/****************************************************************************
 * This code was written by Tyler Akins and has been placed in the
 * public domain.  It would be nice if you left this header intact.
 * Base64 code from Tyler Akins -- http://rumkin.com
 ****************************************************************************/

/****************************************************************************
 * Modofied by Subrata Mazumdar (mazum@avaya.com) to handle binary data.
 * Note: For string data, use btoa() and atob() to encode to baes64
 * and decode form base64 respectively. btoa() and atob() are 
 * Mozilla specific.
 ****************************************************************************/


var keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

function Base64_encodeToBase64ByFilePath(/* string */ inputFilePath)
{
}

function Base64_encodeToBase64ByFile(/* nsIFile */ inputFile)
{
}

/* string */
function Base64_encodeToBase64(/* Array */ inputData)
{
   var output = "";
   var chr1, chr2, chr3;
   var enc1, enc2, enc3, enc4;
   var i = 0;
   var lineCnt = 0;

   do {
      chr1 = inputData[i++];
      chr2 = inputData[i++];
      chr3 = inputData[i++];

      enc1 = chr1 >> 2;
      enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
      enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
      enc4 = chr3 & 63;

      if (isNaN(chr2)) {
         enc3 = enc4 = 64;
      } else if (isNaN(chr3)) {
         enc4 = 64;
      }

      output = output + keyStr.charAt(enc1) + keyStr.charAt(enc2) + 
         keyStr.charAt(enc3) + keyStr.charAt(enc4);
   } while (i < inputData.length);
   
   // Add the line  break;
   var lineSize = 64;
   var lineCnt = (output.length / lineSize) + 1;
   var outputStr = "";
   for (var i = 0; i < lineCnt; i++) {
	if (i > 0) {
      	    outputStr += "\n";
	}
   	outputStr += output.substr((i * lineSize), lineSize);
   }
   return outputStr;
}

/* Array */
function Base64_decodeFromBase64(/* string */ input) {
   var output = [];
   var chr1, chr2, chr3;
   var enc1, enc2, enc3, enc4;
   var i = 0;
   var j = 0;

   // remove all characters that are not A-Z, a-z, 0-9, +, /, or =
   input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

   do {
      enc1 = keyStr.indexOf(input.charAt(i++));
      enc2 = keyStr.indexOf(input.charAt(i++));
      enc3 = keyStr.indexOf(input.charAt(i++));
      enc4 = keyStr.indexOf(input.charAt(i++));

      chr1 = (enc1 << 2) | (enc2 >> 4);
      chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
      chr3 = ((enc3 & 3) << 6) | enc4;

      // output[j++] = String.fromCharCode(chr1);
      output[j++] = chr1;

      if (enc3 != 64) {
         // output[j++] = String.fromCharCode(chr2);
         output[j++] = chr2;
      }
      if (enc4 != 64) {
         // output[j++] = String.fromCharCode(chr3);
         output[j++] = chr3;
      }
   } while (i < input.length);

   return output;
}
