/* @(#) $Id: samlAttributeEdit.js,v 1.5 2008/03/25 02:56:18 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */



var gAttrProfileRowElem;
var gAttrProfileMenuElem;
var gAttrNameMenuElem;
var gAttrNameElem;
var gAttrNamespaceMenuElem;
var gAttrValueElem;

var gAttrParamChanged = false;
var gParams = null;
var isAddCmd = false;

function onLoadSamlAttributeEditDialog()
{

    dump("onLoadSamlAttributeEditDialog():...................Start.\n");

    var attrCmd = "Add";
    var attrName = null;
    var attrNamespace = null;
    var attrValue = null;

    var argCnt = 0;
    if (window.arguments && window.arguments[0]) {
        gParams = window.arguments[0].QueryInterface(Components.interfaces.nsIDialogParamBlock);

	argCnt = gParams.GetInt(0);

        attrCmd = gParams.GetString(0);
    }
    dump("onLoadSamlAttributeEditDialog(): attrCmd: " + attrCmd + "\n");

    gAttrProfileRowElem = document.getElementById("samltoken.attribute.modify.form.profile.row");
    gAttrProfileMenuElem = document.getElementById("samltoken.attribute.modify.form.profile.menu");
    gAttrNameMenuElem = document.getElementById("samltoken.attribute.modify.form.name.menu");
    gAttrNameElem = document.getElementById("samltoken.attribute.modify.form.name");
    gAttrNamespaceMenuElem = document.getElementById("samltoken.attribute.modify.form.namespcae.menu");
    gAttrValueElem = document.getElementById("samltoken.attribute.modify.form.value");
    if (attrCmd == "Edit") {
	isAddCmd = false; // Edit value

        attrName = gParams.GetString(1);
        attrValue = gParams.GetString(2);
        // attrNamespace = gParams.GetString(3);
    	dump("onLoadSamlAttributeEditDialog(): attrName: " + attrName + "\n");
    	dump("onLoadSamlAttributeEditDialog(): attrNamespace: " + attrNamespace + "\n");
    	dump("onLoadSamlAttributeEditDialog(): attrValue: " + attrValue + "\n");
	
	gAttrProfileRowElem.hidden = true;

	/*
    	gAttrNameMenuElem.value = attrName;
	gAttrNameMenuElem.editable = false;
	gAttrNameMenuElem.readonly = true;
	gAttrNameMenuElem.disabled = true;
	*/
	gAttrNameMenuElem.hidden = true;
	gAttrNameElem.hidden = false;
    	gAttrNameElem.setAttribute("value", attrName);
    }
    else {
	isAddCmd = true;

        var samlVersion = gParams.GetString(1);
        var samlAttributeProfile = gParams.GetString(2);
    	dump("onLoadSamlAttributeEditDialog(): samlVersion: " + samlVersion + "\n");
    	dump("onLoadSamlAttributeEditDialog(): samlAttributeProfile: " + samlAttributeProfile + "\n");

	gAttrProfileMenuElem.value = samlAttributeProfile;
    	handleAttributeProfileChange(gAttrProfileMenuElem);
	gAttrProfileMenuElem.disabled = true;
	gAttrProfileRowElem.hidden = false;

	gAttrNameMenuElem.hidden = false;
	gAttrNameElem.hidden = true;
    }

    if (attrNamespace) {
    	gAttrNamespaceMenuElem.value = attrNamespace;
    }
    if (attrValue) {
    	gAttrValueElem.value = attrValue;
    }

    gAttrParamChanged = false;

    dump("onLoadSamlAttributeEditDialog():...................End.\n");
}

function handleAttributeProfileChange(aProfileMenuElem)
{
    dump("handleAttributeProfileChange():...................Start.\n");
    var profileXmlDoc = aProfileMenuElem.getProfileXmlDoc();
    if (!profileXmlDoc) {
    	return;
    }

    gAttrNameMenuElem.removeAllItems();
    gAttrNameMenuElem.value = "";
    gAttrNameMenuElem.selectedIndex = -1;

    var samlAttributeNameIdList = ["FriendlyName", "Name", "AttributeName"];

    var samlAttribElemList = profileXmlDoc.getElementsByTagName("Attribute");
    if (samlAttribElemList.length <= 0) {
    	samlAttribElemList = profileXmlDoc.getElementsByTagName("saml:Attribute");
    }
    var foundMenuItem = false;
    for (var i = 0; i < samlAttribElemList.length; i++) {
	var samlAttribName = null;

    	var samlAttributeElem = samlAttribElemList.item(i);
	for (var j = 0; j < samlAttributeNameIdList.length; j++) {
	    var samlAttribNameId = samlAttributeNameIdList[j];
	    samlAttribName = samlAttributeElem.getAttribute(samlAttribNameId);
	    if (samlAttribName) {
	    	break;
	    }
	}
	if (!samlAttribName) {
	    continue;
	}

	var menuItemNode = gAttrNameMenuElem.appendItem(samlAttribName, samlAttribName);
	menuItemNode.samlAttributeElem = samlAttributeElem;
    	foundMenuItem = true;
    }
    if (foundMenuItem) {
    	gAttrNameMenuElem.selectedIndex = 0;
    }

    dump("handleAttributeProfileChange():...................End.\n");
}

function handleAttributeNameMenuChange()
{
    gAttrParamChanged = true;
}

function handleAttributeNamesapceMenuChange()
{
    gAttrParamChanged = true;
}

function handleAttributeValueChange()
{
    gAttrParamChanged = true;
}

function acceptSamlAttributeEdit()
{
    dump("acceptSamlAttributeEdit(): attrName: " +  gAttrNameMenuElem.value + "\n");
    dump("acceptSamlAttributeEdit(): attrValue: " + gAttrValueElem.value  + "\n");

    // dump("acceptSamlAttributeEdit(): attrNamespace: " + gAttrNamespaceMenuElem.value + "\n");

    var argCnt = 0;
    if (gAttrProfileRowElem.hidden == false) {
	// if crate a new element
    	var samlAttributeElem = gAttrNameMenuElem.selectedItem.samlAttributeElem;
    	dump("acceptSamlAttributeEdit(): samlAttributeElem: " +  samlAttributeElem + "\n");
	var samlAttribElemDataStr = "";
	if (samlAttributeElem) {
	    var xmlSerializer = new XMLSerializer();
	    samlAttribElemDataStr = xmlSerializer.serializeToString(samlAttributeElem);
	}
    	dump("acceptSamlAttributeEdit(): samlAttribElemDataStr: " +  samlAttribElemDataStr + "\n");
    	gParams.SetString(0, samlAttribElemDataStr); argCnt++;
    	gParams.SetString(1, gAttrValueElem.value); argCnt++;
	gAttrParamChanged = false;
    }
    else {
        if (gAttrParamChanged) {
    	    gParams.SetString(0, gAttrNameMenuElem.value); argCnt++;
    	    gParams.SetString(1, gAttrValueElem.value); argCnt++;
    	    // gParams.SetString(2, gAttrNamespaceMenuElem.value); argCnt++;
        }
    }
    gParams.SetInt(0, argCnt);

    window.close();
}

function cancelSamlAttributeEdit()
{
    gParams.SetInt(0, 0);
    window.close();
}

