/* @(#) $Id: SamlSelfToken.js,v 1.11 2008/04/16 00:19:36 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */



const gXmlDocPreamble = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\" ?>\n";
const gSamlAssertionNS = "urn:oasis:names:tc:SAML:1.0:assertion";
const gAttributeNamespace = "http://schemas.microsoft.com/ws/2005/05/identity";
const gSamlSelfTokenTemplate = 
"<?xml version=\"1.0\" encoding=\"UTF-8\"?> \n" +
"<Assertion xmlns=\"urn:oasis:names:tc:SAML:1.0:assertion\" \n" +
"    xmlns:wsa=\"http://schemas.xmlsoap.org/ws/2004/08/addressing\" \n" +
"    xmlns:wsp=\"http://schemas.xmlsoap.org/ws/2004/09/policy\" \n" +
"    xmlns:xs=\"http://www.w3.org/2001/XMLSchema\" \n" +
"    xmlns:ds=\"http://www.w3.org/2000/09/xmldsig#\" \n" +
"    xmlns:xenc=\"http://www.w3.org/2001/04/xmlenc#\" \n" +
"    xmlns:wsse=\"http://docs.oasis-open.org/wss/2004/xx/oasis-2004xx-wss-soap-message-security-1.1\" \n" +
"    xmlns:tns=\"http://schemas.microsoft.com/ws/2005/05/identity\" \n" +
"    Issuer=\"http://schemas.microsoft.com/ws/2005/05/identity/issuer/self\" \n" +
"    MajorVersion=\"1\" \n" +
"    MinorVersion=\"1\" \n" +
"    > \n" +
"</Assertion> \n" +
"";


var gXmlParser;
var gXmlSerializer;

var /* nsIX509Cert	  */ gCertDB = null;
var /* alrIX509CertDBUtil */ gX509CertDBUtil = null;
var /* alrIXPSignTool	  */ gXmlDSigTool = null;
var /* alrIXPSamlTokenSvc */ gSamlTokenSvc = null;
var /* alrIUUIDGenerator  */ gUUIDGenerator = null;

var gParams = null;

var gTabboxElem;
var gSignTabElem;
var gVerifyTabElem;

var gSignCmdButtonElem;
var gVerifyCmdButtonElem;

function samlSelfToken_initOnLoad()
{
    dump("samlSelfToken_initOnLoad():................Start.\n");

    // samlSelfToken_isSupportedOS();
    xmldsigffext_isSupportedOS();

    gTabboxElem = document.getElementById('xmldsigffext.form.tabbox');

    gSignTabElem = document.getElementById('xmldsigffext.form.tab.sign');
    gVerifyTabElem = document.getElementById('xmldsigffext.form.tab.verify');

    gSignCmdButtonElem = document.getElementById('xmldsigffext.cmd.sign');
    gVerifyCmdButtonElem = document.getElementById('xmldsigffext.cmd.verify');

    dump("samlSelfToken_initOnLoad():................10.\n");

    initSamlSelfTokenHandler();

    try {
    	samlSelfToken_initSignFormXULElems();
    } catch (ex) {
    	dump("samlSelfToken_initOnLoad(): samlSelfToken_initSignFormXULElems() failed - ex - " + ex + "\n");
    }


    samlSelfToken_initParamsOnLoad();

    dump("samlSelfToken_initOnLoad():................End.\n");
}

/*
function samlSelfToken_isSupportedOS()
{
    var isWin = (navigator.userAgent.indexOf("Win") != -1);
    var isLinux = (navigator.userAgent.indexOf("Linux") != -1);
    // var isMac = (navigator.userAgent.indexOf("Mac") != -1);
    if (isWin || isLinux) {
        return true;
    }
    alert("ERROR: WRONG BROWSER USER AGENT (" + navigator.userAgent + ")\n" +
        	"This tool is only supported on Linux_x86-gcc3 and Windows_x86-msvc platforms.");
    return false;
}
*/


var XPILoadErrorMessage = "Make sure that DLLs (shared libraries) from Apache Xerces-C++ and Xalan-C++ are in your PATH (LD_LIBRARY_PATH) environment variable.";

function initSamlSelfTokenHandler()
{
    try {
    	gCertDB = Components.classes["@mozilla.org/security/x509certdb;1"].
			getService(Components.interfaces.nsIX509CertDB);
	gX509CertDBUtil = Components.classes["@avaya.com/pkm/x509certdbutil;1"].
			getService(Components.interfaces.alrIX509CertDBUtil);
    	gXmlDSigTool = Components.classes["@avaya.com/pkm/xmldsigtool;1"].
    			getService(Components.interfaces.alrIXPXmlDSigTool);
    	gSamlTokenSvc = Components.classes["@avaya.com/pkm/samltokensvc;1"].
    			getService(Components.interfaces.alrIXPSamlTokenSvc);
    	gUUIDGenerator = Components.classes["@avaya.com/pkm/uuidgenerator;1"].
    			getService(Components.interfaces.alrIUUIDGenerator);

    } catch (ex) {
    	alert("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool - ex: " + ex + "\n");
    	dump("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool - ex: " + ex + "\n");
	dump(XPILoadErrorMessage + "\n");
	throw ex;
    }
    if (gXmlDSigTool == null) {
    	alert("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool.\n");
    	dump("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool.\n");
	dump(XPILoadErrorMessage + "\n");
    	return;
    }
    dump("initSamlSelfTokenHandler(): uuid: " + gUUIDGenerator.create() + "\n");


    gXmlParser = new DOMParser();
    gXmlSerializer = new XMLSerializer();
}


function samlSelfToken_initParamsOnLoad()
{
    dump("samlSelfToken_initParamsOnLoad():................Start.\n");

    if ((window.arguments == null) || (window.arguments.length == 0)) {
    	return false;
    }

    gParams = window.arguments[0].QueryInterface(Components.interfaces.nsIDialogParamBlock);

    var paramCnt = gParams.GetInt(0);
    if (paramCnt <= 0) {
    	return false;
    }
    var unsignedXMLFilePath = gParams.GetString(0);
    var signedXMLFilePath = gParams.GetString(1);

    xmldsigffext_doOnloadInitSignParam(unsignedXMLFilePath, signedXMLFilePath);

    dump("samlSelfToken_initParamsOnLoad():................End.\n");
    return true;
}


function samlSelfToken_showCreateTokenForm(tabElem)
{
    var signCmdButtonElem = document.getElementById('xmldsigffext.cmd.sign');
    var verifyCmdButtonElem = document.getElementById('xmldsigffext.cmd.verify');

    signCmdButtonElem.hidden = false;
    verifyCmdButtonElem.hidden = true;

    signCmdButtonElem.disabled = false;
}

function samlSelfToken_showCreateAvIdCardForm(tabElem)
{
    samlSelfToken_showCreateTokenForm(tabElem);
    var signCmdButtonElem = document.getElementById('xmldsigffext.cmd.sign');
    signCmdButtonElem.disabled = true;
}

function samlSelfToken_showVerifyTokenForm(tabElem)
{
    var signCmdButtonElem = document.getElementById('xmldsigffext.cmd.sign');
    var verifyCmdButtonElem = document.getElementById('xmldsigffext.cmd.verify');

    signCmdButtonElem.hidden = true;
    verifyCmdButtonElem.hidden = false;
}

function samlSelfToken_create()
{
    var smalTokenFile = samlSelfToken_createSamlTokenToFile();
}


function xmldsigffext_cmdClose()
{
    dump("xmldsigffext_cmdClose():..................Start.\n");
    if (gParams) {
        gParams.SetInt(0, 0);
    }
    window.close();
}

function xmldsigffext_cmdCancel()
{
    dump("xmldsigffext_cmdCancel():..................Start.\n");
    if (gParams) {
        gParams.SetInt(0, 0);
    }
    window.close();
}

