/* @(#) $Id: SamlSelfTokenFormSign.js,v 1.10 2008/01/22 14:24:33 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */



// const PERMS_FILE      = 0644;
// const PERMS_DIRECTORY = 0755;

var gCacheSize = 4;

var gUserSamlTokenVersionGroupElem;
var gSubjectConfirmationElem;
var gSubjectConfirmIncludeProofKeyElem;
var gRecipientCertRowElem;
var gRecipientNickNameMenuListElem;

var gUserCredentialTypeGroupElem;
var gUserCredentialTypePasswordElem;
var gUserCredentialTypeCertElem;

var gUserNameElem;
var gUserPasswordElem;

var gXmlFileSignerCertMenuListElem;

var gXmlSigAlgMenuElem;
var gSamlTokenOutFilePickerElem;


function samlSelfToken_initSignFormXULElems()
{

    dump("samlSelfToken_initSignFormXULElems():................Start.\n");

    gUserSamlTokenVersionGroupElem	= document.getElementById("xmldsigffext.form.saml.token.version.group");

    gSubjectConfirmationElem		= document.getElementById("xmldsigffext.form.saml.token.subject.confirmation.row");
    gSubjectConfirmIncludeProofKeyElem	= document.getElementById("xmldsigffext.form.saml.token.include.proof.key");
    gRecipientCertRowElem		= document.getElementById("xmldsigffext.form.saml.token.recipient.cert.row");
    gRecipientNickNameMenuListElem	= document.getElementById("xmldsigffext.form.saml.token.recipient.nickName.menulist");


    xmldsigffextsig_initSigFormXULElems();

    gUserCredentialTypeGroupElem = gXmlVerifyUserCredentialTypeGroupElem;
    gUserCredentialTypeCertElem = gXmlVerifyCredentialTypeCertElem;
    gUserCredentialTypePasswordElem = gXmlVerifyCredentialTypePasswordElem;
    gUserPasswordElem = gXmlVerifyUserPasswordElem;
    gXmlFileSignerCertMenuListElem = gXmlVerifySignerCertMenuListElem;

    gSamlTokenOutFilePickerElem		= document.getElementById("xmldsigffext.form.saml.token.xmldoc.file.path"); 

    // TestXPath();

    xmldsigffext_enabledSignedInfo(false);
    xmldsigffext_initSAMLTokenForCert();
    /*
    samlSelfToken_handleSamlTokenVersionChange(
    		gUserSamlTokenVersionGroupElem,
		gUserSamlTokenVersionGroupElem.selectedItem
		);
    */

    samlSelfToken_onIncludeProofKeyChange(gSubjectConfirmIncludeProofKeyElem);

    /*
    if (gSubjectConfirmIncludeProofKeyElem.checked) {
    	gUserCredentialTypePasswordElem.disabled = false;
    	gUserCredentialTypeCertElem.disabled = false;
    	gUserCredentialTypeGroupElem.addEventListener("command", samlSelfToken_handleCredentialTypeChange, false);
    	gXmlVerifyUserInfoRowElem.hidden = true;
    }
    */

    dump("samlSelfToken_initSignFormXULElems():................End.\n");
}

function samlSelfToken_doOnloadInitSignParam(/* String */ outXmlFilePath, /* nsIX509 */ aSelectedSignerCert)
{
    dump("samlSelfToken_doOnloadInitSignParam():................Start.\n");

    if (outXmlFilePath) {
    	gSamlTokenOutFilePickerElem.value = outXmlFilePath;
	gSamlTokenOutFilePickerElem.disabled = true;
    }
    if (aSelectedSignerCert) {
    	xmldsigffext_setUserCredential(aSelectedSignerCert);
    }

    dump("samlSelfToken_doOnloadInitSignParam():................End.\n");
}


function samlSelfToken_handleSamlTokenVersionChange(samlVersionGroupElem, selectedItemElem)
{
    dump("samlSelfToken_handleSamlTokenVersionChange():................Start.\n");
    var samlv1AttrPofileMenuElem = document.getElementById("xmldsigffext.form.saml.token.v1attr.profile.menulist");
    var samlv2AttrPofileMenuElem = document.getElementById("xmldsigffext.form.saml.token.v2attr.profile.menulist");

    if (selectedItemElem && (selectedItemElem.value == "samlv1")) {
    	samlv1AttrPofileMenuElem.hidden = false;
    	samlv2AttrPofileMenuElem.hidden = true;
    }
    else {
    	samlv1AttrPofileMenuElem.hidden = true;
    	samlv2AttrPofileMenuElem.hidden = false;
    }

    samlSelfToken_setSamlTokenFilePath();

    dump("samlSelfToken_handleSamlTokenVersionChange():................End.\n");
}

function samlSelfToken_onAttributeProfileChange()
{
}

function samlSelfToken_onIncludeProofKeyChange(includeProofKeyElem)
{
    dump("samlSelfToken_onIncludeProofKeyChange():................Start.\n");

    if (includeProofKeyElem.checked) {
    	gUserCredentialTypePasswordElem.disabled = false;
    	gUserCredentialTypeCertElem.disabled = false;
    	gUserCredentialTypeGroupElem.addEventListener("command", samlSelfToken_handleCredentialTypeChange, false);
    }
    else {
    	gUserCredentialTypePasswordElem.disabled = true;
    	gUserCredentialTypeCertElem.disabled = true;
    	gUserCredentialTypeGroupElem.selectedItem = gUserCredentialTypeCertElem;
    	gUserCredentialTypeGroupElem.removeEventListener("command", samlSelfToken_handleCredentialTypeChange, false);
    }
    xmldsigffext_handleCredentialTypeChange(gUserCredentialTypeGroupElem, gUserCredentialTypeGroupElem.selectedItem);
    gXmlVerifyUserInfoRowElem.hidden = true;

    dump("samlSelfToken_onIncludeProofKeyChange():................End.\n");
}

function samlSelfToken_setSamlTokenFilePath()
{
    // dump("samlSelfToken_setSamlTokenFilePath():................Start.\n");

    var signerName = xmldsigffext_getSignerName();
    dump("samlSelfToken_SignerNickNameMenuListChanged(): signerName: " + signerName + "\n");

    var samlVersion = "2";
    if (gUserSamlTokenVersionGroupElem.selectedItem.value == "samlv1") {
    	samlVersion = "1";
    }
    var signedSamlTokenFileName = signerName + "_SAMLv" + samlVersion + "Token" + ".xml";
    // dump("samlSelfToken_SignerNickNameMenuListChanged(): signedSamlTokenFileName: " + signedSamlTokenFileName + "\n");
    var outSignedXmlFile = samlSelfToken_autoSelectOutSignedFile(signedSamlTokenFileName);

    // dump("samlSelfToken_SignerNickNameMenuListChanged():................End.\n");
}

function samlSelfToken_handleCredentialTypeChange(ev)
{
    dump("samlSelfToken_handleCredentialTypeChange():................Start.\n");


    var selectedItemElem = ev.target;
    if (selectedItemElem.value == "password") {
    	gRecipientCertRowElem.hidden = false;
    }
    else {
    	gRecipientCertRowElem.hidden = true;
    }

    gXmlVerifyUserInfoRowElem.hidden = true;
    dump("samlSelfToken_handleCredentialTypeChange():................End.\n");
}

function samlSelfToken_RecipientNickNameMenuListChanged(certPickerElem, selectedMenuItemElem)
{
    dump("samlSelfToken_RecipientNickNameMenuListChanged():................Start/End.\n");
}

function xmldsigffext_addSignerMenuListEventListener(signerMenuListEventHandler)
{
    gXmlFileSignerCertMenuListElem.addEventListener('command', signerMenuListEventHandler, false);
}


function samlSelfToken_autoSelectOutSignedFile(outFileName)
{
    var outSignedFileName = outFileName;
    if (!outSignedFileName) {
    	outSignedFileName = "SignedSamlToken.xml";
    }
    return xmldsigffext_autoSelectOutFile(gSamlTokenOutFilePickerElem, outSignedFileName);
}

/* nsIDOMDocument */
function samlSelfToken_signXMLDoc(/* nsIDOMDocument */ xmlDoc)
{
    var signedXmlDoc = null;


    var /* nsIPersistentProperties */ xmlSignatureProps = getSignatureFormProperties("xmldsigffext.form.tabpanel.sign.overlay");

    if (gUserCredentialTypeGroupElem.selectedItem.value == "certificate") {
    	signedXmlDoc = samlSelfToken_signXMLDocWithCert(xmlDoc, xmlSignatureProps);
    }
    else if (gUserCredentialTypeGroupElem.selectedItem.value == "password") {
    	signedXmlDoc = samlSelfToken_signXMLDocWithSharedKey(xmlDoc, xmlSignatureProps);
    }
    else {
    	signedXmlDoc = null;
    }

    return signedXmlDoc;
}

/* nsIDOMDocument  */
function samlSelfToken_signXMLDocWithSharedKey(/* nsIDOMDocument  */ xmlDoc, /* nsIPersistentProperties */ xmlSignatureProps)
{
    dump("samlSelfToken_signXMLDocWithSharedKey():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
    var sharedKey = gUserPasswordElem.value;
    if (sharedKey.length == 0) {
    	alert("samlSelfToken_signXMLDocWithSharedKey(): shared key is missing.\n");
    	dump("samlSelfToken_signXMLDocWithSharedKey(): shared key is missing.\n");
    	return null;
    }

    var outSignedXmlDoc = null;
    try {
    	outSignedXmlDoc = gXmlDSigTool.signXMLDocBySharedKey(xmlDoc, xmlSignatureProps);
    } catch (ex) {
    	// alert("xmldsigffext_signXMLFileWithSharedKey(): failed to create signed XML file - ex : " + ex + "\n");
    	dump("samlSelfToken_signXMLDocWithSharedKey(): failed to create signed XML file - ex : " + ex + "\n");
	throw ex;
    }

    dump("samlSelfToken_signXMLDocWithSharedKey():................End.\n");

    return outSignedXmlDoc;
}


/* nsIDOMDocument  */
function samlSelfToken_signXMLDocWithCert(/* nsIDOMDocument  */ xmlDoc, /* nsIPersistentProperties */ xmlSignatureProps)
{
    dump("samlSelfToken_signXMLDocWithCert():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var /* nsIX509Cert */ signerCert;
    signerCert = xmldsigffext_getSelectedSignerCert();
    if (signerCert == null) {
    	dump("samlSelfToken_signXMLDocWithCert(): null signerCert.\n");
    	return null;
    }


    var outSignedXmlDoc = null;
    try {
    	// Force token login - on windows the popup window for password is not coming up
    	xmldsigffext_loginToCertToken(signerCert);
    	// outSignedXmlDoc = gXmlDSigTool.signXMLDocByX509Cert(xmlDoc, signerCert, xmlSignatureProps);
    	outSignedXmlDoc = gSamlTokenSvc.signSAMLTokenWithX509Cert(xmlDoc, signerCert, xmlSignatureProps);
    } catch (ex) {
    	alert("samlSelfToken_signXMLDocWithCert(): failed to sign XML file - ex : " + ex + "\n");
    	dump("samlSelfToken_signXMLDocWithCert(): failed to sign XML file - ex : " + ex + "\n");
	throw ex;
    }

    dump("samlSelfToken_signXMLDocWithCert():................End.\n");

    return outSignedXmlDoc;
}

function uuidGen()
{
    var uuid = "uuid-08301dba-d8d5-462f-85db-dec08c5e4e17";
    return uuid;
}

function getTimeStamp()
{
    var timeStamp = "2004-10-06T16:44:20.00Z";
    return timeStamp;
}



function samlSelfToken_createSamlTokenWithCert(attrProfile)
{
}

function samlSelfToken_createSamlv1TokenWithCert(attrProfile)
{
    // var xmlDoc = document.implementation.createDocument("", "test", null); 

    var selectedCert = xmldsigffext_getSelectedSignerCert();
    if (!selectedCert) {
	alert("samlSelfToken_createSamlv1TokenWithCert(): No user cert is selected.");
    	return null;
    }

    var samlSelfTokenXmlDoc = gXmlParser.parseFromString(gSamlSelfTokenTemplate, "text/xml");
    var samlSelfTokenXmlDoc = gSamlTokenSvc.createSelfIssuedSAMLv1Token(selectedCert, attrProfile);
    return samlSelfTokenXmlDoc;
}

function samlSelfToken_createSamlv2TokenWithCert(attrProfile)
{
}

function samlSelfToken_addAttribute(xmlDoc, attrName, attrValue)
{

    var attrElem = xmlDoc.createElementNS(
    				gSamlAssertionNS,
				"Attribute"
				);
        attrElem.setAttributeNS(gSamlAssertionNS, "AttributeName", attrName);
        attrElem.setAttributeNS(gSamlAssertionNS, "AttributeNamespace", gAttributeNamespace);

    	attrElem.appendChild(xmlDoc.createTextNode("\n            "));
        var attrValueElem = xmlDoc.createElementNS(
    				gSamlAssertionNS,
				"AttributeValue"
				);
    	    attrValueElem.appendChild(xmlDoc.createTextNode(attrValue));
        attrElem.appendChild(attrValueElem);
    	attrElem.appendChild(xmlDoc.createTextNode("\n        "));
    return attrElem;
}

function samlSelfToken_createSamlTokenToXmlDoc()
{
    var samlTokenDoc = null;
    if (gXmlVerifyUserCredentialTypeGroupElem.selectedItem.value == "certificate") {
    	samlTokenDoc = samlSelfToken_createSamlTokenWithCertToXmlDoc();
    }
    else {
    	samlTokenDoc = samlSelfToken_createSamlTokenWithSharedKeyToXmlDoc();
    }
    return samlTokenDoc;
}

/* nsIDOMDocument  */
function samlSelfToken_createSamlTokenWithSharedKeyToXmlDoc()
{
    var samlTokenDoc = null;
    return samlTokenDoc;
}

/* nsIDOMDocument  */
function samlSelfToken_createSamlTokenWithCertToXmlDoc()
{
    dump("samlSelfToken_createSamlTokenWithCertToXmlDoc():................Start.\n");

    var /* nsIX509Cert */ signerCert = xmldsigffext_getSelectedSignerCert();
    if (!signerCert) {
	alert("No user cert is selected.");
    	return null;
    }
    xmldsigffext_loginToCertToken(signerCert);

    /*
    attrProfile = alrIXPSamlTokenSvc::AttrProfile_samlv1;
    attrProfile = alrIXPSamlTokenSvc::AttrProfile_samlv2Basic;
    attrProfile = alrIXPSamlTokenSvc::AttrProfile_samlv2X500;
    attrProfile = alrIXPSamlTokenSvc::AttrProfile_infoCard;
    */

    var attrProfile = Components.interfaces.alrIXPSamlTokenSvc.AttrProfile_samlv1;
    var samlSelfTokenXmlDoc = null;
    try {
    if (gUserSamlTokenVersionGroupElem.selectedItem.value == "samlv1") {
    	var samlv1AttrPofileMenuElem = document.getElementById("xmldsigffext.form.saml.token.v1attr.profile.menulist");
	if (samlv1AttrPofileMenuElem.value == "samlv1") {
    	    attrProfile = Components.interfaces.alrIXPSamlTokenSvc.AttrProfile_samlv1;
	}
	else {
    	    attrProfile = Components.interfaces.alrIXPSamlTokenSvc.AttrProfile_infoCard;
	}
    	dump("samlSelfToken_createSamlTokenWithCertToXmlDoc(): attrProfile: " + attrProfile + "\n");
    	samlSelfTokenXmlDoc = gSamlTokenSvc.createSelfIssuedSAMLv1Token(signerCert, attrProfile);
    }
    else if (gUserSamlTokenVersionGroupElem.selectedItem.value == "samlv2") {
    	var samlv2AttrPofileMenuElem = document.getElementById("xmldsigffext.form.saml.token.v2attr.profile.menulist");
	if (samlv2AttrPofileMenuElem.value == "samlv2Basic") {
    	    attrProfile = Components.interfaces.alrIXPSamlTokenSvc.AttrProfile_samlv2Basic;
	}
	else {
    	    attrProfile = Components.interfaces.alrIXPSamlTokenSvc.AttrProfile_samlv2X500;
	}
    	dump("samlSelfToken_createSamlTokenWithCertToXmlDoc(): attrProfile: " + attrProfile + "\n");
    	samlSelfTokenXmlDoc = gSamlTokenSvc.createSelfIssuedSAMLv2Token(signerCert, attrProfile);
    }
    else {
	dump("Unknown Saml Token Version: " + gUserSamlTokenVersionGroupElem.value + "\n");
    }
    } catch (ex) {
	alert("Failed to create XML doc for SAML Token - ex: " + ex);
	samlSelfTokenXmlDoc = null;
    }
    if (!samlSelfTokenXmlDoc) {
	alert("Failed to create XML doc for SAML Token.");
	dump("Failed to create XML doc for SAML Token.\n");
    	return null;
    }

    var assertionElem = samlSelfTokenXmlDoc.documentElement;

    dump("samlSelfToken_createSamlTokenWithCertToXmlDoc():................10.\n");

    /*
    var assertionID = uuidGen(); 
    assertionElem.setAttributeNS (
			gSamlAssertionNS,
                        "AssertionID",
                        assertionID
		    );
    var issueInstant = getTimeStamp(); 
    assertionElem.setAttributeNS (
			gSamlAssertionNS,
                        "IssueInstant",
                        issueInstant
                        );
    var condBefore = "xxx";
    var condOnOrAfter = "xxx";
    var conditionsElem = samlSelfTokenXmlDoc.createElementNS(
    				gSamlAssertionNS,
				"Conditions"
				);
        assertionElem.appendChild(samlSelfTokenXmlDoc.createTextNode("\n    "));
        assertionElem.appendChild(conditionsElem);
    var attrStmtElem = samlSelfTokenXmlDoc.createElementNS(
    				gSamlAssertionNS,
				"AttributeStatement"
				);
        assertionElem.appendChild(samlSelfTokenXmlDoc.createTextNode("\n    "));
        assertionElem.appendChild(attrStmtElem);
        var attrStmtSubjElem = samlSelfTokenXmlDoc.createElementNS(
    				gSamlAssertionNS,
				"Subject"
				);
            assertionElem.appendChild(samlSelfTokenXmlDoc.createTextNode("\n        "));
            attrStmtElem.appendChild(attrStmtSubjElem);

    dump("samlSelfToken_createSamlTokenToXmlDoc():................20.\n");

    var privatPersonalIdentifier = uuidGen();
    var givenName = "Subrata";
    var emailAddress = "abc@xyz.com";

    var attrElem = null;
    attrElem = samlSelfToken_addAttribute(samlSelfTokenXmlDoc, "privatpersonalidentifier", privatPersonalIdentifier);
    attrStmtElem.appendChild(samlSelfTokenXmlDoc.createTextNode("\n        "));
    attrStmtElem.appendChild(attrElem);

    attrElem = samlSelfToken_addAttribute(samlSelfTokenXmlDoc, "givenname", givenName);
    attrStmtElem.appendChild(samlSelfTokenXmlDoc.createTextNode("\n        "));
    attrStmtElem.appendChild(attrElem);

    attrElem = samlSelfToken_addAttribute(samlSelfTokenXmlDoc, "emailaddress", emailAddress);
    attrStmtElem.appendChild(samlSelfTokenXmlDoc.createTextNode("\n        "));
    attrStmtElem.appendChild(attrElem);

    assertionElem.appendChild(samlSelfTokenXmlDoc.createTextNode("\n"));
    */

    var /* nsIDOMDocument  */ signedSamlTokenXmlDoc = samlSelfToken_signXMLDoc(samlSelfTokenXmlDoc);
    if (signedSamlTokenXmlDoc == null) {
	alert("samlSelfToken_signXMLDoc() failed for SAML token.");
	dump("samlSelfToken_signXMLDoc() failed for SAML token.\n");
    	return null;
    }

    dump("samlSelfToken_createSamlTokenWithCertToXmlDoc():.........................End.\n");

    return signedSamlTokenXmlDoc;

}


function samlSelfToken_createSamlTokenToFile()
{
    dump("samlSelfToken_createSamlTokenToFile():.........................Start.\n");

    var /* nsIDOMDocument  */ signedSamlTokenXmlDoc = samlSelfToken_createSamlTokenToXmlDoc();

    if (!signedSamlTokenXmlDoc) {
	alert("Failed to create SAML Token.\n");
	dump("samlSelfToken_createSamlTokenToFile(): Failed to create SAML Token.\n");
    	return null;
    }

    var signerName = xmldsigffext_getSignerName();
    var /* nsILocalFile */ outSAMLTokenFile = null;
    if (gSamlTokenOutFilePickerElem.value == "") {
    	samlSelfToken_setSamlTokenFilePath();
    }
    outSAMLTokenFile = gSamlTokenOutFilePickerElem.file;
    if (outSAMLTokenFile == null) {
    	dump("samlSelfToken_createSamlTokenToFile(): failed to get outSAMLTokenFile.\n");
    	// alert("samlSelfToken_create(): failed to get outSAMLTokenFile.\n");
        return null;
    }
    dump("samlSelfToken_createSamlTokenToFile(): outSAMLTokenFile: " + outSAMLTokenFile.path + "\n");



    var signedSamlTokenXmlDataStr = gXmlSerializer.serializeToString(signedSamlTokenXmlDoc);

    dump("samlSelfToken_createSamlTokenToFile():.........................40.\n");

    gSamlTokenOutFilePickerElem.saveFile(signedSamlTokenXmlDataStr);
    gSamlTokenOutFilePickerElem.refresh();

    outSAMLTokenFile = gSamlTokenOutFilePickerElem.file;
    if (!outSAMLTokenFile.exists() || (outSAMLTokenFile.fileSize <= 0)) {
    	dump("samlSelfToken_createSamlTokenToFile(): failed to create Signed XML file.\n");
    	alert("samlSelfToken_createSamlTokenToFile(): failed to create Signed XML file.\n");
	return null;
    }

    alert("samlSelfToken_createSamlTokenToFile(): Successfully created the and saved SAML token.\n");

    dump("samlSelfToken_createSamlTokenToFile():................End.\n");
    return outSAMLTokenFile;
}



/*
    Source: http://developer.mozilla.org/en/docs/Using_XPath
            http://www-xray.ast.cam.ac.uk/~jgraham/mozilla/xpath-tutorial.html
*/

// Evaluate an XPath expression aExpression against a given DOM node
// or Document object (aNode), returning the results as an array
// thanks wanderingstan at morethanwarm dot mail dot com for the
// initial work.
function evaluateXPath(aNode, aExpr) {

    var xpe = new XPathEvaluator();
    var nsResolver = xpe.createNSResolver(aNode.ownerDocument == null ?
        aNode.documentElement : aNode.ownerDocument.documentElement);

    dump("evaluateXPath(): nsResolver: " + nsResolver + "\n");

    var found = [];
    var result = null;
    try {
    	result = xpe.evaluate(aExpr, aNode, nsResolver, 0, null);
    } catch(ex) {
    	dump("evaluateXPath(): xpe.evaluate() failed - ex: " + ex + "\n");
    }
    dump("evaluateXPath(): result: " + result + "\n");
    if (!result) {
    	return found;
    }

    var res;
    while (res = result.iterateNext()) {
    	dump("evaluateXPath(): res: " + res + "\n");
	found.push(res);
    }
    return found;
}

function TestXPath()
{
    var xpathExpr = "//saml:Attribute[@FriendlyName='commonName']";
    TestXPathExpr(xpathExpr);
}


function TestXPathExpr(xpathExpr)
{
    dump("TestXPath():............................Start.\n");
    dump("TestXPath():xpathExpr: " + xpathExpr + "\n");

    var xmlDocURI = "chrome://xmldsigffext/content/SamlAttributeX500Profile.xml";

    var xmlDoc = gXmlDSigTool.readXMLDocFromURIPath(xmlDocURI);
    if (!xmlDoc) {
    	dump("TestXPath(): gXmlDSigTool.readXMLDocFromURIPath() failed \n");
	return;
    }
    dump("TestXPath():xmlDoc.documentElement: " + xmlDoc.documentElement.tagName + "\n");

    var /* Object[] */ foundObjList = evaluateXPath(xmlDoc, xpathExpr);
    dump("TestXPath():foundObjList: " + foundObjList + "\n");
    if (!foundObjList || foundObjList.length <= 0) {
    	dump("TestXPath(): evaluateXPath() failed. \n");
	return;
    }
    var attrElem = foundObjList[0];
    var attrElemStr = gXmlSerializer.serializeToString(attrElem);

    dump("TestXPath(): attrElemStr: \n" + attrElemStr + "\n");

    dump("TestXPath():............................End.\n");
}

function samlSelfToken_testXPathExpr(xpathExprElemId)
{
    var xpathExprElem = document.getElementById(xpathExprElemId); 
    TestXPathExpr(xpathExprElem.value);
}

