/* @(#) $Id: XmlDSigToolForm.js,v 1.10 2008/04/16 00:19:36 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


var gParams = null;

var gTabboxElem;
var gSignTabElem;
var gVerifyTabElem;

var gSignCmdButtonElem;
var gVerifyCmdButtonElem;

var gXmlParser;
var gXmlSerializer;

var /* nsIX509Cert	  */ gCertDB = null;
var /* alrIX509CertDBUtil */ gX509CertDBUtil = null;
var /* alrIXPSignTool	  */ gXmlDSigTool = null;
var /* alrIXPSamlTokenSvc */ gSamlTokenSvc = null;

function xmldsigffext_initOnLoad()
{
    dump("xmldsigffext_initOnLoad():................Start.\n");

    xmldsigffext_isSupportedOS();

    try {
    	gCertDB = Components.classes["@mozilla.org/security/x509certdb;1"].
			getService(Components.interfaces.nsIX509CertDB);
	gX509CertDBUtil = Components.classes["@avaya.com/pkm/x509certdbutil;1"].
			getService(Components.interfaces.alrIX509CertDBUtil);
    	gXmlDSigTool = Components.classes["@avaya.com/pkm/xmldsigtool;1"].
    			getService(Components.interfaces.alrIXPXmlDSigTool);
    	gSamlTokenSvc = Components.classes["@avaya.com/pkm/samltokensvc;1"].
    			getService(Components.interfaces.alrIXPSamlTokenSvc);

    } catch (ex) {
    	alert("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool - ex: " + ex + "\n");
    	dump("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool - ex: " + ex + "\n");
	throw ex;
    }
    if (gXmlDSigTool == null) {
    	alert("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool.\n");
    	dump("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool.\n");
    	return;
    }

    gXmlParser = new DOMParser();
    gXmlSerializer = new XMLSerializer();

    gTabboxElem = document.getElementById('xmldsigffext.form.tabbox');
    gSignTabElem = document.getElementById('xmldsigffext.form.tab.sign');
    gVerifyTabElem = document.getElementById('xmldsigffext.form.tab.verify');

    gSignCmdButtonElem = document.getElementById('xmldsigffext.cmd.sign');
    gVerifyCmdButtonElem = document.getElementById('xmldsigffext.cmd.verify');

    try {
    	// xmldsigffext_initSignFormXULElems();

    	xmldsigffext_initVerifyFormXULElems();

	// xmldsigffext_displaySignTab();
	xmldsigffext_displayVerifyTab();

    } catch (ex) {
    	dump("xmldsigffext_initOnLoad(): ex - " + ex + "\n");
    }

    xmldsigffext_initParamsOnLoad();

    dump("xmldsigffext_initOnLoad():................End.\n");
}

/*
function xmldsigffext_isSupportedOS()
{
    var isWin = (navigator.userAgent.indexOf("Win") != -1);
    var isLinux = (navigator.userAgent.indexOf("Linux") != -1);
    // var isMac = (navigator.userAgent.indexOf("Mac") != -1);
    if (isWin || isLinux) {
        return true;
    }
    alert("ERROR: WRONG BROWSER USER AGENT (" + navigator.userAgent + ")\n" +
        	"This tool is only supported on Linux_x86-gcc3 and Windows_x86-msvc platforms.");
    return false;
}
*/

function xmldsigffext_initParamsOnLoad()
{
    dump("xmldsigffext_initParamsOnLoad():................Start.\n");

    if ((window.arguments == null) || (window.arguments.length == 0)) {
    	return false;
    }

    gParams = window.arguments[0].QueryInterface(Components.interfaces.nsIDialogParamBlock);

    var paramCnt = gParams.GetInt(0);
    if (paramCnt <= 0) {
    	return false;
    }
    var unsignedXMLFilePath = gParams.GetString(0);
    var signedXMLFilePath = gParams.GetString(1);

    dump("unsignedXMLFilePath: " + unsignedXMLFilePath + " " + 
    		"signedXMLFilePath: " + signedXMLFilePath + " " + 
		"\n");

    xmldsigffext_doOnloadInitSignParam(unsignedXMLFilePath, signedXMLFilePath);

    dump("xmldsigffext_initParamsOnLoad():................End.\n");
    return true;
}


function xmldsigffext_showSignForm()
{
    gSignCmdButtonElem.hidden = false;
    gVerifyCmdButtonElem.hidden = true;
}

function xmldsigffext_showVerifyForm()
{
    gSignCmdButtonElem.hidden = true;
    gVerifyCmdButtonElem.hidden = false;
}

function xmldsigffext_displayTab(tabElemId)
{
    dump("xmldsigffext_displayTab():................Start.\n");

    var tabElem = document.getElementById(tabElemId);
    gTabboxElem.selectedTab = tabElem;

    dump("xmldsigffext_displayTab():................End.\n");
}

function xmldsigffext_displaySignTab()
{
    xmldsigffext_displayTab("xmldsigffext.form.tab.sign");
    xmldsigffext_showSignForm();
}

function xmldsigffext_displayVerifyTab()
{
    dump("xmldsigffext_displayVerifyTab():................Start.\n");

    xmldsigffext_displayTab("xmldsigffext.form.tab.verify");
    xmldsigffext_showVerifyForm();

    dump("xmldsigffext_displayVerifyTab():................End.\n");
}

/*
function attrcert_displayAdvancedTabs(show)
{
    // dump("attrcert_displayAdvancedTabs():................Start.\n");

    var attrCertFormTabAttrElem = document.getElementById('xmldsigffext.form.tab.attribute');
    var attrCertFormTabExtElem = document.getElementById('xmldsigffext.form.tab.extension');

    if (show == false) {
	attrCertFormTabAttrElem.hidden = true;
	attrCertFormTabExtElem.hidden = true;
    }
    else {
	attrCertFormTabAttrElem.removeAttribute("hidden");
	// attrCertFormTabAttrElem.hidden = false;

	attrCertFormTabExtElem.removeAttribute("hidden");
	// attrCertFormTabExtElem.hidden = false;
    }

    // xmldsigffext_selectBasicFormTab();

    // dump("attrcert_displayAdvancedTabs():................End.\n");
}

function xmldsigffext_selectBasicFormTab()
{
    // Select the Basic tab
    var attrCertSignerTabboxElem = document.getElementById('xmldsigffext.form.tabbox');
    var attrCertBasicTabElem = document.getElementById('xmldsigffext.form.tab.basic');

    attrCertSignerTabboxElem.selectedTab = attrCertBasicTabElem;
}

function xmldsigffext_showAdvancedTabs()
{
    attrcert_displayAdvancedTabs(true);
}

function xmldsigffext_hideAdvancedTabs()
{
    attrcert_displayAdvancedTabs(false);
}


function xmldsigffext_showBasicForm()
{
    // dump("xmldsigffext_showBasicForm():..................Start.\n");

    // Hide the  cert related Tabs
    xmldsigffext_hideAdvancedTabs();

    // Show the basic tab
    var attrCertFormTabCmdBasicElem = document.getElementById('xmldsigffext.form.tab.cmd.basic');
    attrCertFormTabCmdBasicElem.hidden = true;

    // Hide the Advanced tab
    var attrCertFormTabCmdAdvancedElem = document.getElementById('xmldsigffext.form.tab.cmd.advanced');
    attrCertFormTabCmdAdvancedElem.hidden = false;

    xmldsigffext_selectBasicFormTab();

    // dump("xmldsigffext_showBasicForm():..................End.\n");
}

function xmldsigffext_showAdvancedForm()
{
    // dump("xmldsigffext_showAdvancedForm():..................Start.\n");

    // Hide the basic tab
    var attrCertFormTabCmdBasicElem = document.getElementById('xmldsigffext.form.tab.cmd.basic');
    attrCertFormTabCmdBasicElem.hidden = false;

    // Show the Advanced tab
    var attrCertFormTabCmdAdvancedElem = document.getElementById('xmldsigffext.form.tab.cmd.advanced');
    attrCertFormTabCmdAdvancedElem.hidden = true;

    // Show the cert related Tabs
    xmldsigffext_showAdvancedTabs();

    xmldsigffext_selectBasicFormTab();

    // dump("xmldsigffext_showAdvancedForm():..................End.\n");
}
*/

function xmldsigffext_enableForVerify()
{
    xmldsigffext_showVerifyForm();
}


function xmldsigffext_enableForSign()
{
    xmldsigffext_showSignForm();
}

function xmldsigffext_enableForResign()
{
    xmldsigffext_showSignForm();
}

function xmldsigffext_cmdVerify()
{
    dump("xmldsigffext_cmdVerify():..................Start.\n");
    if (gParams) {
	// Falure by default
        gParams.SetInt(0, 0);
    }

    var isPassed = false;
    try {
    	isPassed = xmldsigffext_verifySignedXMLDoc("xmldsigffext.form.tabpanel.verify");
    	// xmldsigffext_verifySignedXMLFile("xmldsigffext.form.tabpanel.verify");
    } catch (ex) {
    	dump("xmldsigffext_cmdVerify(): failed to verify signed XML file - ex : " + ex + "\n");
	return;
    }
    if (isPassed) {
    	alert("xmldsigffext_cmdVerify(): successfully verified the signed XML.\n");
    }
    else {
    	alert("xmldsigffext_cmdVerify(): failed to verify the signed XML.\n");
    }

    if (gParams) {
	// Set success 
        gParams.SetInt(0, 1);
    	window.close();
    }
    dump("xmldsigffext_cmdVerify():..................End.\n");
}

function xmldsigffext_cmdSign()
{
    dump("xmldsigffext_cmdSign():..................Start.\n");
    if (gParams) {
	// Falure by default
        gParams.SetInt(0, 0);
    }

    var signedFile = null;
    try {
    	signedFile = xmldsigffext_signXMLDocToFile("xmldsigffext.form.tabpanel.verify");
    	// signedFile = xmldsigffext_signXMLFile("xmldsigffext.form.tabpanel.verify");
    } catch (ex) {
    	dump("xmldsigffext_cmdSign(): failed to create signed XML file - ex : " + ex + "\n");
    	alert("xmldsigffext_cmdSign(): failed to create signed XML file - ex : " + ex + "\n");
	return;
    }
    if (!signedFile) {
    	dump("xmldsigffext_cmdSign(): failed to create signed XML file\n");
    	alert("xmldsigffext_cmdSign(): failed to create signed XML file\n");
	return;
    }
    alert("xmldsigffext_cmdSign(): Successfully created the signed XML.\n");
    if (gParams) {
	// Set success 
        gParams.SetInt(0, 1);
    	window.close();
    }
    dump("xmldsigffext_cmdSign():..................End.\n");
}

function xmldsigffext_cmdClose()
{
    dump("xmldsigffext_cmdClose():..................Start.\n");
    window.close();
}

function xmldsigffext_cmdCancel()
{
    dump("xmldsigffext_cmdCancel():..................Start.\n");
    if (gParams) {
        gParams.SetInt(0, 0);
    }
    window.close();
}

