/* @(#) $Id: XmlDSigToolFormSignVerify.js,v 1.8 2007/10/02 21:59:02 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */



var gXmlVerifyInputFileIsSignedElem;
var gXmlVerifyInputFilePickerElem;
var gXmlVerifyResignRowElem;
var gXmlVerifyResignElem;

var gXmlVerifySignInfoElem;

var gXmlVerifySignedOutFilePickerRowElem;
var gXmlVerifySignedOutFilePickerElem;

function xmldsigffext_initVerifyFormXULElems()
{
    dump("xmldsigffext_initVerifyFormXULElems():................Start.\n");

    gXmlVerifyInputFilePickerElem	= document.getElementById("xmldsigffext.form.sign.file.in.xmldoc.path");
    gXmlVerifyInputFileIsSignedElem	= document.getElementById("xmldsigffext.form.sign.file.in.xmldoc.issigned");
    gXmlVerifyResignRowElem		= document.getElementById("xmldsigffext.form.sign.resign.row");
    gXmlVerifyResignElem		= document.getElementById("xmldsigffext.form.sign.resign");


    gXmlVerifySignInfoElem		= document.getElementById("xmldsigffext.form.tabpanel.xmlsig.overlay");
    xmldsigffextsig_initSigFormXULElems();

    gXmlVerifySignedOutFilePickerRowElem = document.getElementById("xmldsigffext.form.sign.file.out.xmldoc.row"); 
    gXmlVerifySignedOutFilePickerElem	= document.getElementById("xmldsigffext.form.sign.file.out.xmldoc.path"); 

    gXmlVerifyInputFilePickerElem.addEventListener('command', xmldsigffext_xmlDocFileChangeHandler, false);
    gXmlVerifyInputFilePickerElem.addEventListener('change', xmldsigffext_xmlDocFileChangeHandler, false);

    // gXmlVerifyUserCredentialTypeGroupElem.selectedItem = null;
    // xmldsigffext_xmlDocFileChangeHandler();
    xmldsigffext_initSignVerifySig();

    dump("xmldsigffext_initVerifyFormXULElems():................End.\n");
}

function xmldsigffext_initSignVerifySig()
{
    gXmlVerifySignInfoElem.hidden = true;
}

function xmldsigffext_doOnloadInitSignParam(/* String */ inXmlFilePath, /* String */ outXmlFilePath, /* nsIX509 */ aSelectedSignerCert)
{
    dump("xmldsigffext_doOnloadInitSignParam():................Start.\n");
    // xmldsigffext_initVerifyFormXULElems();

    dump("inXmlFilePath: " + inXmlFilePath + " " + 
    		"outXmlFilePath: " + outXmlFilePath + " " + 
    		"cert: " + (aSelectedSignerCert?aSelectedSignerCert.nickname:"") + " " + 
		"\n");
    if (inXmlFilePath) {
    	gXmlVerifyInputFilePickerElem.value = inXmlFilePath;
	gXmlVerifyInputFilePickerElem.disabled = true;
    }


    xmldsigffext_xmlDocFileChangeHandler(null);
    if (aSelectedSignerCert) {
    	xmldsigffext_setUserCredential(aSelectedSignerCert);
    }

    /*
    if (aSelectedSignerCert) {
	gXmlVerifySignerCertMenuListElem.value = aSelectedSignerCert.nickname;
    	xmldsigffext_SignerNickNameMenuListChanged(
		gXmlVerifySignerCertMenuListElem,
		gXmlVerifySignerCertMenuListElem.selectedItem,
		"xmldsigffext.form.sign.signer"
		);
	// gXmlFileSignerCertMenuListElem.disabled = true;
    }
    */

    if (outXmlFilePath) {
    	gXmlVerifySignedOutFilePickerElem.value = outXmlFilePath;
	gXmlVerifySignedOutFilePickerElem.disabled = true;
    }
    dump("xmldsigffext_doOnloadInitSignParam():................End.\n");
}

function xmldsigffext_setInputXMLFilePath(xmlFilePath)
{
    gXmlVerifyInputFilePickerElem.value = xmlFilePath;
}


function xmldsigffext_xmlDocFileChangeHandler(event)
{
    dump("xmldsigffext_xmlDocFileChangeHandler():................Start.\n");

    gXmlVerifySignInfoElem.hidden = true;

    var signedXmlFile = gXmlVerifyInputFilePickerElem.file;
    if (signedXmlFile == null) {
    	alert("xmldsigffext_xmlDocFileChangeHandler(): signed XML file name is missing.\n");
    	dump("xmldsigffext_xmlDocFileChangeHandler(): signed XML file name is missing.\n");
    	return;
    }
    if (signedXmlFile.fileSize == 0) {
    	alert("xmldsigffext_xmlDocFileChangeHandler(): Zero-length XML file - pick another one.\n");
    	dump("xmldsigffext_xmlDocFileChangeHandler(): Zero-length XML file - pick another one.\n");
    	return;
    }

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var /* nsIDOMDocument */ xmlDoc = gXmlDSigTool.readXMLDocFromFile(signedXmlFile);
    if (!xmlDoc) {
    	alert("xmldsigffext_xmlDocFileChangeHandler(): Not a valid XML file.\n");
    	dump("xmldsigffext_xmlDocFileChangeHandler(): Not a valid XML file.\n");
    	return;
    }
    if (xmlDoc.documentElement.tagName == "parsererror") {
    	alert("xmldsigffext_xmlDocFileChangeHandler(): Parsing of  XML file failed.\n");
    	dump("xmldsigffext_xmlDocFileChangeHandler(): Parsing of  XML file failed.\n");
    	return;
    }
    gXmlVerifyInputFilePickerElem.xmlDoc = xmlDoc;

    // Display the signed info elements
    gXmlVerifySignInfoElem.hidden = false;

    var /* nsINodeList */ xmlDocSigElemList = xmlDoc.getElementsByTagName("Signature");
    if (!xmlDocSigElemList || (xmlDocSigElemList.length == 0)) {
    	xmldsigffext_unsignedXmlDocFileHandler(xmlDoc);
    	gXmlVerifyResignRowElem.hidden = true;
	return;
    }
    xmldsigffext_signedXmlDocFileHandler(xmlDoc);

    dump("xmldsigffext_xmlDocFileChangeHandler():................End.\n");
}


function xmldsigffext_unsignedXmlDocFileHandler(xmlDoc)
{
    dump("xmldsigffext_unsignedXmlDocFileHandler():................Start.\n");

    xmldsigffext_enabledSignedInfo(true);

    gXmlVerifyInputFileIsSignedElem.hidden = true;
    gXmlVerifySignedOutFilePickerRowElem.hidden = false;

    xmldsigffext_enableForSign();

    dump("xmldsigffext_unsignedXmlDocFileHandler():................End.\n");
}

function xmldsigffext_signedXmlDocFileHandler(xmlDoc)
{
    dump("xmldsigffext_signedXmlDocFileHandler():................Start.\n");

    gXmlVerifyResignRowElem.hidden = false;
    gXmlVerifyResignElem.checked = false;
    gXmlVerifyInputFileIsSignedElem.hidden = false;

    var /* nsINodeList */ xmlDocSigElemList = xmlDoc.getElementsByTagName("Signature");
    if (!xmlDocSigElemList || (xmlDocSigElemList.length == 0)) {
    	alert("xmldsigffext_signedXmlDocFileHandler(): Not a valid Signed XML file - no Signature element.\n");
    	dump("xmldsigffext_signedXmlDocFileHandler(): Not a valid Signed XML file - no Signature element.\n");
    	return;
    }
    var xmlDocSigElem = xmlDocSigElemList.item(0);

    xmldsigffextsig_signedXmlDocFileHandler(xmlDoc);

    xmldsigffext_enableForVerify();
    gXmlVerifySignedOutFilePickerRowElem.hidden = true;
    dump("xmldsigffext_signedXmlDocFileHandler():................End.\n");
}

function xmldsigffext_handleRemoveSignature(removeSigCheckBoxElem)
{
    if (removeSigCheckBoxElem.checked) {
	var xmlDoc = xmldsigffext_removeXMLDocSignature(gXmlVerifyInputFilePickerElem.xmlDoc);
	gXmlVerifyInputFilePickerElem.xmlDoc = xmlDoc;
	gXmlVerifySignedOutFilePickerElem.value = "";
    	// xmldsigffext_enabledSignedInfo(true);
	xmldsigffext_unsignedXmlDocFileHandler(xmlDoc);
	return;
    }
    xmldsigffext_xmlDocFileChangeHandler(null);
}

/* nsIDOMDocument */
function xmldsigffext_removeXMLDocSignature(/* nsIDOMDocument */ xmlDoc)
{
    dump("\n\nxxmldsigffext_removeXMLDocSignature():................Start.\n");

    var /* nsINodeList */ xmlDocSigElemList = xmlDoc.getElementsByTagName("Signature");
    if (!xmlDocSigElemList || (xmlDocSigElemList.length == 0)) {
	/*
    	alert("xmldsigffext_signedXmlDocFileHandler(): Not a valid Signed XML file - no Signature element.\n");
    	dump("xmldsigffext_signedXmlDocFileHandler(): Not a valid Signed XML file - no Signature element.\n");
	*/
    	return xmlDoc;
    }
    var xmlDocSigElem = xmlDocSigElemList.item(0);

    var signatureType = xmldsigffext_getSelectedSignatureType();

    // Reference URI
    if (signatureType == "ENVELOPING_SIGNATURE") {
    	dump("xmldsigffext_removeXMLDocSignature(): ENVELOPING_SIGNATURE\n");
        var xmlDocObjIdURI = xmldsigffext_getXmlDocElemAttribute(xmlDocSigElem, "Reference", "URI");
	if (!xmlDocObjIdURI) {
    	    dump("xxmldsigffext_removeXMLDocSignature(): ENVELOPING_SIGNATURE - ERROR: Can't find Reference URI\n");
	    return xmlDoc;
	}
    	dump("xmldsigffext_removeXMLDocSignature(): xmlDocObjIdURI: " + xmlDocObjIdURI + "\n");
	var xmlDocObjIdList = xmlDocObjIdURI.split("#"); 
	var xmlDocObjId = xmlDocObjIdURI.substring(1);
    	dump("xmldsigffext_removeXMLDocSignature(): xmlDocObjId: " + xmlDocObjId + "\n");
    	var xmlDocSigObjElem = xmlDoc.getElementById(xmlDocObjId);
	if (!xmlDocSigObjElem) {
	    xmlDocSigObjElem = xmldsigffext_getXmlDocElemChildByAttrNVP(xmlDocSigElem, "Id", xmlDocObjId);
	}
	if (!xmlDocSigObjElem) {
    	    dump("xmldsigffext_removeXMLDocSignature(): ENVELOPING_SIGNATURE - ERROR: Can't find referenced Object: " + xmlDocObjId + "\n");
	    return xmlDoc;
	}
	if (xmlDocSigObjElem.tagName.indexOf("Object") < 0) {
    	    dump("xxmldsigffext_removeXMLDocSignature(): ENVELOPING_SIGNATURE - ERROR: referenced Object: " + xmlDocObjId + " is not an element of Object type.\n");
	    return xmlDoc;
	}
    	dump("xmldsigffext_removeXMLDocSignature(): xmlDocSigObjElem: " + xmlDocSigObjElem + "\n");
        var /* nsIDOMElement */ xmlDocNewRootElem = xmlDocSigObjElem.childNodes.item(0);
	if (!xmlDocNewRootElem) {
    	    dump("xmldsigffext_removeXMLDocSignature(): ENVELOPING_SIGNATURE - ERROR: failed get new doc root element.\n");
	    return xmlDoc;
	}
	// xmlDocNewRootElem = xmlDocNewRootElem.cloneNode(true);
    	xmlDoc.removeChild(xmlDocSigElem);
    	xmlDoc.appendChild(xmlDocNewRootElem);
	var xmlDocStr = gXmlDSigTool.saveXMLDocToString(xmlDoc);
	dump("xmlDocStr:\n" + xmlDocStr + "\n");
	// return xmlDoc;
    }
    else if (signatureType == "ENVELOPED_SIGNATURE") {
    	xmlDoc.documentElement.removeChild(xmlDocSigElem);
	var xmlDocStr = gXmlDSigTool.saveXMLDocToString(xmlDoc);
	dump("xmlDocStr:\n" + xmlDocStr + "\n");
	// return xmlDoc;
    }

    dump("xmldsigffext_removeXMLDocSignature():................End.\n\n");
    return xmlDoc;
}



/* nsIDOMDocument  */
function xmldsigffext_signXMLDocWithSharedKey(/* nsIDOMDocument  */ xmlDoc, /* nsIPersistentProperties */ xmlSignatureProps)
{
    dump("xmldsigffext_signXMLDocWithSharedKey():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var outSignedXmlDoc = null;
    try {
    	outSignedXmlDoc = gXmlDSigTool.signXMLDocBySharedKey(xmlDoc, xmlSignatureProps);
    } catch (ex) {
    	// alert("xmldsigffext_signXMLFileWithSharedKey(): failed to create signed XML file - ex : " + ex + "\n");
    	dump("xmldsigffext_signXMLDocWithSharedKey(): failed to create signed XML file - ex : " + ex + "\n");
	throw ex;
    }

    dump("xmldsigffext_signXMLDocWithSharedKey():................End.\n");

    return outSignedXmlDoc;

}


/* nsIDOMDocument  */
function xmldsigffext_signXMLDocWithCert(/* nsIDOMDocument  */ xmlDoc, /* nsIX509Cert */ signerCert, /* nsIPersistentProperties */ xmlSignatureProps)
{
    dump("xmldsigffext_signXMLDocWithCert():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var outSignedXmlDoc = null;
    try {
    	// Force token login - on windows the popup window for password is not coming up
    	xmldsigffext_loginToCertToken(signerCert);
    	outSignedXmlDoc = gXmlDSigTool.signXMLDocByX509Cert(xmlDoc, signerCert, xmlSignatureProps);
    } catch (ex) {
    	alert("xmldsigffext_signXMLDocWithCert(): failed to sign XML file - ex : " + ex + "\n");
    	dump("xmldsigffext_signXMLDocWithCert(): failed to sign XML file - ex : " + ex + "\n");
	throw ex;
    }

    dump("xmldsigffext_signXMLDocWithCert():................End.\n");

    return outSignedXmlDoc;
}


/* nsIDOMDocument */
function xmldsigffext_signXMLDoc(xmlDSigParamRootElemId)
{
    var signedXmlDoc = null;
    // var signedXmlDoc = xmldsigffext_signXMLDoc(gXmlVerifyInputFilePickerElem.xmlDoc, xmlDSigParamRootElemId);

    var xmlDoc = gXmlVerifyInputFilePickerElem.xmlDoc;

    var /* nsIPersistentProperties */ xmlSignatureProps = getSignatureFormProperties(xmlDSigParamRootElemId);
    var credentialType = xmldsigffext_getUserCredentialType();
    if (credentialType == "certificate") {
        var /* nsIX509Cert */ signerCert;
        signerCert = xmldsigffext_getSelectedSignerCert();
        if (signerCert == null) {
    	    dump("xmldsigffext_signXMLDoc(): null signerCert.\n");
    	    alert("xmldsigffext_signXMLDoc(): null signerCert.\n");
    	    return null;
        }
        dump("xmldsigffext_signXMLDoc():................20.\n");
    	signedXmlDoc = xmldsigffext_signXMLDocWithCert(xmlDoc, signerCert, xmlSignatureProps);
    }
    else if (credentialType == "password") {
        var sharedKey = xmldsigffext_getUserPassword();
        if (sharedKey.length == 0) {
    	    alert("xmldsigffext_signXMLDoc(): shared key is missing.\n");
    	    dump("xmldsigffext_signXMLDoc(): shared key is missing.\n");
    	    return null;
        }
    	signedXmlDoc = xmldsigffext_signXMLDocWithSharedKey(xmlDoc, xmlSignatureProps);
    }
    else {
    	signedXmlDoc = null;
    }
    if (!signedXmlDoc) {
    	return null;
    }
    return signedXmlDoc;
}

/* nsIDOMDocument */
function xmldsigffext_signXMLDocToFile(xmlDSigParamRootElemId)
{
    dump("xmldsigffext_signXMLDocToFile():................Start.\n");

    // Select path to the signed XML File 
    var /* nsILocalFile */ outSignedXmlDocFile = null;
    if (gXmlVerifySignedOutFilePickerElem.value == "") {
	xmldsigffext_autoSelectOutSignedFile(gXmlVerifyInputFilePickerElem.file);
    }
    outSignedXmlDocFile = gXmlVerifySignedOutFilePickerElem.file;
    if (outSignedXmlDocFile == null) {
    	dump("xmldsigffext_signXMLDocToFile(): failed to get outSignedXmlDocFile.\n");
        return signedXmlDoc;
    }
    dump("xmldsigffext_signXMLDocToFile(): outSignedXmlDocFile: " + outSignedXmlDocFile.path + "\n");


    // Create signed XML doc 
    var /* nsIDOMDocument */ signedXmlDoc = null;
    signedXmlDoc = xmldsigffext_signXMLDoc(xmlDSigParamRootElemId);
    if (!signedXmlDoc) {
    	return null;
    }

    // Save signed XML doc 

    var signedXmlDocStr = gXmlSerializer.serializeToString(signedXmlDoc);
    gXmlVerifySignedOutFilePickerElem.saveFile(signedXmlDocStr);
    gXmlVerifySignedOutFilePickerElem.refresh();

    dump("xmldsigffext_signXMLDocToFile():................End.\n");
    return signedXmlDoc;
}

function xmldsigffext_verifySignedXMLFile(xmlDSigParamRootElemId)
{
    dump("xmldsigffext_verifySignedXMLFile():................Start.\n");

    // var xmlSignatureProps = getSignatureFormProperties("xmldsigffext.form.tabpanel.sign");
    var /* nsIPersistentProperties */ xmlSignatureProps = getSignatureFormProperties(xmlDSigParamRootElemId);

    var isPassed = false;
    var credentialType = xmldsigffext_getUserCredentialType();
    if (credentialType.value == "certificate") {
    	isPassed = xmldsigffext_verifySignedXMLFileWithX509Cert(xmlSignatureProps);
    }
    else {
    	isPassed = xmldsigffext_verifySignedXMLFileWithSharedKey(xmlSignatureProps);
    }

    dump("xmldsigffext_verifySignedXMLFile():................End.\n");
    return isPassed;
}

function xmldsigffext_verifySignedXMLFileWithSharedKey(xmlSignatureProps)
{
    dump("xmldsigffext_verifySignedXMLFileWithSharedKey():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var signedXmlFile = gXmlVerifyInputFilePickerElem.file;

    var sharedKey = xmldsigffext_getUserPassword();
    if (sharedKey == "") {
	alert("Password is missing - enter a password.");
    	return false;
    }

    var isPassed = false;
    try {
    	/*
        boolean verifySignedXMLFileByX509Cert(
	    	in nsILocalFile aSignedXmlFile,
		in AString sharedKey,
		in nsIPersistentProperties aSignatureProps
		);
	*/
    	isPassed = gXmlDSigTool.verifySignedXMLFileBySharedKey(
                        signedXmlFile,
			sharedKey,
			xmlSignatureProps
                        );
    } catch (ex) {
    	dump("xmldsigffext_verifySignedXMLFileWithSharedKey to verify signed XML file - ex : " + ex + "\n");
	throw ex;
    }

    dump("xmldsigffext_verifySignedXMLFileWithSharedKey():................Start.\n");
    return isPassed;
}

function xmldsigffext_verifySignedXMLFileWithX509Cert(xmlSignatureProps)
{
    dump("xmldsigffext_verifySignedXMLFileWithX509Cert():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var signedXmlFile = gXmlVerifyInputFilePickerElem.file;

    var /* nsIX509Cert */ signerCert = null;
    var signerCertObj = new Object();
    var isPassed = false;
    try {
    	/*
        boolean verifySignedXMLFileByX509Cert(
	    	in nsILocalFile aSignedXmlFile,
		inout nsIX509Cert aOutSignerCert,
		in nsIPersistentProperties aSignatureProps
		);
	*/
        signerCert = xmldsigffext_getSelectedSignerCert();
	signerCertObj.value = signerCert;
    	isPassed = gXmlDSigTool.verifySignedXMLFileByX509Cert(
                        signedXmlFile,
			signerCertObj,
			xmlSignatureProps
                        );
    } catch (ex) {
    	dump("xmldsigffext_verifySignedXMLFileWithX509Cert(): failed to verify signed XML file - ex : " + ex + "\n");
	throw ex;
    }
    if (!signerCert) {
    	// gXmlVerifyDocSignerCertElem.cert = signerCertObj.value;
    	if (signerCertObj.value) {
    	    xmldsigffext_showXmlDocSignerCert(signerCertObj.value);
    	    dump("xmldsigffext_verifySignedXMLFileWithX509Cert():x509Cert.dbKey: " + signerCertObj.value.dbKey + "\n");
    	}
    }

    dump("xmldsigffext_verifySignedXMLFileWithX509Cert():................End.\n");
    return isPassed;
}

function xmldsigffext_verifySignedXMLDoc(xmlDSigParamRootElemId)
{
    dump("xmldsigffext_verifySignedXMLDoc():................Start.\n");

    var /* nsIPersistentProperties */ xmlSignatureProps = getSignatureFormProperties(xmlDSigParamRootElemId);
    var /* nsIDOMDocument */ signedXmlDoc = gXmlVerifyInputFilePickerElem.xmlDoc;

    var isPassed = false;
    var credentialType = xmldsigffext_getUserCredentialType();
    if (credentialType == "certificate") {
    	isPassed = xmldsigffext_verifySignedXMLDocByX509Cert(signedXmlDoc, xmlSignatureProps);
    }
    else {
    	isPassed = xmldsigffext_verifySignedXMLDocWithSharedKey(signedXmlDoc, xmlSignatureProps);
    }

    dump("xmldsigffext_verifySignedXMLDoc():................End.\n");
    return isPassed;
}

function xmldsigffext_verifySignedXMLDocWithSharedKey(signedXmlDoc, xmlSignatureProps)
{
    dump("xmldsigffext_verifySignedXMLDocWithSharedKey():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var sharedKey = xmldsigffext_getUserPassword();
    if (sharedKey == "") {
	alert("Password is missing - enter a password.");
    	return false;
    }

    var isPassed = false;
    try {
        /*
    	boolean verifySignedXMLDocBySharedKey(
                in nsIDOMDocument aSignedXmlDoc,
		in AString sharedKey,
                in nsIPersistentProperties aSignatureProps
                );
	*/
    	isPassed = gXmlDSigTool.verifySignedXMLDocBySharedKey(
                        signedXmlDoc,
			sharedKey,
			xmlSignatureProps
                        );
    } catch (ex) {
    	dump("xmldsigffext_verifySignedXMLDocWithSharedKey(): failed to verify signed archive file - ex : " + ex + "\n");
	throw ex;
    }

    dump("xmldsigffext_verifySignedXMLDocWithSharedKey():................End.\n");
    return isPassed;
}

function xmldsigffext_verifySignedXMLDocByX509Cert(signedXmlDoc, xmlSignatureProps)
{
    dump("xmldsigffext_verifySignedXMLDocByX509Cert():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var /* nsIX509Cert */ signerCert = null;
    var signerCertObj = new Object();
    var isPassed = false;
    try {
        /*
    	boolean verifySignedXMLDocByX509Cert(
                in nsIDOMDocument aSignedXmlDoc,
                inout nsIX509Cert aOutSignerCert,
                in nsIPersistentProperties aSignatureProps
                );

	*/
        signerCert = xmldsigffext_getSelectedSignerCert();
    	dump("xmldsigffext_verifySignedXMLDocByX509Cert(): signerCert: " + signerCert + "\n");
	// signerCertObj.value = xmldsigffext_getXmlDocSignerCert();
	signerCertObj.value = signerCert;
    	isPassed = gXmlDSigTool.verifySignedXMLDocByX509Cert(
                        signedXmlDoc,
			signerCertObj,
			xmlSignatureProps
                        );
    } catch (ex) {
    	dump("xmldsigffext_verifySignedXMLDocByX509Cert(): failed to verify signed archive file - ex : " + ex + "\n");
	isPassed = false;
	// throw ex;
    }
    if (!signerCert) {
    	dump("xmldsigffext_verifySignedXMLDocByX509Cert(): signerCertObj.value: " + signerCertObj.value + "\n");
    	// gXmlVerifyDocSignerCertElem.cert = signerCertObj.value;
	if (signerCertObj.value) {
    	    xmldsigffext_showXmlDocSignerCert(signerCertObj.value);
    	    dump("xmldsigffext_verifySignedXMLDocByX509Cert():x509Cert.dbKey: " + signerCertObj.value.dbKey + "\n");
	}
    }

    dump("xmldsigffext_verifySignedXMLDocByX509Cert():................End.\n");
    return isPassed;
}

function xmldsigffext_autoSelectOutSignedFile(/* nsILocalFile */ inputXMLFile)
{
    var outSignedFileName = null;

    outSignedFileName = "TmpXMLFile.xml";
    if (inputXMLFile) {
    	outSignedFileName = inputXMLFile.leafName;
    }
    if (outSignedFileName.indexOf("_SIGNATURE") < 0) {
    	outSignedFileName =
			xmldsigffext_getSignedXMLFileType() + 
			/*
			gXmlVerifySigTypeMenuElem.value +
    			"_" + gXmlVerifySigCanonMethodMenuElem.value +
    			"_" + gXmlVerifyUserCredentialTypeGroupElem.selectedItem.value +
			*/
			"_" + inputXMLFile.leafName;
    }
    
    return xmldsigffext_autoSelectOutFile(gXmlVerifySignedOutFilePickerElem, outSignedFileName);
}

function xmldsigffext_signXMLFile(xmlDSigParamRootElemId)
{
    dump("xmldsigffext_signXMLFile():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
    netscape.security.PrivilegeManager.enablePrivilege("UniversalFileRead");

    // var xmlSignatureProps = getSignatureFormProperties("xmldsigffext.form.tabpanel.sign");
    var /* nsIPersistentProperties */ xmlSignatureProps = getSignatureFormProperties(xmlDSigParamRootElemId);

    var /* nsILocalFile */ inputXMLFile = gXmlVerifyInputFilePickerElem.file;
    if (inputXMLFile == null) {
    	dump("xmldsigffext_signXMLFile(): No input XML file is selected.\n");
    	alert("xmldsigffext_signXMLFile(): No input XML file is selected.\n");
    	return null;
    }

    var /* nsILocalFile */ outSignedXMLFile = null;
    if (gXmlVerifySignedOutFilePickerElem.value == "") {
	xmldsigffext_autoSelectOutSignedFile(inputXMLFile);
    }
    outSignedXMLFile = gXmlVerifySignedOutFilePickerElem.file;
    if (outSignedXMLFile == null) {
    	dump("xmldsigffext_signXMLFile(): failed to get outSignedXMLFile.\n");
    	alert("xmldsigffext_signXMLFile(): failed to get outSignedXMLFile.\n");
        return null;
    }
    dump("xmldsigffext_signXMLFile(): outSignedXMLFile: " + outSignedXMLFile.path + "\n");


    var credentialType = xmldsigffext_getUserCredentialType();
    if (credentialType == "certificate") {
    	outSignedXMLFile = xmldsigffext_signXMLFileWithCert(xmlSignatureProps);
    }
    else if (credentialType == "password") {
        var sharedKey = xmldsigffext_getUserPassword();
        if (sharedKey.length == 0) {
    	    alert("xmldsigffext_signXMLFileWithSharedKey(): shared key is missing.\n");
    	    dump("xmldsigffext_signXMLFileWithSharedKey(): shared key is missing.\n");
    	    return null;
        }
    	outSignedXMLFile = xmldsigffext_signXMLFileWithSharedKey(xmlSignatureProps);
    }
    else {
    	outSignedXMLFile = null;
    }

    if (!outSignedXMLFile) {
    	dump("xmldsigffext_signXMLFile(): failed to sign input XML file.\n");
	return null;
    }

    gXmlVerifySignedOutFilePickerElem.refresh();
    outSignedXMLFile = gXmlVerifySignedOutFilePickerElem.file;
    if (!outSignedXMLFile || !outSignedXMLFile.exists() || (outSignedXMLFile.fileSize <= 0)) {
    	dump("xmldsigffext_signXMLFile(): failed to create Signed XML file.\n");
    	// alert("xmldsigffext_signXMLFile(): failed to create Signed XML file.\n");
	return null;
    }

    dump("xmldsigffext_signXMLFile():................End.\n");

    return gXmlVerifySignedOutFilePickerElem.file;
}

function xmldsigffext_signXMLFileWithSharedKey(/* nsIPersistentProperties */ xmlSignatureProps)
{
    dump("xmldsigffext_signXMLFileWithSharedKey():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var /* nsILocalFile */ inputXMLFile = gXmlVerifyInputFilePickerElem.file;
    if (inputXMLFile == null) {
    	dump("xmldsigffext_signXMLFileWithSharedKey(): No input XML file is selected.\n");
    	return null;
    }

    var /* nsILocalFile */ outSignedXMLFile = gXmlVerifySignedOutFilePickerElem.file;
    if (outSignedXMLFile == null) {
    	dump("xmldsigffext_signXMLFileWithSharedKey(): failed to get outSignedXMLFile.\n");
        return null;
    }

    try {
    	gXmlDSigTool.signXMLFileBySharedKey(inputXMLFile, xmlSignatureProps, outSignedXMLFile);
    } catch (ex) {
    	// alert("xmldsigffext_signXMLFileWithSharedKey(): failed to create signed XML file - ex : " + ex + "\n");
    	dump("xmldsigffext_signXMLFileWithSharedKey(): failed to create signed XML file - ex : " + ex + "\n");
	throw ex;
    }

    dump("xmldsigffext_signXMLFileWithSharedKey():................End.\n");

    return outSignedXMLFile;
}

function xmldsigffext_signXMLFileWithCert(/* nsIPersistentProperties */ xmlSignatureProps)
{
    dump("xmldsigffext_signXMLFileWithCert():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
    netscape.security.PrivilegeManager.enablePrivilege("UniversalFileRead");

    var /* nsIX509Cert */ signerCert;
    signerCert = xmldsigffext_getSelectedSignerCert();
    if (signerCert == null) {
    	dump("xmldsigffext_signXMLFileWithCert(): null signer certificate is selected.\n");
    	return null;
    }

    var /* nsILocalFile */ inputXMLFile = gXmlVerifyInputFilePickerElem.file;
    if (inputXMLFile == null) {
    	dump("xmldsigffext_signXMLFileWithCert(): No input XML file is selected.\n");
    	return null;
    }

    var /* nsILocalFile */ outSignedXMLFile = gXmlVerifySignedOutFilePickerElem.file;
    if (outSignedXMLFile == null) {
    	dump("xmldsigffext_signXMLFileWithCert(): failed to get outSignedXMLFile.\n");
        return null;
    }

    try {
    	// Force token login - on windows the popup window for password is not coming up
    	xmldsigffext_loginToCertToken(signerCert);

    	// dumpProperties(xmlSignatureProps, "xmldsigffext_signXMLFileWithCert(): xmlSignatureParams:");
    	gXmlDSigTool.signXMLFileByX509Cert(inputXMLFile, signerCert, xmlSignatureProps, outSignedXMLFile);
    } catch (ex) {
    	// alert("xmldsigffext_signXMLFileWithCert(): failed to create signed XML file - ex : " + ex + "\n");
    	dump("xmldsigffext_signXMLFileWithCert(): failed to create signed XML file - ex : " + ex + "\n");
	throw ex;
    }

    dump("xmldsigffext_signXMLFileWithCert():................End.\n");

    return outSignedXMLFile;
}

