/* @(#) $Id: XmlDSigToolFormSignature.js,v 1.10 2008/02/24 06:33:04 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */



var gXmlVerifySignInfoElem;
var gXmlVerifyResignRowElem;
var gXmlVerifyResignElem;

var gXmlVerifyUserCredentialTypeRowElem;
var gXmlVerifyUserCredentialTypeGroupElem;
var gXmlVerifyCredentialTypePasswordElem;
var gXmlVerifyCredentialTypeCertElem;

var gXmlVerifyUserInfoRowElem;
var gXmlVerifyUserNameElem;
var gXmlVerifyUserPasswordElem;

var gXmlVerifyKeyInfoRowElem;

var gXmlVerifyKeyInfoNameElem;
var gXmlVerifyKeyInfoX509Elem;
var gXmlVerifyKeyInfoValueElem;
// var gXmlVerifyPasswordEncElem;

var gXmlVerifySigMethodMenuElem;
var gXmlVerifySigCanonMethodMenuElem;
var gXmlVerifySigHashAlgMenuElem;
var gXmlVerifySigTypeMenuElem;


var gXmlVerifyParamSignerCertRowElem;
var gXmlVerifySignerCertMenuListElem;
var gXmlVerifyDocSignerCertRowElem;
var gXmlVerifyDocSignerCertElem;

var gXmlVerifyTransformTypeRowElem;

/*
var gXmlVerifyResultRowElem;
var gXmlVerifyResultElem;
*/

/*
 * Copied from Apache xml-security-c-1.3.0/src/dsig/DSIGConstants.hpp of Apache XSEC
 */
const  URI_ID_ENVELOPE 		= "http://www.w3.org/2000/09/xmldsig#enveloped-signature";

const  URI_ID_C14N_NOC 		= "http://www.w3.org/TR/2001/REC-xml-c14n-20010315";
const  URI_ID_C14N_COM 		= "http://www.w3.org/TR/2001/REC-xml-c14n-20010315#WithComments";
const  URI_ID_EXC_C14N_NOC 	= "http://www.w3.org/2001/10/xml-exc-c14n#";
const  URI_ID_EXC_C14N_COM	= "http://www.w3.org/2001/10/xml-exc-c14n#WithComments";

const  URI_ID_HMAC_SHA1		= "http://www.w3.org/2000/09/xmldsig#hmac-sha1";
const  URI_ID_HMAC_SHA224	= "http://www.w3.org/2001/04/xmldsig-more#hmac-sha224";
const  URI_ID_HMAC_SHA256	= "http://www.w3.org/2001/04/xmldsig-more#hmac-sha256";
const  URI_ID_HMAC_SHA384	= "http://www.w3.org/2001/04/xmldsig-more#hmac-sha384";
const  URI_ID_HMAC_SHA512	= "http://www.w3.org/2001/04/xmldsig-more#hmac-sha512";

const  URI_ID_DSA_SHA1		= "http://www.w3.org/2000/09/xmldsig#dsa-sha1";
const  URI_ID_RSA_SHA1		= "http://www.w3.org/2000/09/xmldsig#rsa-sha1";
const  URI_ID_RSA_SHA224	= "http://www.w3.org/2001/04/xmldsig-more#rsa-sha224";
const  URI_ID_RSA_SHA256	= "http://www.w3.org/2001/04/xmldsig-more#rsa-sha256";
const  URI_ID_RSA_SHA384	= "http://www.w3.org/2001/04/xmldsig-more#rsa-sha384";
const  URI_ID_RSA_SHA512	= "http://www.w3.org/2001/04/xmldsig-more#rsa-sha512";
const  URI_ID_RSA_MD5		= "http://www.w3.org/2000/09/xmldsig#rsa-md5";

function xmldsigffextsig_initSigFormXULElems()
{
    dump("xmldsigffextsig_initSigFormXULElems():................Start.\n");

    // gXmlVerifySignInfoElem		= document.getElementById("xmldsigffext.form.sign.sig.info");

    gXmlVerifyResignRowElem		= document.getElementById("xmldsigffext.form.sign.resign.row");
    gXmlVerifyResignElem		= document.getElementById("xmldsigffext.form.sign.resign");

    gXmlVerifyUserCredentialTypeRowElem	= document.getElementById("xmldsigffext.form.sign.credential.type.row");
    gXmlVerifyUserCredentialTypeGroupElem	= document.getElementById("xmldsigffext.form.sign.credential.type.group");
    gXmlVerifyCredentialTypePasswordElem = document.getElementById("xmldsigffext.form.sign.credential.type.password");
    gXmlVerifyCredentialTypeCertElem	= document.getElementById("xmldsigffext.form.sign.credential.type.cert");


    gXmlVerifyUserInfoRowElem		= document.getElementById("xmldsigffext.form.sign.signer.userinfo.row");
    gXmlVerifyUserNameElem		= document.getElementById("xmldsigffext.form.sign.signer.userinfo.name");
    gXmlVerifyUserPasswordElem		= document.getElementById("xmldsigffext.form.sign.signer.userinfo.password");

    gXmlVerifyParamSignerCertRowElem	= document.getElementById("xmldsigffext.form.sign.signer.cert.row");
    gXmlVerifySignerCertMenuListElem	= document.getElementById("xmldsigffext.form.sign.signer.nickName.menulist");
    gXmlVerifyDocSignerCertRowElem	= document.getElementById("xmldsigffext.form.sign.doc.signer.cert.row");
    gXmlVerifyDocSignerCertElem		= document.getElementById("xmldsigffext.form.sign.doc.signer.cert.nickName");

    gXmlVerifyKeyInfoRowElem		= document.getElementById("xmldsigffext.form.sign.params.keyinfo.row"); 

    gXmlVerifyKeyInfoNameElem		= document.getElementById("xmldsigffext.form.sign.params.keyinfo.keyName"); 
    gXmlVerifyKeyInfoX509Elem		= document.getElementById("xmldsigffext.form.sign.params.keyinfo.x509Data"); 
    gXmlVerifyKeyInfoValueElem		= document.getElementById("xmldsigffext.form.sign.params.keyinfo.keyValue"); 

    /*
    gXmlVerifyKeyInfoX509Elem.checked = true;
    keyinfoValueCheckElem.disabled = false;
    keyinfoValueCheckElem.checked = true;
    */
    // gXmlVerifyPasswordEncElem	= document.getElementById("xmldsigffext.form.sign.params.keyinfo.enckey"); 

    gXmlVerifySigMethodMenuElem		= document.getElementById("xmldsigffext.form.sign.params.digest.method.menulist"); 
    gXmlVerifySigCanonMethodMenuElem 	= document.getElementById("xmldsigffext.form.sign.params.canon.method.menulist"); 
    gXmlVerifySigHashAlgMenuElem	= document.getElementById("xmldsigffext.form.sign.params.sig.hashalg.menulist");
    gXmlVerifySigTypeMenuElem		= document.getElementById("xmldsigffext.form.sign.params.signature.type.menulist");


    gXmlVerifyTransformTypeRowElem	= document.getElementById("xmldsigffext.form.sign.params.transform.type.row");
    // gXmlVerifyResultRowElem		= document.getElementById("xmldsigffext.form.sign.file.xmldoc.result.row");
    // gXmlVerifyResultElem		= document.getElementById("xmldsigffext.form.sign.file.xmldoc.result");

    // gXmlVerifyUserCredentialTypeGroupElem.selectedItem = null;


    dump("xmldsigffextsig_initSigFormXULElems():................End.\n");
}

function xmldsigffext_initForSigningWithCert()
{
    gXmlVerifyUserCredentialTypeGroupElem.selectedItem = gXmlVerifyCredentialTypeCertElem;

    gXmlVerifyParamSignerCertRowElem.hidden = false;
    gXmlVerifySignerCertMenuListElem.hidden = false;
    gXmlVerifyDocSignerCertRowElem.hidden = true;
    gXmlVerifyDocSignerCertElem.hidden = true;
    gXmlVerifySignerCertMenuListElem.focus();

    gXmlVerifyKeyInfoRowElem.hidden = false;
    gXmlVerifyKeyInfoNameElem.checked = true;
    gXmlVerifyKeyInfoX509Elem.checked = true;
    gXmlVerifyKeyInfoValueElem.checked = true;

    /*
    // gXmlVerifySigMethodMenuElem.value = "xx";
    gXmlVerifySigCanonMethodMenuElem.value = "C14NE_NOC";
    gXmlVerifySigHashAlgMenuElem.value = "SHA1";
    gXmlVerifySigTypeMenuElem.value = "ENVELOPED_SIGNATURE";

    gXmlVerifyTransformTypeRowElem.hidden = true;
    */
}

function xmldsigffext_initSAMLTokenForCert()
{
    gXmlVerifyUserCredentialTypeGroupElem.selectedItem = gXmlVerifyCredentialTypeCertElem;

    gXmlVerifyParamSignerCertRowElem.hidden = false;
    gXmlVerifySignerCertMenuListElem.hidden = false;
    gXmlVerifyDocSignerCertRowElem.hidden = true;
    gXmlVerifyDocSignerCertElem.hidden = true;
    gXmlVerifySignerCertMenuListElem.focus();

    gXmlVerifyKeyInfoRowElem.hidden = false;
    gXmlVerifyKeyInfoNameElem.checked = true;
    gXmlVerifyKeyInfoX509Elem.checked = true;
    gXmlVerifyKeyInfoValueElem.checked = true;

    // gXmlVerifySigMethodMenuElem.value = "xx";
    gXmlVerifySigCanonMethodMenuElem.value = "C14NE_NOC";
    gXmlVerifySigHashAlgMenuElem.value = "SHA1";
    gXmlVerifySigTypeMenuElem.value = "ENVELOPED_SIGNATURE";

    gXmlVerifyTransformTypeRowElem.hidden = true;
}

function xmldsigffext_isEnvelopedSignature(xmlDocSignedInfoElem)
{
    var docElemList = xmlDocSignedInfoElem.getElementsByTagName("Transform");
    if (!docElemList || (docElemList.length == 0)) {
    	return false;
    }
    for (var i = 0; i < docElemList.length; i++) {
	var docElemAttribValue = docElemList[i].getAttribute("Algorithm");
	if (!docElemAttribValue) {
	    continue;
	}
	if (docElemAttribValue.indexOf("enveloped-signature") >= 0) {
	    return true;
	}
    }
    return false;
}

function xmldsigffext_isHmacSig(sigMethodAlgURIStr)
{
    var sigMethodAlgURICompList = sigMethodAlgURIStr.split("#");
    var sigMethodAlg = sigMethodAlgURICompList[1];
    // dump("xmldsigffext_isHmacSig(): sigMethodAlg: " + sigMethodAlg + "\n");
    if (sigMethodAlg.indexOf("hmac") >= 0) {
    	return true;
    }
    return false;
}

function xmldsigffext_sigMethodAlg2XULMap(sigMethodAlgURIStr)
{
    /*
    var sigMethodAlgURI = Components.classes["@mozilla.org/network/io-service;1"].
    				getService(Components.interfaces.nsIIOService).
				newURI(sigMethodAlgURIStr, null, null);
    */
    var sigMethodAlgURICompList = sigMethodAlgURIStr.split("#");
    var sigMethodAlg = sigMethodAlgURICompList[1];
    var sigMethodAlgCompList = sigMethodAlg.split("-");
    sigMethodAlg = sigMethodAlgCompList[1].toUpperCase();
    return sigMethodAlg;
}

function xmldsigffext_sigCanonicalAlg2XULMap(canonAlgURI)
{
    var canonMenuItemValue = "";
    if (canonAlgURI == URI_ID_C14N_NOC) {
    	canonMenuItemValue = "C14N_NOC";
    }
    else if (canonAlgURI == URI_ID_C14N_COM) {
    	canonMenuItemValue = "C14N_COM";
    }
    else if (canonAlgURI == URI_ID_EXC_C14N_NOC) {
    	// canonMenuItemValue = "EXC_C14N_NOC";
    	canonMenuItemValue = "C14NE_NOC";
    }
    else if (canonAlgURI == URI_ID_EXC_C14N_COM) {
    	// canonMenuItemValue = "EXC_C14N_COM";
    	canonMenuItemValue = "C14NE_COM";
    }
    return canonMenuItemValue;
}


function xmldsigffext_handleCredentialTypeChange(credentialTypeGroupElem, selectedItemElem)
{
    dump("xmldsigffext_handleCredentialTypeChange():................Start.\n");

    if (selectedItemElem.value == "password") {
	gXmlVerifyUserInfoRowElem.hidden = false;

    	gXmlVerifyKeyInfoX509Elem.hidden = true;
    	gXmlVerifyKeyInfoValueElem.hidden = true;
	/*
    	gXmlVerifyKeyInfoX509Elem.checked = false;
	*/

    	// gXmlVerifyPasswordEncElem.hidden = false;

	gXmlVerifyParamSignerCertRowElem.hidden = true;
	gXmlVerifySignerCertMenuListElem.hidden = true;
	gXmlVerifyDocSignerCertRowElem.hidden = true;
	gXmlVerifyDocSignerCertElem.cert = null;
	
	gXmlVerifySigMethodMenuElem.value = "HMAC";
	gXmlVerifySigHashAlgMenuElem.value = "SHA1";
	gXmlVerifySigHashAlgMenuElem.disabled = true;
    }
    else {
	gXmlVerifyUserInfoRowElem.hidden = true;

    	gXmlVerifyKeyInfoX509Elem.hidden = false;
    	gXmlVerifyKeyInfoX509Elem.checked = true;

    	gXmlVerifyKeyInfoValueElem.hidden = false;
    	gXmlVerifyKeyInfoX509Elem.checked = true;

	/*
    	gXmlVerifyKeyInfoX509Elem.disabled = false;
	*/

	/*
    	gXmlVerifyPasswordEncElem.disabled = true;
    	gXmlVerifyPasswordEncElem.checked = false;
	*/

	gXmlVerifySigMethodMenuElem.value = "RSA";

	gXmlVerifySigHashAlgMenuElem.value = "SHA1";
	gXmlVerifySigHashAlgMenuElem.disabled = false;

	gXmlVerifyParamSignerCertRowElem.hidden = false;
	gXmlVerifySignerCertMenuListElem.hidden = false;
	if (xmldsigffext_getSelectedSignerCert()) {
    	    xmldsigffext_SignerNickNameMenuListChanged(
	    		gXmlVerifySignerCertMenuListElem,
			gXmlVerifySignerCertMenuListElem.selectedItem,
			""
			); 
	}
	else {
	    gXmlVerifySignerCertMenuListElem.refresh();
	}
    }

    xmldsigffext_handleSignerNameChange(gXmlVerifyUserNameElem);

    dump("xmldsigffext_handleCredentialTypeChange():................End.\n");
}
function xmldsigffext_handleSignerNameChange(aSignerNameElem, ev)
{
    dump( "xmldsigffext_handleSignerNameChange():......................Start.\n");

    // autoCompleteAction(aSignerNameElem);

    if (aSignerNameElem.value == "") {
	gXmlVerifyKeyInfoNameElem.checked = false;
	gXmlVerifyKeyInfoNameElem.disabled = true;
    }
    else {
    	// gXmlVerifyKeyInfoNameElem.checked = false;
	gXmlVerifyKeyInfoNameElem.disabled = false;
    }

   dump( "xmldsigffext_handleSignerNameChange():......................End.\n");
}

function xmldsigffext_setUserCredential( /* nsIX509 */ aSelectedSignerCert)
{
    if (aSelectedSignerCert) {
    	gXmlVerifyUserCredentialTypeGroupElem.selectedItem = gXmlVerifyCredentialTypeCertElem;
    	// gXmlFileSignerCertMenuListElem = document.getElementById("xmldsigffext.form.sign.signer.nickName.menulist");
	gXmlFileSignerCertMenuListElem.value = aSelectedSignerCert.nickname;
	// gXmlFileSignerCertMenuListElem.disabled = true;
    }
    else {
    	gXmlVerifyUserCredentialTypeGroupElem.selectedItem = gXmlVerifyCredentialTypePasswordElem;
    }
    xmldsigffext_handleCredentialTypeChange(
		gXmlVerifyUserCredentialTypeGroupElem,
		gXmlVerifyUserCredentialTypeGroupElem.selectedItem
    		);

}

function xmldsigffext_getUserCredentialType()
{
    return gXmlVerifyUserCredentialTypeGroupElem.selectedItem.value;
}


function xmldsigffext_enabledSignedInfo(enableForSig)
{
    dump("xmldsigffext_enabledSignedInfo():................Start.\n");

    var disabledForSig = !enableForSig;

    gXmlVerifyCredentialTypePasswordElem.disabled = disabledForSig;
    gXmlVerifyCredentialTypeCertElem.disabled = disabledForSig;
    gXmlVerifySigCanonMethodMenuElem.disabled = disabledForSig;
    // gXmlVerifySigMethodMenuElem.disabled = disabledForSig;
    gXmlVerifySigHashAlgMenuElem.disabled = disabledForSig;
    gXmlVerifySigHashAlgMenuElem.setAttribute("disabled", ("" + disabledForSig));
    gXmlVerifySigTypeMenuElem.disabled = disabledForSig;

    gXmlVerifyKeyInfoRowElem.hidden = !enableForSig;

    if (enableForSig) {
	gXmlVerifyParamSignerCertRowElem.hidden = false;
	gXmlVerifyDocSignerCertRowElem.hidden = true;
    }
    else {
    	gXmlVerifyParamSignerCertRowElem.hidden = true;
    	gXmlVerifyDocSignerCertRowElem.hidden = false;
    }
    // gXmlVerifyResultRowElem.hidden = enableForSig;

    if (enableForSig) {
	gXmlVerifyParamSignerCertRowElem.hidden = false;
	gXmlVerifySignerCertMenuListElem.hidden = false;

	gXmlVerifyDocSignerCertElem.hidden = true;;
	gXmlVerifyDocSignerCertRowElem.hidden = true;;

    }
    else {
	gXmlVerifyParamSignerCertRowElem.hidden = true;
	gXmlVerifySignerCertMenuListElem.hidden = true;
	gXmlVerifySignerCertMenuListElem.value = "";

	gXmlVerifyDocSignerCertRowElem.hidden = false;;
	gXmlVerifyDocSignerCertElem.hidden = false;;
	gXmlVerifyDocSignerCertElem.cert = null;;

    	// xmldsigffext_enableForVerify();
    }
    dump("xmldsigffext_enabledSignedInfo():................80.\n");

    if (!gXmlVerifyUserCredentialTypeGroupElem.selectedItem) {
    	gXmlVerifyUserCredentialTypeGroupElem.selectedItem = gXmlVerifyCredentialTypeCertElem;
    }
    xmldsigffext_handleCredentialTypeChange(
    		gXmlVerifyUserCredentialTypeGroupElem,
		gXmlVerifyUserCredentialTypeGroupElem.selectedItem
		);

    dump("xmldsigffext_enabledSignedInfo():................End.\n");
}


function xmldsigffextsig_signedXmlDocFileHandler(xmlDoc)
{
    dump("xmldsigffextsig_signedXmlDocFileHandler():................Start.\n");

    xmldsigffext_enabledSignedInfo(false);

    /*
    gXmlVerifyUserCredentialTypeRowElem.hidden = true;
    */
    gXmlVerifyUserInfoRowElem.hidden = true;

    gXmlVerifyParamSignerCertRowElem.hidden = true;
    gXmlVerifyDocSignerCertRowElem.hidden = true;

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var /* nsINodeList */ xmlDocSigElemList = xmlDoc.getElementsByTagName("Signature");
    if (!xmlDocSigElemList || (xmlDocSigElemList.length == 0)) {
    	alert("xmldsigffextsig_signedXmlDocFileHandler(): Not a valid Signed XML file - no Signature element.\n");
    	dump("xmldsigffextsig_signedXmlDocFileHandler(): Not a valid Signed XML file - no Signature element.\n");
    	return;
    }
    var xmlDocSigElem = xmlDocSigElemList.item(0);

    var isEnvelopingSignature = false;
    if (xmlDoc.documentElement.tagName.indexOf("Signature") >= 0) {
    	 isEnvelopingSignature = true;
    }

/*
<ds:SignedInfo>
<ds:CanonicalizationMethod Algorithm="http://www.w3.org/TR/2001/REC-xml-c14n-20010315"/>
<ds:SignatureMethod Algorithm="http://www.w3.org/2000/09/xmldsig#hmac-sha1"/>
<ds:Reference URI="#ObjectId_1053011544">
<ds:DigestMethod Algorithm="http://www.w3.org/2000/09/xmldsig#sha1"/>
<ds:DigestValue>lu0xrClrKjlZi+0+hZa6HaHzzgA=</ds:DigestValue>
</ds:Reference>
</ds:SignedInfo>
*/
    var xmlDocSignedInfoElemList = xmlDocSigElem.getElementsByTagName("SignedInfo");
    if (!xmlDocSignedInfoElemList || (xmlDocSignedInfoElemList.length == 0)) {
    	alert("xmldsigffextsig_signedXmlDocFileHandler(): Not a valid Signed XML file - no SignedInfo element.\n");
    	dump("xmldsigffextsig_signedXmlDocFileHandler(): Not a valid Signed XML file - no SignedInfo element.\n");
    	return;
    }
    var xmlDocSignedInfoElem = xmlDocSignedInfoElemList.item(0);
    // gXmlVerifyUserCredentialTypeRowElem.hidden = false;

    var xmlDocCanonMethodAlgorithmURI = xmldsigffext_getXmlDocElemAttribute(xmlDocSignedInfoElem, "CanonicalizationMethod", "Algorithm");
    if (!xmlDocCanonMethodAlgorithmURI) {
    	alert("xmldsigffextsig_signedXmlDocFileHandler(): Not a valid Signed XML file - no CanonicalizationMethod element.\n");
    	dump("xmldsigffextsig_signedXmlDocFileHandler(): Not a valid Signed XML file - no CanonicalizationMethod element.\n");
    }
    var xulSigCanonAlg = xmldsigffext_sigCanonicalAlg2XULMap(xmlDocCanonMethodAlgorithmURI);
    dump("xmldsigffextsig_signedXmlDocFileHandler(): xmlDocCanonMethodAlgorithmURI: " + xmlDocCanonMethodAlgorithmURI + " ==> xulSigCanonAlg: " + xulSigCanonAlg + "\n");
    // gXmlVerifySigCanonMethodMenuElem.value = xulSigCanonAlg.toUpperCase();
    gXmlVerifySigCanonMethodMenuElem.value = xulSigCanonAlg;

    var xmlDocDigestMethodAlgorithmURI = xmldsigffext_getXmlDocElemAttribute(xmlDocSignedInfoElem, "DigestMethod", "Algorithm");
    if (!xmlDocDigestMethodAlgorithmURI) {
    	alert("xmldsigffextsig_signedXmlDocFileHandler(): Not a valid Signed XML file - no DigestMethod element.\n");
    	dump("xmldsigffextsig_signedXmlDocFileHandler(): Not a valid Signed XML file - no DigestMethod element.\n");
    }
    var hashMethodURICompList = xmlDocDigestMethodAlgorithmURI.split("#")
    var xmlDocDigestMethodAlgorithm = hashMethodURICompList[1].toUpperCase();
    dump("xmldsigffextsig_signedXmlDocFileHandler(): xmlDocDigestMethodAlgorithmURI: " + xmlDocDigestMethodAlgorithmURI + " ==> xmlDocDigestMethodAlgorithm: " + xmlDocDigestMethodAlgorithm + "\n");
    gXmlVerifySigHashAlgMenuElem.value = xmlDocDigestMethodAlgorithm;

    var xmlDocSigMethodAlgorithmURI = xmldsigffext_getXmlDocElemAttribute(xmlDocSignedInfoElem, "SignatureMethod", "Algorithm");
    if (!xmlDocSigMethodAlgorithmURI) {
    	alert("xmldsigffextsig_signedXmlDocFileHandler(): Not a valid Signed XML file - no SignatureMethod element.\n");
    	dump("xmldsigffextsig_signedXmlDocFileHandler(): Not a valid Signed XML file - no SignatureMethod element.\n");
    }
    var xulSigMethodAlg = xmldsigffext_sigMethodAlg2XULMap(xmlDocSigMethodAlgorithmURI);
    // gXmlVerifySigMethodMenuElem.value = xulSigMethodAlg;

    var isEnvelopedSignature = false;
    if (!isEnvelopingSignature) {
    	isEnvelopedSignature = xmldsigffext_isEnvelopedSignature(xmlDocSignedInfoElem);
    }
    var signatureType = "ENVELOPED_SIGNATURE";
    if (!isEnvelopedSignature) {
	if (isEnvelopingSignature) {
    	    signatureType = "ENVELOPING_SIGNATURE";
	}
	else {
    	    signatureType = "DETACHED_SIGNATURE";
	}
    }
    gXmlVerifySigTypeMenuElem.value = signatureType;


    var credentialType = "certificate";
    var isHmacSig = xmldsigffext_isHmacSig(xmlDocSigMethodAlgorithmURI);
    dump("xmldsigffextsig_signedXmlDocFileHandler(): xmlDocSigMethodAlgorithmURI: " + xmlDocSigMethodAlgorithmURI + " ==> isHmacSig: " + isHmacSig + "\n");
    if (isHmacSig) {
    	credentialType = "password";
    	gXmlVerifyUserCredentialTypeGroupElem.selectedItem = gXmlVerifyCredentialTypePasswordElem;
    	gXmlVerifyUserInfoRowElem.hidden = false;
    	gXmlVerifyParamSignerCertRowElem.hidden = true;
    	gXmlVerifyDocSignerCertRowElem.hidden = true;
    }
    else {
    	gXmlVerifyUserCredentialTypeGroupElem.selectedItem = gXmlVerifyCredentialTypeCertElem;

    	gXmlVerifyUserInfoRowElem.hidden = true;

	var x509Cert = null;
	x509Cert = xmldsigffext_extractX509CertFromKeyInfo(xmlDocSigElem);
	if (x509Cert) {
    	    gXmlVerifyDocSignerCertRowElem.hidden = false;
	    gXmlVerifyDocSignerCertElem.cert = x509Cert;

    	    gXmlVerifyParamSignerCertRowElem.hidden = true;
	    gXmlVerifySignerCertMenuListElem.hidden = true;
	    gXmlVerifySignerCertMenuListElem.value = "";
	}
	else {
    	    gXmlVerifyParamSignerCertRowElem.hidden = false;
	    gXmlVerifySignerCertMenuListElem.hidden = false;
	    gXmlVerifySignerCertMenuListElem.disabled = false;
	    gXmlVerifySignerCertMenuListElem.value = "";

    	    gXmlVerifyDocSignerCertRowElem.hidden = true;
	    gXmlVerifyDocSignerCertElem.cert = null;
	}
    }
    dump("xmldsigffext_xmlDocFileChangeHandler(): credentialType: " + credentialType + ".\n");

    dump("xmldsigffextsig_signedXmlDocFileHandler():................End.\n");
}

/* nsIX509Cert */
function xmldsigffext_extractX509CertFromKeyInfo(xmlDocSigElem)
{

    dump("xmldsigffext_extractX509CertFromKeyInfo():................Start.\n");

    var /* nsIX509Cert */ x509Cert = null;
    var keyInfoElem = xmldsigffext_getFirstXmlDocElem(xmlDocSigElem, "KeyInfo");
    if (keyInfoElem) {
	try {
	    x509Cert = gX509CertDBUtil.findX509CertByKeyInfo(keyInfoElem);
	} catch(ex) {
    	    dump("xmldsigffext_extractX509CertFromKeyInfo(): gX509CertDBUtil.findX509CertByKeyInfo() failed - ex: " + ex +  "\n");
	    x509Cert = null;
	}
    }

    /*
    var x509CertElem = xmldsigffext_getFirstXmlDocElem(xmlDocSigElem, "X509Certificate");
    var keyNameElem = xmldsigffext_getFirstXmlDocElem(xmlDocSigElem, "KeyName");
    if (x509CertElem) {
    	var x509CertBase64 = x509CertElem.firstChild.nodeValue;
	// x509CertBase64 = "-----BEGIN CERTIFICATE-----\n" + x509CertBase64 + "\n-----END CERTIFICATE-----\n";
    	dump("xmldsigffext_extractX509CertFromKeyInfo():x509CertBase64: >>>\n" + x509CertBase64 + "<<<\n");
	try {
	    x509Cert = gCertDB.constructX509FromBase64(x509CertBase64);
	} catch(ex) {
    	    dump("xmldsigffext_extractX509CertFromKeyInfo(): gCertDB.constructX509FromBase64() failed - ex: " + ex +  "\n");
	    x509Cert = null;
	}
    	dump("xmldsigffext_extractX509CertFromKeyInfo():x509Cert: " + x509Cert + "\n");
    	dump("xmldsigffext_extractX509CertFromKeyInfo():................20.\n");
    }

    if (!x509Cert && keyNameElem) {
    	var subjName = keyNameElem.firstChild.nodeValue;
    	dump("xmldsigffext_extractX509CertFromKeyInfo():subjName: " + subjName + "\n");
	try {
	    x509Cert = gXmlDSigTool.findX509CertBySubjectName(subjName);
	} catch(ex) {
	    x509Cert = null;
	}
    }
    */

    dump("xmldsigffext_extractX509CertFromKeyInfo():x509Cert: " + x509Cert + "\n");
    /*
    if (x509Cert) {
    	dump("xmldsigffext_extractX509CertFromKeyInfo():x509Cert.dbKey: " + x509Cert.dbKey + "\n");
    }
    */

    dump("xmldsigffext_extractX509CertFromKeyInfo():................End.\n");
    return x509Cert;
}

function xmldsigffext_getUserPassword()
{
    return gXmlVerifyUserPasswordElem.value;
}

function xmldsigffext_getXmlDocSignerCert()
{
    return gXmlVerifyDocSignerCertElem.cert;
}

function xmldsigffext_showXmlDocSignerCert(signerCert)
{
    xmldsigffext_setXmlDocSignerCert(signerCert);

    gXmlVerifyParamSignerCertRowElem.hidden = true;
    gXmlVerifySignerCertMenuListElem.hidden = true;
}

function xmldsigffext_setXmlDocSignerCert(signerCert)
{
    gXmlVerifyDocSignerCertElem.cert = signerCert;
    gXmlVerifyDocSignerCertElem.hidden = false;
    gXmlVerifyDocSignerCertRowElem.hidden = false;
}


function xmldsigffext_NickNameMenuListChanged(menuListElem, selectedItemElem, certItemPrefix)
{
    /*
    dump("xmldsigffext_NickNameMenuListChanged():................Start.\n");
    dump("xmldsigffext_NickNameMenuListChanged():................End.\n");
    */
}

function xmldsigffext_SignerNickNameMenuListChanged(menuListElem, selectedItemElem, certItemPrefix)
{
    dump("xmldsigffext_SignerNickNameMenuListChanged():................Start.\n");

    // xmldsigffext_NickNameMenuListChanged(menuListElem, selectedItemElem, certItemPrefix);
    // dump("xmldsigffext_SignerNickNameMenuListChanged():................10.\n");

    var selectedCert = menuListElem.getSelectedCert();
    dump("xmldsigffext_SignerNickNameMenuListChanged(): selectedCert: " + selectedCert + ".\n");
    if (!selectedCert) {
    	return;
    }
    dump("xmldsigffext_SignerNickNameMenuListChanged():................20.\n");
    dump("xmldsigffext_SignerNickNameMenuListChanged(): selectedCert: " + selectedCert + "\n");

    var keyType = gSamlTokenSvc.getCertKeyType(selectedCert);
    dump("xmldsigffext_SignerNickNameMenuListChanged():................30.\n");
    switch(keyType) {
    	case Components.interfaces.alrIXPSamlTokenSvc.KeyType_rsaKey: 
	    gXmlVerifySigMethodMenuElem.value = "RSA";
	    // gXmlVerifySigMethodMenuElem.disabled = true;
	    break;
    	case Components.interfaces.alrIXPSamlTokenSvc.KeyType_dsaKey: 
	    gXmlVerifySigMethodMenuElem.value = "DSA";
	    // gXmlVerifySigMethodMenuElem.disabled = true;
	    break;
    }

    dump("xmldsigffext_SignerNickNameMenuListChanged():................End.\n");
}

function xmldsigffext_addSignerMenuListEventListener(signerMenuListEventHandler)
{
    gXmlVerifySignerCertMenuListElem.addEventListener('command', signerMenuListEventHandler, false);
}

function xmldsigffext_getSelectedSignerCert()
{
    dump("xmldsigffext_getSelectedSignerCert():................Start.\n");
    var selectedCert = gXmlVerifySignerCertMenuListElem.getSelectedCert();
    dump("xmldsigffext_getSelectedSignerCert(): selectedCert: " + selectedCert + "\n");
    if (!selectedCert) {
    	selectedCert = gXmlVerifyDocSignerCertElem.cert;
    	dump("xmldsigffext_getSelectedSignerCert(): selectedCert: " + selectedCert + "\n");
    }
    dump("xmldsigffext_getSelectedSignerCert():................End.\n");
    return selectedCert;
}

function xmldsigffext_getSignerName()
{
    var defaultSignerName = "DummySigner";
    var signerName = "";
    if (gXmlVerifyUserCredentialTypeGroupElem.selectedItem.value == "certificate") {
	signerName = xmldsigffext_getSelectedSignerCertNickName();
    }
    else if (gXmlVerifyUserCredentialTypeGroupElem.selectedItem.value == "password") {
	signerName = trimString(gXmlVerifyUserNameElem.value);
    }
    if (signerName == "") {
    	signerName = defaultSignerName;
    }
    return signerName;
}

function xmldsigffext_getSelectedSignerCertNickName()
{
    var selectedCert = gXmlVerifySignerCertMenuListElem.getSelectedCert();
    if (selectedCert) {
    	return selectedCert.nickname;
    }
    return gXmlVerifySignerCertMenuListElem.value;
}

function xmldsigffext_onXmlCanonMethodChange(canonMethoMenuElem, selectedItem)
{
    dump("xmldsigffext_onXmlCanonMethodChange():..................Start.\n");
    dump("canonMethoMenuElem: " + canonMethoMenuElem.id + " value: " + canonMethoMenuElem.value + "\n");
}

function xmldsigffext_onSigMethodChange(sigMethodMenuElem, selectedItem)
{
    dump("xmldsigffext_onSigMethodChange():..................Start.\n");
    dump("sigMethodMenuElem: " + sigMethodMenuElem.id + " value: " + sigMethodMenuElem.value + "\n");
}

function xmldsigffext_onSigHashAlgorithmChange(sigHashAlgMenuElem, originalTargetElem)
{
    dump("xmldsigffext_onSigHashAlgorithmChange():..................Start.\n");
    dump("sigHashAlgMenuElem: " + sigHashAlgMenuElem.id + " value: " + sigHashAlgMenuElem.value + "\n");
}

function xmldsigffext_onSignatureTypeChange(signatureTypeMenuElem, selectedItem)
{
    dump("xmldsigffext_onSignatureTypeChange():..................Start.\n");
    dump("transformTypeMenuElem: " + signatureTypeMenuElem.id + " value: " + signatureTypeMenuElem.value + "\n");
}

function xmldsigffext_getSelectedSignatureType()
{
    return gXmlVerifySigTypeMenuElem.value;
}


function xmldsigffext_onTransformTypeChange(transformTypeElem, transformTypeValueElemId)
{
    dump("xmldsigffext_onTransformTypeChange():..................Start.\n");
    dump("transformTypeMenuElem: " + transformTypeElem.id +
			" transformTypeValueElemId: " + (transformTypeValueElemId?transformTypeValueElemId:"null") +
			"\n");
    if (!transformTypeValueElemId) {
    	return;
    }

    var transformTypeValueElem = document.getElementById(transformTypeValueElemId); 
    if ("xmldsigffext.form.sign.params.transform.type.none" == transformTypeElem.id) {
    	transformTypeValueElem.hidden = true;
    }
    else {
    	transformTypeValueElem.hidden = false;
    }
}



function xmldsigffext_getFirstXmlDocElem(docElem, elemTag)
{
    var docElemList = docElem.getElementsByTagName(elemTag);
    if (!docElemList || (docElemList.length == 0)) {
	dump("xmldsigffext_getXmlDocElemAttribute(): couldn't find elemTag: " + elemTag + "\n");
    	return null;
    }
    var slectedDocElem = docElemList.item(0);
    return slectedDocElem;
}

function xmldsigffext_getXmlDocElemAttribute(docElem, elemTag, elemAttributeName)
{
    var slectedDocElem = xmldsigffext_getFirstXmlDocElem(docElem, elemTag);
    if (!slectedDocElem) {
    	return null;
    }
    var docElemAttribValue = slectedDocElem.getAttribute(elemAttributeName);
    return docElemAttribValue;
}

function xmldsigffext_getXmlDocElemChildByAttrNVP(docElem, elemAttrId, elemAttrValue)
{
    var elemChildNodeList = docElem.childNodes;
    if (elemChildNodeList.length == 0) {
    	return null;
    }
    for (var i = 0; i < elemChildNodeList.length; i++) {
        var elemNode = elemChildNodeList.item(i);
	if (!elemNode) {
	    continue;
	}
	var /* nsIDOMElement */ elemChild = null;
	try {
	    elemChild = elemNode.QueryInterface(Components.interfaces.nsIDOMElement);
	} catch (ex) {
	    continue;
	}
	dump("elemNode: " + elemNode + " tag: " + elemNode.nodeName + "\n");
	if (elemChild.getAttribute(elemAttrId) == elemAttrValue) {
	    return elemChild;
	}
    }
    return null;
}

/* nsIDOMDocument  */
function xmldsigffext_signXMLDocWithSharedKey(/* nsIDOMDocument  */ xmlDoc, /* nsIPersistentProperties */ xmlSignatureProps)
{
    dump("xmldsigffext_signXMLDocWithSharedKey():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var outSignedXmlDoc = null;
    try {
    	outSignedXmlDoc = gXmlDSigTool.signXMLDocBySharedKey(xmlDoc, xmlSignatureProps);
    } catch (ex) {
    	// alert("xmldsigffext_signXMLFileWithSharedKey(): failed to create signed XML file - ex : " + ex + "\n");
    	dump("xmldsigffext_signXMLDocWithSharedKey(): failed to create signed XML file - ex : " + ex + "\n");
	throw ex;
    }

    dump("xmldsigffext_signXMLDocWithSharedKey():................End.\n");

    return outSignedXmlDoc;

}


/* nsIDOMDocument  */
function xmldsigffext_signXMLDocWithCert(/* nsIDOMDocument  */ xmlDoc, /* nsIX509Cert */ signerCert, /* nsIPersistentProperties */ xmlSignatureProps)
{
    dump("xmldsigffext_signXMLDocWithCert():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var outSignedXmlDoc = null;
    try {
    	// Force token login - on windows the popup window for password is not coming up
    	xmldsigffext_loginToCertToken(signerCert);
    	outSignedXmlDoc = gXmlDSigTool.signXMLDocByX509Cert(xmlDoc, signerCert, xmlSignatureProps);
    } catch (ex) {
    	alert("xmldsigffext_signXMLDocWithCert(): failed to sign XML file - ex : " + ex + "\n");
    	dump("xmldsigffext_signXMLDocWithCert(): failed to sign XML file - ex : " + ex + "\n");
	throw ex;
    }

    dump("xmldsigffext_signXMLDocWithCert():................End.\n");

    return outSignedXmlDoc;
}


/* nsIDOMDocument */
function xmldsigffext_signXMLDoc(xmlDSigParamRootElemId)
{
    var signedXmlDoc = null;
    // var signedXmlDoc = xmldsigffext_signXMLDoc(gXmlVerifyInputFilePickerElem.xmlDoc, xmlDSigParamRootElemId);

    var xmlDoc = gXmlVerifyInputFilePickerElem.xmlDoc;

    var /* nsIPersistentProperties */ xmlSignatureProps = getSignatureFormProperties(xmlDSigParamRootElemId);
    if (gXmlVerifyUserCredentialTypeGroupElem.selectedItem.value == "certificate") {
        var /* nsIX509Cert */ signerCert;
        signerCert = xmldsigffext_getSelectedSignerCert();
        if (signerCert == null) {
    	    dump("xmldsigffext_signXMLDoc(): null signerCert.\n");
    	    alert("xmldsigffext_signXMLDoc(): null signerCert.\n");
    	    return null;
        }
        dump("xmldsigffext_signXMLDoc():................20.\n");
    	signedXmlDoc = xmldsigffext_signXMLDocWithCert(xmlDoc, signerCert, xmlSignatureProps);
    }
    else if (gXmlVerifyUserCredentialTypeGroupElem.selectedItem.value == "password") {
        var sharedKey = gXmlVerifyUserPasswordElem.value;
        if (sharedKey.length == 0) {
    	    alert("xmldsigffext_signXMLDoc(): shared key is missing.\n");
    	    dump("xmldsigffext_signXMLDoc(): shared key is missing.\n");
    	    return null;
        }
    	signedXmlDoc = xmldsigffext_signXMLDocWithSharedKey(xmlDoc, xmlSignatureProps);
    }
    else {
    	signedXmlDoc = null;
    }
    if (!signedXmlDoc) {
    	return null;
    }
    return signedXmlDoc;
}

/* nsIDOMDocument */
function xmldsigffext_signXMLDocToFile(xmlDSigParamRootElemId)
{
    dump("xmldsigffext_signXMLDocToFile():................Start.\n");

    // Select path to the signed XML File 
    var /* nsILocalFile */ outSignedXmlDocFile = null;
    if (gXmlVerifySignedOutFilePickerElem.value == "") {
	xmldsigffext_autoSelectOutSignedFile(gXmlVerifyInputFilePickerElem.file);
    }
    outSignedXmlDocFile = gXmlVerifySignedOutFilePickerElem.file;
    if (outSignedXmlDocFile == null) {
    	dump("xmldsigffext_signXMLDocToFile(): failed to get outSignedXmlDocFile.\n");
        return signedXmlDoc;
    }
    dump("xmldsigffext_signXMLDocToFile(): outSignedXmlDocFile: " + outSignedXmlDocFile.path + "\n");


    // Create signed XML doc 
    var /* nsIDOMDocument */ signedXmlDoc = null;
    signedXmlDoc = xmldsigffext_signXMLDoc(xmlDSigParamRootElemId);
    if (!signedXmlDoc) {
    	return null;
    }

    // Save signed XML doc 

    var signedXmlDocStr = gXmlSerializer.serializeToString(signedXmlDoc);
    gXmlVerifySignedOutFilePickerElem.saveFile(signedXmlDocStr);
    gXmlVerifySignedOutFilePickerElem.refresh();

    dump("xmldsigffext_signXMLDocToFile():................End.\n");
    return signedXmlDoc;
}

function xmldsigffextsig_verifySignedXMLFile(xmlDSigParamRootElemId)
{
    dump("xmldsigffextsig_verifySignedXMLFile():................Start.\n");

    // var xmlSignatureProps = getSignatureFormProperties("xmldsigffext.form.tabpanel.sign");
    var /* nsIPersistentProperties */ xmlSignatureProps = getSignatureFormProperties(xmlDSigParamRootElemId);

    var isPassed = false;
    if (gXmlVerifyUserCredentialTypeGroupElem.selectedItem.value == "certificate") {
    	isPassed = xmldsigffextsig_verifySignedXMLFileWithX509Cert(xmlSignatureProps);
    }
    else {
    	isPassed = xmldsigffextsig_verifySignedXMLFileWithSharedKey(xmlSignatureProps);
    }

    dump("xmldsigffextsig_verifySignedXMLFile():................End.\n");
    return isPassed;
}

function xmldsigffextsig_verifySignedXMLFileWithSharedKey(xmlSignatureProps)
{
    dump("xmldsigffextsig_verifySignedXMLFileWithSharedKey():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var signedXmlFile = gXmlVerifyInputFilePickerElem.file;

    var sharedKey = gXmlVerifyUserPasswordElem.value;
    if (sharedKey == "") {
	alert("Password is missing - enter a password.");
    	return false;
    }

    var isPassed = false;
    try {
    	/*
        boolean verifySignedXMLFileByX509Cert(
	    	in nsILocalFile aSignedXmlFile,
		in AString sharedKey,
		in nsIPersistentProperties aSignatureProps
		);
	*/
    	isPassed = gXmlDSigTool.verifySignedXMLFileBySharedKey(
                        signedXmlFile,
			sharedKey,
			xmlSignatureProps
                        );
    } catch (ex) {
    	dump("xmldsigffextsig_verifySignedXMLFileWithSharedKey to verify signed XML file - ex : " + ex + "\n");
	throw ex;
    }

    dump("xmldsigffextsig_verifySignedXMLFileWithSharedKey():................Start.\n");
    return isPassed;
}

function xmldsigffextsig_verifySignedXMLFileWithX509Cert(xmlSignatureProps)
{
    dump("xmldsigffextsig_verifySignedXMLFileWithX509Cert():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var signedXmlFile = gXmlVerifyInputFilePickerElem.file;

    var /* nsIX509Cert */ signerCert = null;
    var signerCertObj = new Object();
    var isPassed = false;
    try {
    	/*
        boolean verifySignedXMLFileByX509Cert(
	    	in nsILocalFile aSignedXmlFile,
		inout nsIX509Cert aOutSignerCert,
		in nsIPersistentProperties aSignatureProps
		);
	*/
        signerCert = xmldsigffext_getSelectedSignerCert();
        // signerCert = gXmlVerifyDocSignerCertElem.cert;
	signerCertObj.value = signerCert;
    	isPassed = gXmlDSigTool.verifySignedXMLFileByX509Cert(
                        signedXmlFile,
			signerCertObj,
			xmlSignatureProps
                        );
    } catch (ex) {
    	dump("xmldsigffextsig_verifySignedXMLFileWithX509Cert(): failed to verify signed XML file - ex : " + ex + "\n");
	throw ex;
    }
    if (!signerCert) {
    	gXmlVerifyDocSignerCertElem.cert = signerCertObj.value;
	gXmlVerifyDocSignerCertElem.hidden = false;
	gXmlVerifyDocSignerCertRowElem.hidden = false;
    }

    dump("xmldsigffextsig_verifySignedXMLFileWithX509Cert():................End.\n");
    return isPassed;
}

function xmldsigffextsig_verifySignedXMLDoc(xmlDSigParamRootElemId)
{
    dump("xmldsigffextsig_verifySignedXMLDoc():................Start.\n");

    var /* nsIPersistentProperties */ xmlSignatureProps = getSignatureFormProperties(xmlDSigParamRootElemId);
    var /* nsIDOMDocument */ signedXmlDoc = gXmlVerifyInputFilePickerElem.xmlDoc;

    var isPassed = false;
    if (gXmlVerifyUserCredentialTypeGroupElem.selectedItem.value == "certificate") {
    	isPassed = xmldsigffextsig_verifySignedXMLDocByX509Cert(signedXmlDoc, xmlSignatureProps);
    }
    else {
    	isPassed = xmldsigffextsig_verifySignedXMLDocWithSharedKey(signedXmlDoc, xmlSignatureProps);
    }

    dump("xmldsigffextsig_verifySignedXMLDoc():................End.\n");
    return isPassed;
}

function xmldsigffextsig_verifySignedXMLDocWithSharedKey(signedXmlDoc, xmlSignatureProps)
{
    dump("xmldsigffextsig_verifySignedXMLDocWithSharedKey():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var sharedKey = gXmlVerifyUserPasswordElem.value;
    if (sharedKey == "") {
	alert("Password is missing - enter a password.");
    	return false;
    }

    var isPassed = false;
    try {
        /*
    	boolean verifySignedXMLDocBySharedKey(
                in nsIDOMDocument aSignedXmlDoc,
		in AString sharedKey,
                in nsIPersistentProperties aSignatureProps
                );
	*/
    	isPassed = gXmlDSigTool.verifySignedXMLDocBySharedKey(
                        signedXmlDoc,
			sharedKey,
			xmlSignatureProps
                        );
    } catch (ex) {
    	dump("xmldsigffextsig_verifySignedXMLDocWithSharedKey(): failed to verify signed archive file - ex : " + ex + "\n");
	throw ex;
    }

    dump("xmldsigffextsig_verifySignedXMLDocWithSharedKey():................End.\n");
    return isPassed;
}

function xmldsigffextsig_verifySignedXMLDocByX509Cert(signedXmlDoc, xmlSignatureProps)
{
    dump("xmldsigffextsig_verifySignedXMLDocByX509Cert():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var /* nsIX509Cert */ signerCert = null;
    var signerCertObj = new Object();
    var isPassed = false;
    try {
        /*
    	boolean verifySignedXMLDocByX509Cert(
                in nsIDOMDocument aSignedXmlDoc,
                inout nsIX509Cert aOutSignerCert,
                in nsIPersistentProperties aSignatureProps
                );

	*/
        // signerCert = gXmlVerifyDocSignerCertElem.cert;
        signerCert = xmldsigffext_getSelectedSignerCert();
    	dump("xmldsigffextsig_verifySignedXMLDocByX509Cert(): signerCert: " + signerCert + "\n");
	signerCertObj.value = signerCert;

    	isPassed = gXmlDSigTool.verifySignedXMLDocByX509Cert(
                        signedXmlDoc,
			signerCertObj,
			xmlSignatureProps
                        );
    } catch (ex) {
    	dump("xmldsigffextsig_verifySignedXMLDocByX509Cert(): failed to verify signed archive file - ex : " + ex + "\n");
	throw ex;
    }
    if (!signerCert) {
    	dump("xmldsigffextsig_verifySignedXMLDocByX509Cert(): signerCertObj.value: " + signerCertObj.value + "\n");
    	gXmlVerifyDocSignerCertElem.cert = signerCertObj.value;
	gXmlVerifyDocSignerCertElem.hidden = false;
    }

    dump("xmldsigffextsig_verifySignedXMLDocByX509Cert():................End.\n");
    return isPassed;
}

function xmldsigffext_autoSelectOutSignedFile(/* nsILocalFile */ inputXMLFile)
{
    var outSignedFileName = null;
    // var inputXMLFile = null;
    // inputXMLFile = gXmlVerifyInputFilePickerElem.file;
    /*
    if (inputXMLFile == null) {
    	return null;
    }
    var inputXMLFileName = "TmpXMLFile.xml";
    */

    outSignedFileName = "TmpXMLFile.xml";
    if (inputXMLFile) {
    	outSignedFileName = inputXMLFile.leafName;
	// gXmlVerifySignedOutFilePickerElem.value = inputXMLFile.path;
    }

    if (outSignedFileName.indexOf("_SIGNATURE") < 0) {
	// _SIGNATURE is part of Canonical method which is used to create default file name
	var credentialType = gXmlVerifyUserCredentialTypeGroupElem.selectedItem.value;
	var signerName = null;
	if (credentialType == "certificate") {
	    var signerCert = xmldsigffext_getSelectedSignerCert();
	    signerName = (signerCert?signerCert.nickname:"UserX");
	}
	else {
	    signerName = gXmlVerifyUserNameElem.value;
	}
    	outSignedFileName = gXmlVerifySigTypeMenuElem.value +
    			"_" + gXmlVerifyUserCredentialTypeGroupElem.selectedItem.value +
    			"_" + gXmlVerifySigCanonMethodMenuElem.value +
    			"_" + (signerName?signerName:"UserX") +
			"_" + inputXMLFile.leafName;
    }
    
    return xmldsigffext_autoSelectOutFile(gXmlVerifySignedOutFilePickerElem, outSignedFileName);
}

function xmldsigffext_signXMLFile(xmlDSigParamRootElemId)
{
    dump("xmldsigffext_signXMLFile():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
    netscape.security.PrivilegeManager.enablePrivilege("UniversalFileRead");

    // var xmlSignatureProps = getSignatureFormProperties("xmldsigffext.form.tabpanel.sign");
    var /* nsIPersistentProperties */ xmlSignatureProps = getSignatureFormProperties(xmlDSigParamRootElemId);

    var /* nsILocalFile */ inputXMLFile = gXmlVerifyInputFilePickerElem.file;
    if (inputXMLFile == null) {
    	dump("xmldsigffext_signXMLFile(): No input XML file is selected.\n");
    	alert("xmldsigffext_signXMLFile(): No input XML file is selected.\n");
    	return null;
    }

    var /* nsILocalFile */ outSignedXMLFile = null;
    if (gXmlVerifySignedOutFilePickerElem.value == "") {
	xmldsigffext_autoSelectOutSignedFile(inputXMLFile);
    }
    outSignedXMLFile = gXmlVerifySignedOutFilePickerElem.file;
    if (outSignedXMLFile == null) {
    	dump("xmldsigffext_signXMLFile(): failed to get outSignedXMLFile.\n");
    	alert("xmldsigffext_signXMLFile(): failed to get outSignedXMLFile.\n");
        return null;
    }
    dump("xmldsigffext_signXMLFile(): outSignedXMLFile: " + outSignedXMLFile.path + "\n");


    if (gXmlVerifyUserCredentialTypeGroupElem.selectedItem.value == "certificate") {
    	outSignedXMLFile = xmldsigffext_signXMLFileWithCert(xmlSignatureProps);
    }
    else if (gXmlVerifyUserCredentialTypeGroupElem.selectedItem.value == "password") {
        var sharedKey = gXmlVerifyUserPasswordElem.value;
        if (sharedKey.length == 0) {
    	    alert("xmldsigffext_signXMLFileWithSharedKey(): shared key is missing.\n");
    	    dump("xmldsigffext_signXMLFileWithSharedKey(): shared key is missing.\n");
    	    return null;
        }
    	outSignedXMLFile = xmldsigffext_signXMLFileWithSharedKey(xmlSignatureProps);
    }
    else {
    	outSignedXMLFile = null;
    }

    if (!outSignedXMLFile) {
    	dump("xmldsigffext_signXMLFile(): failed to sign input XML file.\n");
	return null;
    }

    gXmlVerifySignedOutFilePickerElem.refresh();
    outSignedXMLFile = gXmlVerifySignedOutFilePickerElem.file;
    if (!outSignedXMLFile || !outSignedXMLFile.exists() || (outSignedXMLFile.fileSize <= 0)) {
    	dump("xmldsigffext_signXMLFile(): failed to create Signed XML file.\n");
    	// alert("xmldsigffext_signXMLFile(): failed to create Signed XML file.\n");
	return null;
    }

    dump("xmldsigffext_signXMLFile():................End.\n");

    return gXmlVerifySignedOutFilePickerElem.file;
}

function xmldsigffext_signXMLFileWithSharedKey(/* nsIPersistentProperties */ xmlSignatureProps)
{
    dump("xmldsigffext_signXMLFileWithSharedKey():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var /* nsILocalFile */ inputXMLFile = gXmlVerifyInputFilePickerElem.file;
    if (inputXMLFile == null) {
    	dump("xmldsigffext_signXMLFileWithSharedKey(): No input XML file is selected.\n");
    	return null;
    }

    var /* nsILocalFile */ outSignedXMLFile = gXmlVerifySignedOutFilePickerElem.file;
    if (outSignedXMLFile == null) {
    	dump("xmldsigffext_signXMLFileWithSharedKey(): failed to get outSignedXMLFile.\n");
        return null;
    }

    try {
    	gXmlDSigTool.signXMLFileBySharedKey(inputXMLFile, xmlSignatureProps, outSignedXMLFile);
    } catch (ex) {
    	// alert("xmldsigffext_signXMLFileWithSharedKey(): failed to create signed XML file - ex : " + ex + "\n");
    	dump("xmldsigffext_signXMLFileWithSharedKey(): failed to create signed XML file - ex : " + ex + "\n");
	throw ex;
    }

    dump("xmldsigffext_signXMLFileWithSharedKey():................End.\n");

    return outSignedXMLFile;
}

function xmldsigffext_signXMLFileWithCert(/* nsIPersistentProperties */ xmlSignatureProps)
{
    dump("xmldsigffext_signXMLFileWithCert():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
    netscape.security.PrivilegeManager.enablePrivilege("UniversalFileRead");

    var /* nsIX509Cert */ signerCert;
    signerCert = xmldsigffext_getSelectedSignerCert();
    if (signerCert == null) {
    	dump("xmldsigffext_signXMLFileWithCert(): null signer certificate is selected.\n");
    	return null;
    }

    var /* nsILocalFile */ inputXMLFile = gXmlVerifyInputFilePickerElem.file;
    if (inputXMLFile == null) {
    	dump("xmldsigffext_signXMLFileWithCert(): No input XML file is selected.\n");
    	return null;
    }

    var /* nsILocalFile */ outSignedXMLFile = gXmlVerifySignedOutFilePickerElem.file;
    if (outSignedXMLFile == null) {
    	dump("xmldsigffext_signXMLFileWithCert(): failed to get outSignedXMLFile.\n");
        return null;
    }

    try {
    	// Force token login - on windows the popup window for password is not coming up
    	xmldsigffext_loginToCertToken(signerCert);

    	// dumpProperties(xmlSignatureProps, "xmldsigffext_signXMLFileWithCert(): xmlSignatureParams:");
    	gXmlDSigTool.signXMLFileByX509Cert(inputXMLFile, signerCert, xmlSignatureProps, outSignedXMLFile);
    } catch (ex) {
    	// alert("xmldsigffext_signXMLFileWithCert(): failed to create signed XML file - ex : " + ex + "\n");
    	dump("xmldsigffext_signXMLFileWithCert(): failed to create signed XML file - ex : " + ex + "\n");
	throw ex;
    }

    dump("xmldsigffext_signXMLFileWithCert():................End.\n");

    return outSignedXMLFile;
}

function xmldsigffext_getSignedXMLFileType()
{
    var signedXMLFileType = null;
    signedXMLFileType = gXmlVerifySigTypeMenuElem.value +
    			"_" + gXmlVerifySigCanonMethodMenuElem.value +
    			"_" + gXmlVerifyUserCredentialTypeGroupElem.selectedItem.value
			;
    return signedXMLFileType;
}

