/* @(#) $Id: SamlSelfTokenCreate.js,v 1.16 2008/05/25 15:55:58 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */



const gXmlDocPreamble = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\" ?>\n";
const gSamlAssertionNS = "urn:oasis:names:tc:SAML:1.0:assertion";
const gAttributeNamespace = "http://schemas.microsoft.com/ws/2005/05/identity";

const gSamlSelfTokenTemplate = 
"<?xml version=\"1.0\" encoding=\"UTF-8\"?> \n" +
"<Assertion xmlns=\"urn:oasis:names:tc:SAML:1.0:assertion\" \n" +
"    xmlns:wsa=\"http://schemas.xmlsoap.org/ws/2004/08/addressing\" \n" +
"    xmlns:wsp=\"http://schemas.xmlsoap.org/ws/2004/09/policy\" \n" +
"    xmlns:xs=\"http://www.w3.org/2001/XMLSchema\" \n" +
"    xmlns:ds=\"http://www.w3.org/2000/09/xmldsig#\" \n" +
"    xmlns:xenc=\"http://www.w3.org/2001/04/xmlenc#\" \n" +
"    xmlns:wsse=\"http://docs.oasis-open.org/wss/2004/xx/oasis-2004xx-wss-soap-message-security-1.1\" \n" +
"    xmlns:tns=\"http://schemas.microsoft.com/ws/2005/05/identity\" \n" +
"    Issuer=\"http://schemas.microsoft.com/ws/2005/05/identity/issuer/self\" \n" +
"    MajorVersion=\"1\" \n" +
"    MinorVersion=\"1\" \n" +
"    > \n" +
"</Assertion> \n" +
"";



var /* alrIXPSamlTokenSvc */ gSamlTokenSvc = null;
var /* alrIUUIDGenerator  */ gUUIDGenerator = null;

var gParams = null;

var gSamlTokenCreateWizardInitDone = false;
var gSamlTokenCreateWizardElem = null;
var gWizardButtonNextElem;
var gWizardButtonBackElem;
var gWizardButtonFinishElem;
var gWizardButtonExtra1Elem;
var gWizardButtonExtra2Elem;
var gWizardButtonCancelElem;
var gWizardButtonNextOrigLabel;

var gSamlTokenSignDSignatureElem;
var gSamlTokenVerifyDSignatureElem;

function SamlSelfTokenCreate_initOnLoad(aWizardElem)
{
    if (gSamlTokenCreateWizardInitDone) {
    	return;
    }

    dump("SamlSelfTokenCreate_initOnLoad():................Start.\n");
    gSamlTokenCreateWizardInitDone = true;

    // gSamlTokenCreateWizardElem = document.getElementById('samltoken.form.wizard');
    gSamlTokenCreateWizardElem = aWizardElem;
    
    gWizardButtonNextElem = gSamlTokenCreateWizardElem.getButton("next");
    gWizardButtonNextOrigLabel = "" + gWizardButtonNextElem.label;
    // dump("gWizardButtonNextOrigLabel: " + gWizardButtonNextOrigLabel + "\n");

    initSamlSelfTokenCreateHandlers();

    try {
    	samlSelfTokenCertClaims_initClaimsWithCertFormXULElems();
    } catch (ex) {
    	dump("SamlSelfTokenCreate_initOnLoad(): samlSelfTokenCertClaims_initSignParamFormXULElems() failed - ex - " + ex + "\n");
    }

    SamlSelfTokenCreate_initParamsOnLoad();

    dump("SamlSelfTokenCreate_initOnLoad():................End.\n");
}

function SamlSelfTokenCreate_initParamsOnLoad()
{
}

var XPILoadErrorMessage = "Make sure that DLLs (shared libraries) from Apache Xerces-C++ and Xalan-C++ are in your PATH (LD_LIBRARY_PATH) environment variable.";
function initSamlSelfTokenCreateHandlers()
{
    try {
    	gSamlTokenSvc = Components.classes["@avaya.com/pkm/samltokensvc;1"].
    			getService(Components.interfaces.alrIXPSamlTokenSvc);
    	gUUIDGenerator = Components.classes["@avaya.com/pkm/uuidgenerator;1"].
    			getService(Components.interfaces.alrIUUIDGenerator);
    } catch (ex) {
    	alert("xmldsigffext_initSignFormXULElems(): failed to get instance of alrIXPSamlTokenSvc - ex: " + ex + "\n");
    	dump("xmldsigffext_initSignFormXULElems(): failed to get instance of alrIXPSamlTokenSvc - ex: " + ex + "\n");
	dump(XPILoadErrorMessage + "\n");
	throw ex;
    }
    // dump("initSamlSelfTokenCreateHandlers(): gSamlTokenSvc: " + gSamlTokenSvc + "\n");
    // dump("initSamlSelfTokenCreateHandlers(): gUUIDGenerator: " + gUUIDGenerator + "\n");
    if (!gSamlTokenSvc) {
    	alert("xmldsigffext_initSignFormXULElems(): failed to get instance of alrIXPSamlTokenSvc.\n");
    	dump("xmldsigffext_initSignFormXULElems(): failed to get instance of alrIXPSamlTokenSvc.\n");
	dump(XPILoadErrorMessage + "\n");
    	return;
    }

    dump("initSamlSelfTokenCreateHandlers(): uuid: " + gUUIDGenerator.create() + "\n");
}


function SamlSelfTokenCreate_InitSamlParamsPageShow(aWizardPageElem) 
{
    dump("SamlSelfTokenCreate_InitSamlParamsPageShow():................Start.\n");

    SamlSelfTokenCreate_initOnLoad();

    // gSamlTokenCreateWizardElem.canAdvance = false;


    var samlTokenParamElem = document.getElementById("samltoken.form.xmldoc.create.samlparams.init.form");
    if (gSamlTokenCreateWizardElem.samlAssertionType == "selfissuedtoken") {
	samlTokenParamElem.selfIssuedToken = true;
    }
    else if (gSamlTokenCreateWizardElem.samlAssertionType == "samltoken") {
	samlTokenParamElem.samlToken = true;
    }
    /*
    else if (gSamlTokenCreateWizardElem.samlAssertionType == "attrassertion") {
    }
    else {
    }
    */
    samlTokenParamElem.refresh();

    // Set the next page id based on the key type.
    var pageUserNextElem = document.getElementById("samltoken.form.xmldoc.create.samlparams.init.next");
    gWizardButtonNextElem.label = pageUserNextElem.value;

    gSamlTokenCreateWizardElem.firstStep = false;

    dump("SamlSelfTokenCreate_InitSamlParamsPageShow():................End.\n");
    return true;
}

function SamlSelfTokenCreate_handleCredentialTypeChange(aSamlTokenKeyTypeOptionsElem, ev) 
{
    dump("SamlSelfTokenCreate_handleCredentialTypeChange():................Start.\n");

    // Select the next wizard page based on the signing key type
    /*
    var nextPageId = null;
    if (aSamlTokenKeyTypeOptionsElem.selectedItem.value == "certificate") {
    	nextPageId = "samltoken.form.xmldoc.create.samlparams.cert";
    }
    else {
    	nextPageId = "samltoken.form.xmldoc.create.samlparams.edit.attrstmt";
    }
    */
    var nextPageId = aSamlTokenKeyTypeOptionsElem.selectedItem.getAttribute("nextPageId");

    gSamlTokenCreateWizardElem.currentPage.next = nextPageId;

    var samlTokenProofKeyFlagElem = document.getElementById("samltoken.form.xmldoc.create.samlparams.include.proof.key");
    SamlSelfTokenCreate_handleIncludeProofKeyChange(samlTokenProofKeyFlagElem);

    // var samlAssertionClaimProfileElem = document.getElementById("samltoken.form.xmldoc.create.samlparams.claim.profile.menu");
    // SamlTokenCreate_handleAttributeProfileChange(samlAssertionClaimProfileElem);

    return true;
}

function SamlSelfTokenCreate_handleVersionChange(aSamlTokenVersionElem, ev) 
{
    dump("SamlSelfTokenCreate_handleVersionChange():................Start.\n");

    var samlAssertionClaimMenuProfileElem = document.getElementById("samltoken.form.xmldoc.create.samlparams.claim.profile.menu");
    // dump("SamlSelfTokenCreate_handleVersionChange(): aSamlTokenVersionElem.attributeProfile: " + aSamlTokenVersionElem.attributeProfile + "\n");

    samlAssertionClaimMenuProfileElem.profile = aSamlTokenVersionElem.attributeProfile;
    SamlTokenCreate_handleAttributeProfileChange(samlAssertionClaimMenuProfileElem);

    dump("SamlSelfTokenCreate_handleVersionChange():................End.\n");
}

function SamlSelfTokenCreate_handleIncludeProofKeyChange(aIncludeProofKeyElem, ev) 
{
    dump("SamlSelfTokenCreate_handleIncludeProofKeyChange():................Start.\n");

    var samlTokenKeyTypeOptionsElem = document.getElementById("samltoken.form.xmldoc.create.samlparams.credential.type.group");
    var recipientCertRowElem = document.getElementById("samltoken.form.xmldoc.create.samlparams.recipient.cert.row");

    if (aIncludeProofKeyElem.checked && (samlTokenKeyTypeOptionsElem.selectedItem.value == "symmetrickey")) {
        recipientCertRowElem.hidden = false;
    }
    else {
    	recipientCertRowElem.hidden = true;
    }

    dump("SamlSelfTokenCreate_handleIncludeProofKeyChange():................End.\n");
}


function SamlTokenCreate_handleRecipientCertPickerChange(aRecipientCertPickerElem, ev) 
{
    dump("SamlTokenCreate_handleRecipientCertPickerChange():................Start.\n");
}


function SamlTokenCreate_handleAttributeProfileChange(aProfileMenuElem, ev)
{
    dump("SamlTokenCreate_handleAttributeProfileChange():...................Start.\n");

    var samlAssertionClaimNamesGridElem = document.getElementById("samltoken.form.xmldoc.create.samlparams.claim.names.grid");
    var samlAssertionClaimNamesCloumnsElem = document.getElementById("samltoken.form.xmldoc.create.samlparams.claim.names.grid.columns");

    var samlAssertionClaimNamesRowsElem = document.getElementById("samltoken.form.xmldoc.create.samlparams.claim.names.grid.rows");
    var rowsChildNodeList = samlAssertionClaimNamesRowsElem.childNodes;
    for (var i = (rowsChildNodeList.length -1); i >= 0; i--) {
    	var rowsChildNode = rowsChildNodeList.item(i);
	samlAssertionClaimNamesRowsElem.removeChild(rowsChildNode);
    }

    var profileXmlDoc = aProfileMenuElem.getProfileXmlDoc();
    if (!profileXmlDoc) {
	samlAssertionClaimNamesGridElem.hidden = true;
    	return;
    }

    var samlAssertionClaimNameList = [];

    var samlAttributeNameIdList = ["FriendlyName", "Name", "AttributeName"];

    var samlAttribElemList = profileXmlDoc.getElementsByTagName("Attribute");
    // dump("SamlTokenCreate_handleAttributeProfileChange(): samlAttribElemList.length: " + samlAttribElemList.length + "\n");
    for (var i = 0; i < samlAttribElemList.length; i++) {
	var samlAttribName = null;

    	var samlAttributeElem = samlAttribElemList.item(i);
	for (var j = 0; j < samlAttributeNameIdList.length; j++) {
	    var samlAttribNameId = samlAttributeNameIdList[j];
	    samlAttribName = samlAttributeElem.getAttribute(samlAttribNameId);
	    if (samlAttribName) {
	    	break;
	    }
	}
	if (!samlAttribName) {
	    continue;
	}
	samlAssertionClaimNameList[samlAssertionClaimNameList.length] = samlAttribName;
    	// dump("SamlTokenCreate_handleAttributeProfileChange(): samlAssertionClaimNameList[" + i + "]: " + samlAttribName + "\n");
    }
    if (samlAssertionClaimNameList.length <= 0) {
	samlAssertionClaimNamesGridElem.hidden = true;
    	return;
    }
    // dump("SamlTokenCreate_handleAttributeProfileChange(): samlAssertionClaimNameList.length: " + samlAssertionClaimNameList.length + "\n");


    samlAssertionClaimNamesGridElem.hidden = false;
    var columnNodeList = samlAssertionClaimNamesCloumnsElem.getElementsByTagName("column");
    var totColumns = columnNodeList.length;
    // dump("SamlTokenCreate_handleAttributeProfileChange(): totColumns: " + totColumns + "\n");

    var rowElem = null;
    var rowHboxElem = null;
    for (var i = 0; i < samlAssertionClaimNameList.length; i++) {
    	if ((i % totColumns) == 0) { 
	    rowElem = document.createElement("row");
	    rowElem = samlAssertionClaimNamesRowsElem.appendChild(rowElem);
	    // rowHboxElem = document.createElement("hbox");
	    // rowHboxElem = rowElem.appendChild(rowHboxElem);
	}
	var checkBoxElem = document.createElement("checkbox");
	// checkBoxElem = rowHboxElem.appendChild(checkBoxElem);
	checkBoxElem = rowElem.appendChild(checkBoxElem);
	checkBoxElem.label = samlAssertionClaimNameList[i];
    }

    dump("SamlTokenCreate_handleAttributeProfileChange():...................End.\n");
}



var gSamlAssertionClaimAttrNameList = [];
var gSamlAssertionClaimAttributesDoc = null;
function SamlSelfTokenCreate_InitSamlParamsPageAdvanced(aWizardPageElem) 
{
    dump("SamlSelfTokenCreate_InitSamlParamsPageAdvanced():................Start.\n");

    // gSamlTokenCreateWizardElem.canAdvance = false;

    gWizardButtonNextElem.label = gWizardButtonNextOrigLabel;

    var samlTokenParamElem = document.getElementById("samltoken.form.xmldoc.create.samlparams.init.form");

    var nextPageId = "samltoken.form.xmldoc.create.samlparams.edit.attrstmt";
    gSamlTokenCreateWizardElem.currentPage.next = nextPageId;

    if (false) {
    dump("samlTokenParamElem.subjectKeyType :\t" + samlTokenParamElem.subjectKeyType + "\n");
    dump("samlTokenParamElem.subjectUserName :\t" + samlTokenParamElem.subjectUserName + "\n");
    dump("samlTokenParamElem.subjectSharedKey :\t" + samlTokenParamElem.subjectSharedKey + "\n");
    dump("samlTokenParamElem.subjectCert :\t" + samlTokenParamElem.subjectCert + "\n");
    }

    if (samlTokenParamElem.holderofkey) {
        if (samlTokenParamElem.subjectKeyType == "symmetrickey") {
            if ((samlTokenParamElem.subjectUserName == "") || (samlTokenParamElem.subjectSharedKey == "")) {
	        alert("Either subject name or shared key is missing.");
    	        return false;
	    }
        }
        else {
    	    if (!samlTokenParamElem.subjectCert) {
	        alert("Subject cert is not selected.");
    	        return false;
	    }
        }
    }

    gSamlAssertionClaimAttrNameList = samlTokenParamElem.samlAssertionClaimAttrNameList;
    // dump("SamlSelfTokenCreate_InitSamlParamsPageAdvanced(): gSamlAssertionClaimAttrNameList.length: " + gSamlAssertionClaimAttrNameList.length  + "\n");
    if (gSamlAssertionClaimAttrNameList.length <= 0) {
	alert("You must select at least one attribute name.");
    	return false;
    }

    gSamlAssertionClaimAttributesDoc = samlTokenParamElem.samlAssertionClaimAttributesDoc;
    // dump("SamlSelfTokenCreate_InitSamlParamsPageAdvanced(): gSamlAssertionClaimAttributesDoc: " + gSamlAssertionClaimAttributesDoc  + "\n");

    gSamlTokenCreateWizardElem.samlAssertionClaimAttrNameList = samlTokenParamElem.samlAssertionClaimAttrNameList;
    gSamlTokenCreateWizardElem.samlAssertionClaimAttributesDoc = samlTokenParamElem.samlAssertionClaimAttributesDoc;

    if (!gSamlAssertionClaimAttributesDoc) {
	alert("Failed to create SAML Assertion document - retry from the start or reset atleast one of the SAML assertion parameters.");
    	return false;
    }

    // dump("gSamlAssertionClaimAttributesDoc:\n" + samlTokenParamElem.serialize(gSamlAssertionClaimAttributesDoc) + "\n");

    dump("SamlSelfTokenCreate_InitSamlParamsPageAdvanced():................End.\n");
    return true;
}

function SamlSelfTokenCreate_EditAttributeStatementPageShow(aWizardPageElem) 
{
    dump("SamlSelfTokenCreate_EditAttributeStatementPageShow():................Start.\n");

    gSamlTokenCreateWizardElem.firstStep = false;

    var pageUserNextElem = document.getElementById("samltoken.form.xmldoc.create.samlparams.edit.attrstmt.next");
    gWizardButtonNextElem.label = pageUserNextElem.value;

    var samlTokenParamElem = document.getElementById("samltoken.form.xmldoc.create.samlparams.init.form");

    // dump("SamlSelfTokenCreate_EditAttributeStatementPageShow(): gSamlAssertionClaimAttrNameList.length: " + gSamlAssertionClaimAttrNameList.length  + "\n");
    if (gSamlAssertionClaimAttrNameList.length <= 0) {
    	return false;
    }
    // dump("SamlSelfTokenCreate_EditAttributeStatementPageShow(): gSamlAssertionClaimAttributesDoc: " + gSamlAssertionClaimAttributesDoc  + "\n");

    var samlAttrStmtEditorElem = document.getElementById("samltoken.form.xmldoc.create.samlparams.edit.attrstmt.editor"); 
    samlAttrStmtEditorElem.samlAssertionClaimNameList = gSamlAssertionClaimAttrNameList;
    samlAttrStmtEditorElem.displayAttributeStatementDoc(gSamlAssertionClaimAttributesDoc);

    var samlTokenClaimsOutFilePicker = document.getElementById("samltoken.form.xmldoc.create.samlparams.edit.attrstmt.out.filepicker"); 
    if (!gSamlTokenCreateWizardElem.saveInFile) {
	samlTokenClaimsOutFilePicker.hidden = true;
    	return true;
    }
    samlTokenClaimsOutFilePicker.hidden = false;

    var samlTokenAlias = "MyToken";
    /*
    if (samlTokenAlias == "") {
    	samlTokenAlias = "MyToken";
    }
    */
    var samlClaimsDocFileName = null;
    if (samlTokenParamElem.samlv1) {
    	samlClaimsDocFileName = samlTokenAlias + "_SAMLv1Assertion.xml";
    }
    else {
    	samlClaimsDocFileName = samlTokenAlias + "_SAMLv2Assertion.xml";
    }
    samlTokenClaimsOutFilePicker.autoSelectTempFile("XMLDSigTool/SamlToken", samlClaimsDocFileName);
    dump("SamlSelfTokenCreate_EditAttributeStatementPageShow():................End.\n");
    return true;
}

function SamlSelfTokenCreate_EditAttributeStatementPageAdvanced(aWizardPageElem) 
{
    dump("SamlSelfTokenCreate_EditAttributeStatementPageAdvanced():................Start.\n");

    var samlAttrStmtEditorElem = document.getElementById("samltoken.form.xmldoc.create.samlparams.edit.attrstmt.editor"); 
    var samlAttributeStatmentDoc = samlAttrStmtEditorElem.getAttributeStatementDoc();
    if (!samlAttributeStatmentDoc) {
	alert("No assertion claims (attributes) for subject is provided - you must provide at least one claim.");
    	return false;
    }
    gSamlAssertionClaimAttributesDoc = samlAttributeStatmentDoc;
    

    // Build the SAML assertion document based on the parameters specified
    var samlTokenParamElem = document.getElementById("samltoken.form.xmldoc.create.samlparams.init.form");
    if (false) {
    dump("**************************************************\n");
    dump("samlTokenParamElem.version:\t\t"	+ samlTokenParamElem.version + "\n");
    dump("samlTokenParamElem.attributeProfile:\t" + samlTokenParamElem.attributeProfile + "\n");
    dump("samlTokenParamElem.samlv1:\t\t"	+ samlTokenParamElem.samlv1 + "\n");
    dump("samlTokenParamElem.samlv2:\t\t"	+ samlTokenParamElem.samlv2 + "\n");
    dump("samlTokenParamElem.subjectKeyType:\t"	+ samlTokenParamElem.subjectKeyType + "\n");
    dump("samlTokenParamElem.credentialType:\t"	+ samlTokenParamElem.credentialType + "\n");
    dump("samlTokenParamElem.subjectUserName:\t" + samlTokenParamElem.subjectUserName + "\n");
    dump("samlTokenParamElem.subjectSharedKey:\t" + samlTokenParamElem.subjectSharedKey + "\n");
    dump("samlTokenParamElem.confirmationMethod:\t" + samlTokenParamElem.confirmationMethod + "\n");
    dump("samlTokenParamElem.includeProofKey:\t" + samlTokenParamElem.includeProofKey + "\n");
    dump("samlTokenParamElem.recipientCert:\t"	+ samlTokenParamElem.recipientCert + "\n");
    dump("samlTokenParamElem.signerCert:\t"	+ samlTokenParamElem.signerCert + "\n");
    dump("**************************************************\n\n");
    }

    var signOptionElem = document.getElementById("samltoken.form.create.workflow.steps.sign");

    var rootElementOnly = true;
    var samlAssertionElem = samlTokenParamElem.getEmptySamlAssertionElem(rootElementOnly);

    // TODO: Issuer element
    samlTokenParamElem.updateSamlAssertionIssuer(samlAssertionElem);
    // dump("samlAssertionElem:\n" + samlTokenParamElem.serialize(samlAssertionElem) + "\n");

    var samlAttributeStatementElem = samlAttributeStatmentDoc.documentElement;

    if (samlTokenParamElem.samlv1) {
    	samlTokenParamElem.updateSamlAssertionConditions(samlAssertionElem);

	samlAttributeStatementElem = samlAssertionElem.appendChild(samlAttributeStatementElem);
    	var samlSubjectElem = samlTokenParamElem.getSamlAssertionSubject(samlAttributeStatementElem);
	if (samlAttributeStatementElem.hasChildNodes()) {
    	    samlSubjectElem = samlAttributeStatementElem.insertBefore(samlSubjectElem, samlAttributeStatementElem.firstChild);
	}
	else {
    	    samlSubjectElem = samlAttributeStatementElem.appendChild(samlSubjectElem);
	}
    	// dump("samlAttributeStatementElem:\n" + samlTokenParamElem.serialize(samlAttributeStatementElem) + "\n");
    }
    else {
    	var issuerElem = null;
    	var issuerElemList = samlAssertionElem.getElementsByTagName("Issuer");
	if (issuerElemList && (issuerElemList.length > 0)) {
	    issuerElem = issuerElemList.item(0);
	}
    	// dump("issuerElem:\n" + samlTokenParamElem.serialize(issuerElem) + "\n");

    	var samlSubjectElem = samlTokenParamElem.getSamlAssertionSubject(samlAssertionElem);
	if (!issuerElem || !issuerElem.nextSibling) {
    	    samlSubjectElem = samlAssertionElem.appendChild(samlSubjectElem);
	}
	else {
    	    samlSubjectElem = samlAssertionElem.insertBefore(samlSubjectElem, issuerElem.nextSibling);
	}
    	// dump("samlSubjectElem:\n" + samlTokenParamElem.serialize(samlSubjectElem) + "\n");

    	samlTokenParamElem.updateSamlAssertionConditions(samlAssertionElem);
    	if (signOptionElem.checked) {
    	    samlTokenParamElem.updateSamlAssertionSignature(samlAssertionElem);
	}

	samlAttributeStatementElem = samlAssertionElem.appendChild(samlAttributeStatementElem);

    }
    // samlTokenParamElem.updateSamlAssertionConditions(samlAssertionElem);
    if (signOptionElem.checked) {
    	samlTokenParamElem.updateSamlAssertionSignature(samlAssertionElem);
    }

    // dump("SamlSelfTokenCreate_EditAttributeStatementPageAdvanced():................30.\n");
    // dump("samlAssertionElem.ownerDocument: " + samlAssertionElem.ownerDocument + "\n");
    // dump("aWizardPageElem.next: " + aWizardPageElem.next + "\n");

    var nextPageElem = gSamlTokenCreateWizardElem.getPageById(aWizardPageElem.next);
    nextPageElem.xmldoc = samlAssertionElem.ownerDocument;

    var outFilePickerElem = document.getElementById("samltoken.form.xmldoc.create.samlparams.edit.attrstmt.out.filepicker"); 
    if (gSamlTokenCreateWizardElem.saveInFile) {
    	var xmlSerializer = new XMLSerializer();
    	var samlAssertionXmlDocStr = xmlSerializer.serializeToString(nextPageElem.xmldoc);
    	outFilePickerElem.saveFile(samlAssertionXmlDocStr);
    	outFilePickerElem.refresh();

    	nextPageElem.filepath = outFilePickerElem.filepath;
    }

    gSamlTokenCreateWizardElem.samlTokenParamElem = samlTokenParamElem;


    var signOptionElem = document.getElementById("samltoken.form.create.workflow.steps.sign");
    if (signOptionElem.checked) {
    	var encryptOptionElem = document.getElementById("samltoken.form.create.workflow.steps.encrypt");
    	SamlSelfTokenCreate_initXmlSignEncryptHandler(aWizardPageElem, null, !encryptOptionElem.checked);
    }

    // dump("Final samlAssertionElem:\n" + samlTokenParamElem.serialize(samlAssertionElem) + "\n");
    dump("SamlSelfTokenCreate_EditAttributeStatementPageAdvanced():................End.\n");
    return true;
}

function SamlSelfTokenCreate_CreateSamlAssertionPageShow(aWizardPageElem) 
{
    dump("SamlSelfTokenCreate_CreateSamlAssertionPageShow():................Start.\n");

    gSamlTokenCreateWizardElem.firstStep = false;
    // gSamlTokenCreateWizardElem.canAdvance = false;

    var pageUserNextElem = document.getElementById("samltoken.form.xmldoc.create.saml.assertion.next");
    gWizardButtonNextElem.label = pageUserNextElem.value;

    var inXmlFilePickerRowElem = document.getElementById('samltoken.form.xmldoc.create.saml.assertion.input.file.row');
    var inXmlFilePickerElem = document.getElementById('samltoken.form.xmldoc.create.saml.assertion.input.filepicker');

    inXmlFilePickerElem.xmldoc = null;
    if (aWizardPageElem.xmldoc) {
    	inXmlFilePickerElem.xmldoc = aWizardPageElem.xmldoc;
    }

    if (!gSamlTokenCreateWizardElem.firstStep && !gSamlTokenCreateWizardElem.saveInFile) {
	inXmlFilePickerRowElem.hidden = true;
    }
    else {
        if (aWizardPageElem.filepath) {
            inXmlFilePickerElem.filepath = aWizardPageElem.filepath;
        }
	inXmlFilePickerRowElem.hidden = false;
    }

    handleCreateSamlAssertionInFilePathChange(inXmlFilePickerElem);

    var samlTokenParamElem = document.getElementById("samltoken.form.xmldoc.create.samlparams.init.form");

    var samlAssertionCreatorElem = document.getElementById("samltoken.form.xmldoc.create.saml.assertion.assertionBox");
    /*
    samlAssertionCreatorElem.samlVersion = samlTokenParamElem.version;
    samlAssertionCreatorElem.samlAttributeProfile = samlTokenParamElem.attributeProfile;
    dump("SamlSelfTokenCreate_CreateSamlAssertionPageShow():................60.\n");

    samlAssertionCreatorElem.credentialType = samlTokenParamElem.credentialType;
    dump("SamlSelfTokenCreate_CreateSamlAssertionPageShow():................61.\n");

    var samlAssertionElem = null;
    if (samlTokenParamElem.subjectKeyType == "certificate") {
    	var samlTokenIdentityElem = document.getElementById("samltoken.form.xmldoc.create.certclaims.token.credential");
    	samlAssertionCreatorElem.subjectCert = samlTokenParamElem.subjectCert;
    	samlAssertionCreatorElem.signerCert = samlTokenParamElem.signerCert;
	samlAssertionElem = samlAssertionXmlDoc.documentElement;
    }
    else {
    	// samlAssertionCreatorElem.credentialType = "symmetrickey";
    }
    dump("SamlSelfTokenCreate_CreateSamlAssertionPageShow():................62.\n");

    // Initialize for Subject Conformation
    samlAssertionCreatorElem.includeProofKey = samlTokenParamElem.includeProofKey;
    if ((samlTokenParamElem.subjectKeyType == "symmetrickey") && (samlTokenParamElem.includeProofKey)) {
    	samlAssertionCreatorElem.recipientCert = samlTokenParamElem.recipientCert;
    }
    else {
    	samlAssertionCreatorElem.recipientCert = null;
    }
    */

    // dump("SamlSelfTokenCreate_CreateSamlAssertionPageShow():................70.\n");

    // var xulSamlAssertionElem = samlAssertionCreatorElem.displaySamlAssertion(samlAssertionElem);

    // dump("SamlSelfTokenCreate_CreateSamlAssertionPageShow():................80.\n");

    var outFilePickerRowElem	= document.getElementById("samltoken.form.xmldoc.create.saml.assertion.unsigned.out.file.row"); 
    if (!gSamlTokenCreateWizardElem.saveInFile) {
    	outFilePickerRowElem.hidden = true;
	return true;
    }
    outFilePickerRowElem.hidden = false;

    dump("SamlSelfTokenCreate_CreateSamlAssertionPageShow():................End.\n");

    return true;
}

function handleCreateSamlAssertionInFilePathChange(aFilePickerElem, ev) 
{
    dump("handleCreateSamlAssertionInFilePathChange():................Start.\n");
    // dump("handleCreateSamlAssertionInFilePathChange(): ev: " + ev + "\n");

    var samlAssertionCreatorElem = document.getElementById("samltoken.form.xmldoc.create.saml.assertion.assertionBox");

    if (ev) {
	aFilePickerElem.xmldoc = null; // Force the parsing of newly choosen XML file 
        if ((aFilePickerElem.value == "") || !aFilePickerElem.file) {
    	    // dump("handleCreateSamlAssertionInFilePathChange():................10.\n");
    	    gSamlTokenCreateWizardElem.canAdvance = false;
	    return false;
        }
    }

    var unsignedXmlDoc = aFilePickerElem.xmldoc;
    // dump("handleCreateSamlAssertionInFilePathChange(): unsignedXmlDoc: " + unsignedXmlDoc + "\n");
    if (!unsignedXmlDoc) {
	if (!aFilePickerElem.file) {
    	    gSamlTokenCreateWizardElem.canAdvance = false;
	    return false;
	}
    	unsignedXmlDoc = samlAssertionCreatorElem.readXMLDocFromFile(aFilePickerElem.file);
    	if (!unsignedXmlDoc) {
    	    dump("handleCreateSamlAssertionInFilePathChange(): xmldsigffext_SignEnc_xmlDocParseXmlFile() failed.\n");
    	    gSamlTokenCreateWizardElem.canAdvance = false;
	    return false;
    	}
    }

    if (ev) {
    	gSamlTokenCreateWizardElem.currentPage.xmldoc = unsignedXmlDoc;
    	gSamlTokenCreateWizardElem.currentPage.filepath = aFilePickerElem.filepath;
    }

    var samlAssertionElem = unsignedXmlDoc.documentElement;
    // dump("\nsamlAssertionElemStr:\n" + samlAssertionElemStr + "\n");

    var xulSamlAssertionElem = null;
    try {
    	xulSamlAssertionElem = samlAssertionCreatorElem.displaySamlAssertion(samlAssertionElem);
    } catch (ex) {
    	dump("handleCreateSamlAssertionInFilePathChange(): samlAssertionCreatorElem.displaySamlAssertion() failed - ex: " + ex + "\n");
    	gSamlTokenCreateWizardElem.canAdvance = false;
	return false;
    }

    var outFilePickerRowElem	= document.getElementById("samltoken.form.xmldoc.create.saml.assertion.unsigned.out.file.row"); 
    if (!gSamlTokenCreateWizardElem.saveInFile) {
    	gSamlTokenCreateWizardElem.canAdvance = true;
	outFilePickerRowElem.hidden = true;
    	return true;
    }
    outFilePickerRowElem.hidden = false;

    var outXmlFilePickerElem = document.getElementById("samltoken.form.xmldoc.create.saml.assertion.unsigned.out.filepicker"); 
    // outXmlFilePickerElem.hidden = false;
    if ((outXmlFilePickerElem.value != "") && outXmlFilePickerElem.file) {
    	gSamlTokenCreateWizardElem.canAdvance = true;
    	// dump("handleCreateSamlAssertionInFilePathChange():................20.\n");
    	return true;
    }

    var inXmlFile = aFilePickerElem.file;
    var outXmlFileName = inXmlFile.leafName + "_XXXX";
    // dump("handleCreateSamlAssertionInFilePathChange(): outXmlFileName: " + outXmlFileName + "\n");

    var outXmlFileDir = inXmlFile.parent; 
    outXmlFilePickerElem.autoSelectFile(outXmlFileDir, outXmlFileName);
    handleCreateSamlAssertionOutFilePathChange(outXmlFilePickerElem);
    // dump("handleCreateSamlAssertionInFilePathChange(): outXmlFilePath: " + outXmlFilePickerElem.value + "\n");


    dump("handleCreateSamlAssertionInFilePathChange():................End.\n");
    return true;
}


function handleCreateSamlAssertionInFileChange(ev) 
{
    var samlAssertionFilePickerElem = ev.target;
    // dump("handleCreateSamlAssertionInFileChange(): samlAssertionFilePickerElem: " + samlAssertionFilePickerElem + "\n");
    handleCreateSamlAssertionInFilePathChange(samlAssertionFilePickerElem, ev);
}

function handleCreateSamlAssertionOutFilePathChange(aFilePickerElem, ev) 
{
    if ((aFilePickerElem.value != "") && aFilePickerElem.file) {
    	gSamlTokenCreateWizardElem.canAdvance = true;
    }
    else {
    	gSamlTokenCreateWizardElem.canAdvance = false;
    }
}

function handleCreateSamlAssertionOutPathChange(ev) 
{
    var outFilePickerElem = ev.target;
    handleCreateSamlAssertionOutFilePathChange(outFilePickerElem, ev);
}



function SamlSelfTokenCreate_CreateSamlAssertionPageAdvanced(aWizardPageElem) 
{
    dump("SamlSelfTokenCreate_CreateSamlAssertionPageAdvanced():................Start.\n");

    // var samlTokenClaimsElem = document.getElementById("samltoken.form.xmldoc.create.saml.assertion.claims");
    var samlAssertionCreatorElem = document.getElementById("samltoken.form.xmldoc.create.saml.assertion.assertionBox");

    if (samlAssertionCreatorElem.credentialType == "symmetrickey") {
        if (samlAssertionCreatorElem.includeProofKey && (samlAssertionCreatorElem.signerSharedKey.length == 0)) {
	    // TODO: Provide a prompt for user input for symmetric key for atleast 16 characters
	    var randomSymKey = "";
	    var now = new Date();
    	    randomSymKey = "" + (Math.floor(Math.random() * (1000000 - 10000 + 1)) + 10000);
    	    randomSymKey = randomSymKey + now.getTime() + randomSymKey;
    	    randomSymKey = randomSymKey.substring(0, 16);
    	    // dump("doGenerateScepReq():senderNonce: " + randomSymKey + "(" + randomSymKey.length + ")\n");

	    samlAssertionCreatorElem.signerSharedKey = randomSymKey;
        }
    }

    // Get the SAML Assertion document with Signtaure element in it for SAMLv2.
    var samlSelfTokenAssertionDoc = samlAssertionCreatorElem.getSamlAssertionDoc(true);


    // dump("SamlSelfTokenCreate_CreateSamlAssertionPageAdvanced(): nextPage: " + aWizardPageElem.next + "\n");
    var nextPageElem = gSamlTokenCreateWizardElem.getPageById(aWizardPageElem.next);
    nextPageElem.xmldoc = samlSelfTokenAssertionDoc;

    var outFilePickerElem = document.getElementById("samltoken.form.xmldoc.create.saml.assertion.unsigned.out.filepicker"); 
    if (gSamlTokenCreateWizardElem.saveInFile) {

    	var xmlSerializer = new XMLSerializer();
    	var samlSelfTokenUnsignedXmlDataStr = xmlSerializer.serializeToString(samlSelfTokenAssertionDoc);
    	outFilePickerElem.saveFile(samlSelfTokenUnsignedXmlDataStr);
    	outFilePickerElem.refresh();

    	var outSAMLTokenUnsignedFile = outFilePickerElem.file;
    	if (!outSAMLTokenUnsignedFile.exists() || (outSAMLTokenUnsignedFile.fileSize <= 0)) {
    	    dump("SamlSelfTokenCreate_CreateSamlAssertionPageAdvanced(): failed to create Unsigned XML file.\n");
    	    alert("SamlSelfTokenCreate_CreateSamlAssertionPageAdvanced(): failed to create Unsigned XML file.\n");
	    return false;
    	}
    	outFilePickerElem.xmldoc = samlSelfTokenAssertionDoc;

    	nextPageElem.filepath = outFilePickerElem.filepath;
    	// dump("SamlSelfTokenCreate_CreateSamlAssertionPageAdvanced(): nextPageElem.filepath: " + nextPageElem.filepath + "\n");
	/*
        if (gSamlTokenCreateWizardElem.generateOutFile) {
    	    gSamlTokenCreateWizardElem.finalOutXmlFilePickerElem.filepath = nextPageElem.filepath;
    	    gSamlTokenCreateWizardElem.finalOutXmlFilePickerElem.xmldoc = nextPageElem.xmldoc;
        }
	*/
    }

    var signOptionElem = document.getElementById("samltoken.form.create.workflow.steps.sign");
    if (signOptionElem.checked) {
    	var encryptOptionElem = document.getElementById("samltoken.form.create.workflow.steps.encrypt");
    	SamlSelfTokenCreate_initXmlSignEncryptHandler(aWizardPageElem, samlAssertionEditorElem, !encryptOptionElem.checked);
    }

    gWizardButtonNextElem.label = gWizardButtonNextOrigLabel;

    gSamlTokenCreateWizardElem.firstStep = false;
    dump("SamlSelfTokenCreate_CreateSamlAssertionPageAdvanced():................End.\n");
    return true;
}

function SamlSelfTokenCreate_EditSamlAssertionPageShow(aWizardPageElem) 
{
    dump("SamlSelfTokenCreate_EditSamlAssertionPageShow():................Start.\n");


    // gSamlTokenCreateWizardElem.firstStep = false;
    // gSamlTokenCreateWizardElem.canAdvance = false;

    var pageUserNextElem = document.getElementById("samltoken.form.xmldoc.edit.saml.assertion.next");
    gWizardButtonNextElem.label = pageUserNextElem.value;

    var inXmlFilePickerElem = document.getElementById('samltoken.form.xmldoc.edit.saml.assertion.input.filepicker');
    inXmlFilePickerElem.xmldoc = null;
    if (aWizardPageElem.xmldoc) {
    	inXmlFilePickerElem.xmldoc = aWizardPageElem.xmldoc;
    }

    var inXmlFilePickerRowElem = document.getElementById('samltoken.form.xmldoc.edit.saml.assertion.input.file.row');
    if (!gSamlTokenCreateWizardElem.firstStep && !gSamlTokenCreateWizardElem.saveInFile) {
	inXmlFilePickerRowElem.hidden = true;
    }
    else {
        if (aWizardPageElem.filepath) {
            inXmlFilePickerElem.filepath = aWizardPageElem.filepath;
        }
	inXmlFilePickerRowElem.hidden = false;
    }
    // dump("SamlSelfTokenCreate_EditSamlAssertionPageShow():................70.\n");
    handleEditSamlAssertionInFilePathChange(inXmlFilePickerElem);

    var samlAssertionEditorElem = document.getElementById("samltoken.form.xmldoc.edit.saml.assertion.editor");
    // dump("SamlSelfTokenCreate_EditSamlAssertionPageShow():................80.\n");

    var outFilePickerRowElem	= document.getElementById("samltoken.form.xmldoc.edit.saml.assertion.unsigned.out.file.row"); 
    if (!gSamlTokenCreateWizardElem.saveInFile) {
    	outFilePickerRowElem.hidden = true;
	return true;
    }
    outFilePickerRowElem.hidden = false;

    dump("SamlSelfTokenCreate_EditSamlAssertionPageShow():................End.\n");
    return true;
}

function handleEditSamlAssertionInFilePathChange(aFilePickerElem, ev) 
{
    dump("handleEditSamlAssertionInFilePathChange():................Start.\n");

    var samlAssertionEditorElem = document.getElementById("samltoken.form.xmldoc.edit.saml.assertion.editor");

    // dump("handleEditSamlAssertionInFilePathChange(): ev: " + ev + "\n");
    if (ev) {
	aFilePickerElem.xmldoc = null; // Force the parsing of newly choosen XML file 
        if ((aFilePickerElem.value == "") || !aFilePickerElem.file) {
    	    // dump("handleEditSamlAssertionInFilePathChange():................10.\n");
    	    gSamlTokenCreateWizardElem.canAdvance = false;
	    return false;
        }
    }

    var unsignedXmlDoc = aFilePickerElem.xmldoc;
    // dump("handleEditSamlAssertionInFilePathChange(): unsignedXmlDoc: " + unsignedXmlDoc + "\n");
    if (!unsignedXmlDoc) {
	if (!aFilePickerElem.file) {
    	    gSamlTokenCreateWizardElem.canAdvance = false;
	    return false;
	}
    	unsignedXmlDoc = samlAssertionEditorElem.readXMLDocFromFile(aFilePickerElem.file);
    	if (!unsignedXmlDoc) {
    	    dump("handleEditSamlAssertionInFilePathChange(): xmldsigffext_SignEnc_xmlDocParseXmlFile() failed.\n");
    	    gSamlTokenCreateWizardElem.canAdvance = false;
	    return false;
    	}
    }

    if (ev) {
    	gSamlTokenCreateWizardElem.currentPage.xmldoc = unsignedXmlDoc;
    	gSamlTokenCreateWizardElem.currentPage.filepath = aFilePickerElem.filepath;
    }

    var samlAssertionElem = unsignedXmlDoc.documentElement;
    try {
    	samlAssertionEditorElem.displaySamlAssertion(samlAssertionElem);
    } catch (ex) {
    	dump("handleEditSamlAssertionInFilePathChange(): samlAssertionEditorElem.displaySamlAssertion() failed - ex: " + ex + "\n");
    	gSamlTokenCreateWizardElem.canAdvance = false;
	return false;
    }

    if (!gSamlTokenCreateWizardElem.saveInFile) {
    	gSamlTokenCreateWizardElem.canAdvance = true;
	// outXmlFilePickerElem.hidden = true;
    	return true;
    }

    var outXmlFilePickerElem = document.getElementById("samltoken.form.xmldoc.edit.saml.assertion.unsigned.out.filepicker");
    // outXmlFilePickerElem.hidden = false;
    if ((outXmlFilePickerElem.value != "") && outXmlFilePickerElem.file) {
    	gSamlTokenCreateWizardElem.canAdvance = true;
    	// dump("handleEditSamlAssertionInFilePathChange():................20.\n");
    	return true;
    }

    var inXmlFile = aFilePickerElem.file;
    var outXmlFileName = "Edited_" + inXmlFile.leafName;
    // dump("handleEditSamlAssertionInFilePathChange(): outXmlFileName: " + outXmlFileName + "\n");

    var outXmlFileDir = inXmlFile.parent; 
    outXmlFilePickerElem.autoSelectFile(outXmlFileDir, outXmlFileName);
    handleSignOutXMLFilePathChange(outXmlFilePickerElem);
    // dump("handleEditSamlAssertionInFilePathChange(): outXmlFilePath: " + outXmlFilePickerElem.value + "\n");


    dump("handleEditSamlAssertionInFilePathChange():................End.\n");
    return true;
}

function handleEditSamlAssertionInFileChange(ev) 
{
    var samlAssertionFilePickerElem = ev.target;
    // dump("handleEditSamlAssertionInFileChange(): samlAssertionFilePickerElem: " + samlAssertionFilePickerElem + "\n");
    handleEditSamlAssertionInFilePathChange(samlAssertionFilePickerElem, ev);
}

function handleEditSamlAssertionOutFilePathChange(aFilePickerElem, ev) 
{
    if ((aFilePickerElem.value != "") && aFilePickerElem.file) {
    	gSamlTokenCreateWizardElem.canAdvance = true;
    }
    else {
    	gSamlTokenCreateWizardElem.canAdvance = false;
    }
}

function handleEditSamlAssertionOutFileChange(ev) 
{
    var outFilePickerElem = ev.target;
    handleEditSamlAssertionOutFilePathChange(outFilePickerElem, ev);
}



function SamlSelfTokenCreate_EditSamlAssertionPageAdvanced(aWizardPageElem) 
{
    dump("SamlSelfTokenCreate_EditSamlAssertionPageAdvanced():................Start.\n");

    var signOptionElem = document.getElementById("samltoken.form.create.workflow.steps.sign");
    var workflowHasSigning = signOptionElem.checked;

    // Get the SAML Assertion document with Signtaure element in it for SAMLv2.
    var samlAssertionEditorElem = document.getElementById("samltoken.form.xmldoc.edit.saml.assertion.editor");
    var samlSelfTokenAssertionDoc = samlAssertionEditorElem.getSamlAssertionDoc(workflowHasSigning);


    // dump("SamlSelfTokenCreate_EditSamlAssertionPageAdvanced(): nextPage: " + aWizardPageElem.next + "\n");
    var nextPageElem = gSamlTokenCreateWizardElem.getPageById(aWizardPageElem.next);
    nextPageElem.xmldoc = samlSelfTokenAssertionDoc;

    var outFilePickerElem = document.getElementById("samltoken.form.xmldoc.edit.saml.assertion.unsigned.out.filepicker"); 
    if (gSamlTokenCreateWizardElem.saveInFile) {
    	var xmlSerializer = new XMLSerializer();
    	var samlSelfTokenUnsignedXmlDataStr = xmlSerializer.serializeToString(samlSelfTokenAssertionDoc);
    	outFilePickerElem.saveFile(samlSelfTokenUnsignedXmlDataStr);
    	outFilePickerElem.refresh();

    	var outSAMLTokenUnsignedFile = outFilePickerElem.file;
    	if (!outSAMLTokenUnsignedFile.exists() || (outSAMLTokenUnsignedFile.fileSize <= 0)) {
    	    dump("SamlSelfTokenCreate_EditSamlAssertionPageAdvanced(): failed to create Unsigned XML file.\n");
    	    alert("SamlSelfTokenCreate_EditSamlAssertionPageAdvanced(): failed to create Unsigned XML file.\n");
	    return false;
    	}
    	outFilePickerElem.xmldoc = samlSelfTokenAssertionDoc;
    	nextPageElem.filepath = outFilePickerElem.filepath;
    	// dump("SamlSelfTokenCreate_EditSamlAssertionPageAdvanced(): nextPageElem.filepath: " + nextPageElem.filepath + "\n");
    }

    if (gSamlTokenCreateWizardElem.firstStep) {
        if (signOptionElem.checked) {
    	    var encryptOptionElem = document.getElementById("samltoken.form.create.workflow.steps.encrypt");
    	    SamlSelfTokenCreate_initXmlSignEncryptHandler(aWizardPageElem, samlAssertionEditorElem, !encryptOptionElem.checked);
        }
    	// dump("SamlSelfTokenCreate_EditSamlAssertionPageAdvanced():................90.\n");
    }

    gWizardButtonNextElem.label = gWizardButtonNextOrigLabel;

    gSamlTokenCreateWizardElem.firstStep = false;
    dump("SamlSelfTokenCreate_EditSamlAssertionPageAdvanced():................End.\n");
    return true;
}

function SamlSelfTokenCreate_ViewSamlAssertionPageShow(aWizardPageElem) 
{
    dump("SamlSelfTokenCreate_ViewSamlAssertionPageShow():................Start.\n");


    // gSamlTokenCreateWizardElem.firstStep = false;
    // gSamlTokenCreateWizardElem.canAdvance = false;

    // var pageUserNextElem = document.getElementById("samltoken.form.xmldoc.view.saml.assertion.next");
    // gWizardButtonNextElem.label = pageUserNextElem.value;

    var inXmlFilePickerElem = document.getElementById('samltoken.form.xmldoc.view.saml.assertion.input.filepicker');
    inXmlFilePickerElem.xmldoc = null;
    if (aWizardPageElem.xmldoc) {
    	inXmlFilePickerElem.xmldoc = aWizardPageElem.xmldoc;
    }

    var inXmlFilePickerRowElem = document.getElementById('samltoken.form.xmldoc.view.saml.assertion.input.file.row');
    if (!gSamlTokenCreateWizardElem.firstStep && !gSamlTokenCreateWizardElem.saveInFile) {
	inXmlFilePickerRowElem.hidden = true;
    }
    else {
        if (aWizardPageElem.filepath) {
            inXmlFilePickerElem.filepath = aWizardPageElem.filepath;
        }
	inXmlFilePickerRowElem.hidden = false;
    }
    // dump("SamlSelfTokenCreate_ViewSamlAssertionPageShow():................70.\n");
    handleViewSamlAssertionInFilePathChange(inXmlFilePickerElem);

    var samlAssertionViewerElem = document.getElementById("samltoken.form.xmldoc.view.saml.assertion.viewer");
    // dump("SamlSelfTokenCreate_ViewSamlAssertionPageShow():................80.\n");

    dump("SamlSelfTokenCreate_ViewSamlAssertionPageShow():................End.\n");
    return true;
}

function handleViewSamlAssertionInFilePathChange(aFilePickerElem, ev) 
{
    dump("handleViewSamlAssertionInFilePathChange():................Start.\n");

    var samlAssertionViewerElem = document.getElementById("samltoken.form.xmldoc.view.saml.assertion.viewer");

    // dump("handleViewSamlAssertionInFilePathChange(): ev: " + ev + "\n");
    if (ev) {
	aFilePickerElem.xmldoc = null; // Force the parsing of newly choosen XML file 
        if ((aFilePickerElem.value == "") || !aFilePickerElem.file) {
    	    dump("handleViewSamlAssertionInFilePathChange():................10.\n");
    	    gSamlTokenCreateWizardElem.canAdvance = false;
	    return false;
        }
    }

    var unsignedXmlDoc = aFilePickerElem.xmldoc;
    // dump("handleViewSamlAssertionInFilePathChange(): unsignedXmlDoc: " + unsignedXmlDoc + "\n");
    if (!unsignedXmlDoc) {
	if (!aFilePickerElem.file) {
    	    gSamlTokenCreateWizardElem.canAdvance = false;
	    return false;
	}
    	unsignedXmlDoc = samlAssertionViewerElem.readXMLDocFromFile(aFilePickerElem.file);
    	if (!unsignedXmlDoc) {
    	    dump("handleViewSamlAssertionInFilePathChange(): xmldsigffext_SignEnc_xmlDocParseXmlFile() failed.\n");
    	    gSamlTokenCreateWizardElem.canAdvance = false;
	    return false;
    	}
    }

    if (ev) {
    	gSamlTokenCreateWizardElem.currentPage.xmldoc = unsignedXmlDoc;
    	gSamlTokenCreateWizardElem.currentPage.filepath = aFilePickerElem.filepath;
    }

    var samlAssertionElem = unsignedXmlDoc.documentElement;
    try {
    	samlAssertionViewerElem.displaySamlAssertion(samlAssertionElem, true);
    } catch (ex) {
    	dump("handleViewSamlAssertionInFilePathChange(): samlAssertionViewerElem.displaySamlAssertion() failed - ex: " + ex + "\n");
    	gSamlTokenCreateWizardElem.canAdvance = false;
	return false;
    }

    gSamlTokenCreateWizardElem.canAdvance = true;
    dump("handleViewSamlAssertionInFilePathChange():................End.\n");
    return true;
}

function handleViewSamlAssertionInFileChange(ev) 
{
    var samlAssertionFilePickerElem = ev.target;
    // dump("handleViewSamlAssertionInFileChange(): samlAssertionFilePickerElem: " + samlAssertionFilePickerElem + "\n");
    handleViewSamlAssertionInFilePathChange(samlAssertionFilePickerElem, ev);
}

function SamlSelfTokenCreate_ViewSamlAssertionPageAdvanced(aWizardPageElem) 
{
    dump("SamlSelfTokenCreate_ViewSamlAssertionPageAdvanced():................Start.\n");

    var samlAssertionViewerElem = document.getElementById("samltoken.form.xmldoc.view.saml.assertion.viewer");

    // dump("SamlSelfTokenCreate_ViewSamlAssertionPageAdvanced(): nextPage: " + aWizardPageElem.next + "\n");
    var nextPageElem = gSamlTokenCreateWizardElem.getPageById(aWizardPageElem.next);
    nextPageElem.xmldoc = aWizardPageElem.xmldoc;

    var inXmlFilePickerElem = document.getElementById('samltoken.form.xmldoc.view.saml.assertion.input.filepicker');
    if (inXmlFilePickerElem.file) {
    	nextPageElem.filepath = inXmlFilePickerElem.filepath;
    }

    if (gSamlTokenCreateWizardElem.firstStep) {
        var signOptionElem = document.getElementById("samltoken.form.create.workflow.steps.sign");
        if (signOptionElem.checked) {
    	    var encryptOptionElem = document.getElementById("samltoken.form.create.workflow.steps.encrypt");
    	    SamlSelfTokenCreate_initXmlSignEncryptHandler(aWizardPageElem, samlAssertionViewerElem, !encryptOptionElem);
        }
    	// dump("SamlSelfTokenCreate_ViewSamlAssertionPageAdvanced():................80.\n");
    }

    // gWizardButtonNextElem.label = gWizardButtonNextOrigLabel;

    gSamlTokenCreateWizardElem.firstStep = false;
    dump("SamlSelfTokenCreate_ViewSamlAssertionPageAdvanced():................End.\n");
    return true;
}

function SamlSelfTokenCreate_initXmlSignEncryptHandler(aWizardPageElem, samlAssertionElem, aExcludeEncrypt) 
{
    dump("SamlSelfTokenCreate_initXmlSignEncryptHandler():................Start.\n");


    var samlAssertionPrefUtilElem = document.getElementById("samltoken.form.xmldoc.create.samlparams.init.prefutil"); 
    // var credentialType	= samlAssertionPrefUtilElem.getPrefStringValue("xmldsigffext.samltok.sign.credentialType");
    var signatureType = samlAssertionPrefUtilElem.getPrefStringValue("xmldsigffext.samltok.sign.signatureType");
    var canonicalizationMethodName = samlAssertionPrefUtilElem.getPrefStringValue("xmldsigffext.samltok.sign.canonicalizationMethodName");
    var signatureMethodCert = samlAssertionPrefUtilElem.getPrefStringValue("xmldsigffext.samltok.sign.signatureMethod");
    var signatureMethodSymKey = samlAssertionPrefUtilElem.getPrefStringValue("xmldsigffext.samltok.sign.signatureMethod.symkey");
    var signatureMethod = null;

    if (!signatureType) {
    	signatureType = "ENVELOPED_SIGNATURE";
    }
    if (!canonicalizationMethodName) {
    	canonicalizationMethodName = "C14NE_NOC";
    }
    /*
    if (!signatureMethod) {
    	signatureMethod = "http://www.w3.org/2000/09/xmldsig#rsa-sha1";
    }
    */

    var keyInfoParamOptions = null;
    var signerKeyType = null;
    var signerUserName = null;
    var signerSharedKey = null;
    var signerX509Cert = null;

    var samlTokenParamElem = gSamlTokenCreateWizardElem.samlTokenParamElem;
    if (samlTokenParamElem) {
	signerKeyType = samlTokenParamElem.signerKeyType;
	if (samlTokenParamElem.holderofkey && (samlTokenParamElem.credentialType == "symmetrickey")) {
	    signerKeyType = "password";
	    signerUserName = gSamlTokenCreateWizardElem.samlTokenParamElem.signerUserName;
	    signerSharedKey = gSamlTokenCreateWizardElem.samlTokenParamElem.signerSharedKey;
	    if (signerUserName) {
	        keyInfoParamOptions = 1; // KeyName
	    }
    	   signatureMethod = "http://www.w3.org/2000/09/xmldsig#hmac-sha1";
	}
	else {
	    signerX509Cert = gSamlTokenCreateWizardElem.samlTokenParamElem.signerCert;
	    if (signerX509Cert) {
	        keyInfoParamOptions = gSamlTokenCreateWizardElem.samlTokenParamElem.signerKeyInfoParamOptions;
	    }
	}
    }
    // dump("SamlSelfTokenCreate_initXmlSignEncryptHandler(): keyInfoParamOptions: " + keyInfoParamOptions + "\n");

    // dump("SamlSelfTokenCreate_initXmlSignEncryptHandler():................40.\n");
    xmldsigffext_SignEnc_doOnloadInitSignParam(
		signerX509Cert,
		signerUserName,
		signerSharedKey,
		signerKeyType,
		signatureType,
		canonicalizationMethodName,
		signatureMethod,
		keyInfoParamOptions
		);

    if (aExcludeEncrypt) {
    	dump("SamlSelfTokenCreate_initXmlSignEncryptHandler():................End(1).\n");
    	return;
    }

    var kekX509Cert = null;
    var symEncryptMethodAlg = samlAssertionPrefUtilElem.getPrefStringValue("xmldsigffext.samltok.symkey.enc.algorithm");
    var kekEncryptMethodAlg = samlAssertionPrefUtilElem.getPrefStringValue("xmldsigffext.samltok.kek.enc.algorithm");

    if (samlTokenParamElem) {
	if (samlTokenParamElem.holderofkey) {
    	    kekX509Cert = samlTokenParamElem.recipientCert;
	}
    }

    xmldsigffext_SignEnc_doOnloadInitEncParam(
		kekX509Cert,
		kekEncryptMethodAlg,
		symEncryptMethodAlg
    		);

    dump("SamlSelfTokenCreate_initXmlSignEncryptHandler():................End.\n");
}

/*
function SamlSelfTokenCreate_View2amlAssertionPageShow(aWizardPageElem) 
{
    dump("SamlSelfTokenCreate_View2amlAssertionPageShow():................Start.\n");


    gSamlTokenCreateWizardElem.firstStep = false;
    // gSamlTokenCreateWizardElem.canAdvance = false;

    var pageUserNextElem = document.getElementById("samltoken.form.xmldoc.view2.saml.assertion.next");
    gWizardButtonNextElem.label = pageUserNextElem.value;

    var inXmlFilePickerElem = document.getElementById('samltoken.form.xmldoc.view2.saml.assertion.input.filepicker');
    inXmlFilePickerElem.xmldoc = null;
    if (aWizardPageElem.xmldoc) {
    	inXmlFilePickerElem.xmldoc = aWizardPageElem.xmldoc;
    }

    var inXmlFilePickerRowElem = document.getElementById('samltoken.form.xmldoc.view2.saml.assertion.input.file.row');
    if (!gSamlTokenCreateWizardElem.firstStep && !gSamlTokenCreateWizardElem.saveInFile) {
	inXmlFilePickerRowElem.hidden = true;
    }
    else {
        if (aWizardPageElem.filepath) {
            inXmlFilePickerElem.filepath = aWizardPageElem.filepath;
        }
	inXmlFilePickerRowElem.hidden = false;
    }
    dump("SamlSelfTokenCreate_View2amlAssertionPageShow():................70.\n");
    handleView2amlAssertionInFilePathChange(inXmlFilePickerElem);

    var samlAssertionViewerElem = document.getElementById("samltoken.form.xmldoc.view2.saml.assertion.viewer");
    dump("SamlSelfTokenCreate_View2amlAssertionPageShow():................80.\n");

    dump("SamlSelfTokenCreate_View2amlAssertionPageShow():................End.\n");
    return true;
}

function handleView2amlAssertionInFilePathChange(aFilePickerElem, ev) 
{
    dump("handleViewSamlAssertionInFilePathChange():................Start.\n");

    var samlAssertionViewerElem = document.getElementById("samltoken.form.xmldoc.view2.saml.assertion.viewer");

    dump("handleView2amlAssertionInFilePathChange(): ev: " + ev + "\n");
    if (ev) {
	aFilePickerElem.xmldoc = null; // Force the parsing of newly choosen XML file 
        if ((aFilePickerElem.value == "") || !aFilePickerElem.file) {
    	    dump("handleView2amlAssertionInFilePathChange():................10.\n");
    	    gSamlTokenCreateWizardElem.canAdvance = false;
	    return false;
        }
    }

    var unsignedXmlDoc = aFilePickerElem.xmldoc;
    dump("handleView2amlAssertionInFilePathChange(): unsignedXmlDoc: " + unsignedXmlDoc + "\n");
    if (!unsignedXmlDoc) {
	if (!aFilePickerElem.file) {
    	    gSamlTokenCreateWizardElem.canAdvance = false;
	    return false;
	}
    	unsignedXmlDoc = samlAssertionViewerElem.readXMLDocFromFile(aFilePickerElem.file);
    	if (!unsignedXmlDoc) {
    	    dump("handleView2amlAssertionInFilePathChange(): xmldsigffext_SignEnc_xmlDocParseXmlFile() failed.\n");
    	    gSamlTokenCreateWizardElem.canAdvance = false;
	    return false;
    	}
    }

    if (ev) {
    	gSamlTokenCreateWizardElem.currentPage.xmldoc = unsignedXmlDoc;
    	gSamlTokenCreateWizardElem.currentPage.filepath = aFilePickerElem.filepath;
    }

    var samlAssertionElem = unsignedXmlDoc.documentElement;
    try {
    	samlAssertionViewerElem.displaySamlAssertion(samlAssertionElem, true);
    } catch (ex) {
    	dump("handleView2amlAssertionInFilePathChange(): samlAssertionViewerElem.displaySamlAssertion() failed - ex: " + ex + "\n");
    	gSamlTokenCreateWizardElem.canAdvance = false;
	return false;
    }

    dump("handleView2amlAssertionInFilePathChange():................End.\n");
}

function handleView2amlAssertionInFileChange(ev) 
{
    var samlAssertionFilePickerElem = ev.target;
    dump("handleView2amlAssertionInFileChange(): samlAssertionFilePickerElem: " + samlAssertionFilePickerElem + "\n");
    handleViewSamlAssertionInFilePathChange(samlAssertionFilePickerElem, ev);
}

function SamlSelfTokenCreate_View2amlAssertionPageAdvanced(aWizardPageElem) 
{
    dump("SamlSelfTokenCreate_View2amlAssertionPageAdvanced():................Start.\n");

    var samlAssertionViewerElem = document.getElementById("samltoken.form.xmldoc.view2.saml.assertion.viewer");
    var inXmlFilePickerElem = document.getElementById('samltoken.form.xmldoc.view2.saml.assertion.input.filepicker');

    // Get the SAML Assertion document with Signtaure element in it for SAMLv2.
    var samlSelfTokenAssertionDoc = aWizardPageElem.xmldoc;

    dump("SamlSelfTokenCreate_View2amlAssertionPageAdvanced(): nextPage: " + aWizardPageElem.next + "\n");
    var nextPageElem = gSamlTokenCreateWizardElem.getPageById(aWizardPageElem.next);
    nextPageElem.xmldoc = samlSelfTokenAssertionDoc;
    if (inXmlFilePickerElem.file) {
    	nextPageElem.filepath = inXmlFilePickerElem.filepath;
    }

    // SamlSelfTokenCreate_initXmlSignEncryptHandler(aWizardPageElem, samlAssertionViewerElem, false);

    // gWizardButtonNextElem.label = gWizardButtonNextOrigLabel;

    gSamlTokenCreateWizardElem.firstStep = false;
    dump("SamlSelfTokenCreate_View2amlAssertionPageAdvanced():................End.\n");
    return true;
}
*/


