/* @(#) $Id: SamlSelfTokenIdCertClaimForm.js,v 1.3 2008/04/16 00:19:30 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */



// const PERMS_FILE      = 0644;
// const PERMS_DIRECTORY = 0755;

var gCacheSize = 4;

var gUserSamlTokenVersionElem;
/*
var gUserSamlTokenV1ProfileMenuElem;
var gUserSamlTokenV2ProfileMenuElem;
*/
var gSubjectConfirmationRowElem;
var gSubjectConfirmationElem;
var gSubjectConfirmIncludeProofKeyElem;
var gRecipientCertRowElem;

var gSamlTokenIdentityElem;

var gSamlTokenClaimsOutFilePickerElem;
var gSamlTokenOutFilePickerElem;


function samlSelfTokenCertClaims_initClaimsWithCertFormXULElems()
{

    dump("samlSelfTokenCertClaims_initClaimsWithCertFormXULElems():................Start.\n");

    gUserSamlTokenVersionElem	= document.getElementById("samltoken.form.xmldoc.create.certclaims.token.version");

    gSubjectConfirmationRowElem		= document.getElementById("samltoken.form.xmldoc.create.certclaims.token.subject.confirmation.row");
    gSubjectConfirmIncludeProofKeyElem	= document.getElementById("samltoken.form.xmldoc.create.certclaims.token.include.proof.key");

    gRecipientCertRowElem		= document.getElementById("samltoken.form.xmldoc.create.certclaims.token.recipient.cert.row");

    gSamlTokenIdentityElem	= document.getElementById("samltoken.form.xmldoc.create.certclaims.token.credential");


    // samlSelfTokenCertClaims_onIncludeProofKeyChange(gSubjectConfirmIncludeProofKeyElem);

    gSamlTokenClaimsOutFilePickerElem	= document.getElementById("samltoken.form.xmldoc.create.certclaims.token.cert.claims.xmldoc.file.path"); 

    dump("samlSelfTokenCertClaims_initClaimsWithCertFormXULElems():................End.\n");
}

function samlSelfTokenCertClaims_doOnloadInitSignParam(/* String */ outXmlFilePath, /* nsIX509 */ aSelectedSignerCert)
{
    dump("samlSelfTokenCertClaims_doOnloadInitSignParam():................Start.\n");

    if (outXmlFilePath) {
    	gSamlTokenOutFilePickerElem.value = outXmlFilePath;
	gSamlTokenOutFilePickerElem.disabled = true;
    }
    if (aSelectedSignerCert) {
    	gSamlTokenIdentityElem.identityCert = aSelectedSignerCert;
    }

    dump("samlSelfTokenCertClaims_doOnloadInitSignParam():................End.\n");
}


function samlSelfTokenCertClaims_initCertParameters(samlVersion, samlAttrProfileType, credentialType, includeProofKey, identityCert)
{
    dump("samlSelfTokenCertClaims_initCertParameters():................Start.\n");

    dump("samlVersion: " + samlVersion + " " + 
    		"samlAttrProfileType: " + samlAttrProfileType + " " + 
    		"credentialType: " + credentialType + " " + 
    		"includeProofKey: " + includeProofKey + " " + 
    		"identityCert: " + identityCert + " " + 
		"\n");

    gSamlTokenIdentityElem.credentialType = credentialType;
    gSamlTokenIdentityElem.setAttribute("credentialtypedisabled", true);

    var versionElem = document.getElementById("samltoken.form.xmldoc.create.certclaims.token.version");
    versionElem.version = samlVersion;
    versionElem.attributeProfile = samlAttrProfileType;
    versionElem.readonly = true;

    gSubjectConfirmIncludeProofKeyElem.checked = includeProofKey;
    gSubjectConfirmIncludeProofKeyElem.disabled = true;

    if (includeProofKey && identityCert) {
    	gSamlTokenIdentityElem.identityCert = identityCert;
    }
    dump("samlSelfTokenCertClaims_initCertParameters():................30.\n");

    
    dump("samlSelfTokenCertClaims_initCertParameters():................40.\n");

    samlSelfTokenCertClaims_onIncludeProofKeyChange(gSubjectConfirmIncludeProofKeyElem);

    samlSelfTokenCertClaims_initSamlTokenAlias();

    dump("samlSelfTokenCertClaims_initCertParameters():................End.\n");
}


function samlSelfTokenCertClaims_onIncludeProofKeyChange(aIncludeProofKeyElem)
{
    dump("samlSelfTokenCertClaims_onIncludeProofKeyChange():................Start.\n");

    var samlTokenIdentityElem	= document.getElementById("samltoken.form.xmldoc.create.certclaims.token.credential");

    dump("samlSelfTokenCertClaims_onIncludeProofKeyChange():................End.\n");
}


function samlSelfTokenCertClaims_handleTokenCredentialChange(aTokenCredentialElem, ev)
{
    samlSelfTokenCertClaims_initSamlTokenAlias();
}


function samlSelfTokenCertClaims_getSamlTokenAlias()
{
    samlSelfTokenCertClaims_initSamlTokenAlias();

    var samlTokenAliasElem = document.getElementById("samltoken.form.xmldoc.create.certclaims.token.alias");
    return samlTokenAliasElem.value;
}

function samlSelfTokenCertClaims_initSamlTokenAlias()
{
    var samlTokenAliasElem = document.getElementById("samltoken.form.xmldoc.create.certclaims.token.alias");

    var samlTokenIdentityElem	= document.getElementById("samltoken.form.xmldoc.create.certclaims.token.credential");
    var identityCert = samlTokenIdentityElem.identityCert;
    var signerCert = samlTokenIdentityElem.signerCert;
    dump("samlSelfTokenCertClaims_getSamlTokenFileNamePrefx(): signerCert: " + signerCert + "\n");

    var signerAlias = samlTokenIdentityElem.signerAlias;
    dump("samlSelfTokenCertClaims_getSamlTokenFileNamePrefx(): signerAlias: " + signerAlias + "\n");

    var versionElem = document.getElementById("samltoken.form.xmldoc.create.certclaims.token.version");

    var samlVersion = "2";
    if (versionElem.version == "samlv1") {
    	samlVersion = "1";
    }

    var samlTokenAlias = signerAlias + "_" + versionElem.attributeProfile;
    samlTokenAliasElem.value = samlTokenAlias;
}

function samlSelfTokenCertClaims_getSamlTokenFileNamePrefx(aUnsignedFileFlag)
{
    var samlTokenFileName = samlSelfTokenCertClaims_getSamlTokenAlias();
    if (aUnsignedFileFlag) {
    	samlTokenFileName = samlTokenFileName + "_UnsignedToken";
    }
    else {
    	samlTokenFileName = samlTokenFileName + "_SignedToken";
    }
    dump("samlSelfTokenCertClaims_getSamlTokenFileNamePrefx(): samlTokenFileName: " + samlTokenFileName + "\n");
    return samlTokenFileName;
}

function samlSelfTokenCertClaims_autoSelectOutFile(aOutFilePickerElem, outFileName)
{
    var outSignedFileName = outFileName;
    if (!outSignedFileName) {
    	outSignedFileName = "SignedSamlToken.xml";
    }
    return xmldsigffext_autoSelectOutFile(aOutFilePickerElem, outSignedFileName);
}

function samlSelfTokenCertClaims_autoSelectOutUnsignedFile(outFileName)
{
    dump("samlSelfTokenCertClaims_autoSelectOutUnsignedFile(" + outFileName + "):................Start.\n");
    var outSignedFileName = outFileName;
    if (!outSignedFileName) {
    	outSignedFileName = "UnsignedSamlToken.xml";
    }
    dump("samlSelfTokenCertClaims_autoSelectOutUnsignedFile(): gSamlTokenClaimsOutFilePickerElem: " + gSamlTokenClaimsOutFilePickerElem + "\n");
    var unsignedFile =  xmldsigffext_autoSelectOutFile(gSamlTokenClaimsOutFilePickerElem, outSignedFileName);

    dump("samlSelfTokenCertClaims_autoSelectOutUnsignedFile(" + outFileName + "):................End.\n");
    return unsignedFile;
}

/* nsIDOMDocument  */
function samlSelfTokenCertClaims_createUnsignedSamlTokenWithCertToXmlDoc()
{
    dump("samlSelfTokenCertClaims_createUnsignedSamlTokenWithCertToXmlDoc():................Start.\n");

    var samlTokenIdentityElem	= document.getElementById("samltoken.form.xmldoc.create.certclaims.token.credential");

    var /* nsIX509Cert */ identityCert = null;
    // identityCert = xmldsigffext_getSelectedSignerCert();
    identityCert = samlTokenIdentityElem.identityCert;
    if (!identityCert) {
	alert("No user cert is selected.");
    	return null;
    }
    xmldsigffext_loginToCertToken(identityCert);

    /*
    attrProfile = alrIXPSamlTokenSvc::AttrProfile_samlv1;
    attrProfile = alrIXPSamlTokenSvc::AttrProfile_samlv2Basic;
    attrProfile = alrIXPSamlTokenSvc::AttrProfile_samlv2X500;
    attrProfile = alrIXPSamlTokenSvc::AttrProfile_infoCard;
    */

    var versionElem = document.getElementById("samltoken.form.xmldoc.create.certclaims.token.version");
    var attrProfile = versionElem.attributeProfile;

    var attrProfile = Components.interfaces.alrIXPSamlTokenSvc.AttrProfile_samlv1;
    if (versionElem.version == "samlv1") {
    	var samlv1AttrPofileMenuElem = document.getElementById("samltoken.form.xmldoc.create.certclaims.token.v1attr.profile.menulist");
	if (versionElem.attributeProfile == "samlv1") {
    	    attrProfile = Components.interfaces.alrIXPSamlTokenSvc.AttrProfile_samlv1;
	}
	else {
    	    attrProfile = Components.interfaces.alrIXPSamlTokenSvc.AttrProfile_infoCard;
	}
    }
    else if (versionElem.version == "samlv2") {
    	var samlv2AttrPofileMenuElem = document.getElementById("samltoken.form.xmldoc.create.certclaims.token.v2attr.profile.menulist");
	if (versionElem.attributeProfile == "samlv2Basic") {
    	    attrProfile = Components.interfaces.alrIXPSamlTokenSvc.AttrProfile_samlv2Basic;
	}
	else {
    	    attrProfile = Components.interfaces.alrIXPSamlTokenSvc.AttrProfile_samlv2X500;
	}
    }
    else {
	dump("Unknown Saml Token Version: " + versionElem.version + "\n");
	return null;
    }
    dump("samlSelfTokenCertClaims_createUnsignedSamlTokenWithCertToXmlDoc(): attrProfile: " + attrProfile + "\n");

    var samlSelfTokenXmlDoc = null;
    try {
        if (versionElem.version == "samlv1") {
    	    samlSelfTokenXmlDoc = gSamlTokenSvc.createSelfIssuedSAMLv1Token(identityCert, attrProfile);
        }
        else if (versionElem.version == "samlv2") {
    	    samlSelfTokenXmlDoc = gSamlTokenSvc.createSelfIssuedSAMLv2Token(identityCert, attrProfile);
        }
    } catch (ex) {
	alert("Failed to create XML doc for SAML Token - ex: " + ex);
	samlSelfTokenXmlDoc = null;
    }

    dump("samlSelfTokenCertClaims_createUnsignedSamlTokenWithCertToXmlDoc():................End.\n");
    return samlSelfTokenXmlDoc;
}


