/* @(#) $Id: XmlDSigEncWizard.js,v 1.12 2008/05/07 00:09:33 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */



var gParams = null;
var gPkiParams = null;

var gXmlDocWizardInitDone = false;
var gXmlDocWizardElem;

var gWizardButtonNextElem;
var gWizardButtonFinishElem;
var gWizardButtonExtra1Elem;
/*
var gWizardButtonBackElem;
var gWizardButtonExtra2Elem;
var gWizardButtonCancelElem;
*/
var gWizardButtonNextOrigLabel;

function xmldsigffext_SigEncWizard_initOnLoad()
{

    if (gXmlDocWizardInitDone) {
    	return;
    }

    dump("xmldsigffext_SigEncWizard_initOnLoad():................Start.\n");
    gXmlDocWizardInitDone = true;

    xmldsigffext_isSupportedOS();


    gXmlDocWizardElem = document.getElementById('xmldsigffext.signenc.wizard');
    gWizardButtonNextElem = gXmlDocWizardElem.getButton("next");
    gWizardButtonNextOrigLabel = gWizardButtonNextElem.label;

    gWizardButtonFinishElem = gXmlDocWizardElem.getButton("finish");

    gWizardButtonExtra1Elem = gXmlDocWizardElem.getButton("extra1");
    gWizardButtonExtra1Elem.label = gWizardButtonFinishElem.label;
    gWizardButtonExtra1Elem.addEventListener('command', handleExtra1CmdEvent, false);

    // xmldsigffext_SigEncWorkFlow_initOnLoad(gXmlDocWizardElem);

    xmldsigffext_SigEncOverlay_initOnLoad(gXmlDocWizardElem);

    /**********************************************/
    /* TODO:  TEST CODE - remove after test phase */
    /**********************************************/
    var testMode = getPrefBoolValue("xmldsigffext.test");
    if (testMode) {
    try {
        var tokenPassword = "abcd1234";
        var tokendb = Components.classes["@mozilla.org/security/pk11tokendb;1"].
                            getService(Components.interfaces.nsIPK11TokenDB);
        var token = tokendb.getInternalKeyToken();
        if (token) {
            token.checkPassword(tokenPassword);
            token.login(false);
        }
    } catch (ex) {}
    }

    dump("xmldsigffext_SigEncWizard_initOnLoad():................End.\n");
}

function xmldsigffext_doOnloadInitSignParam(
	/* String */ inXmlFilePath,
	/* String */ aOutXmlFilePath,
	/* String */ aWizardCommandSteps,
	/* nsIX509 */ aSelectedSignerCert,
	/* String */ aSignatureType,
	/* String */ aCanonicalizationMethodName,
	/* String */ aSignatureMethod
	)
{
    dump("xmldsigffext_doOnloadInitSignParam():................Start.\n");
    // xmldsigffext_initVerifyFormXULElems();

    dump("inXmlFilePath: " + inXmlFilePath + " " + 
    		"aOutXmlFilePath: " + aOutXmlFilePath + " " + 
    		"aWizardCommandSteps: " + aWizardCommandSteps + " " + 
    		"cert: " + (aSelectedSignerCert?aSelectedSignerCert.nickname:"") + " " + 
    		"aSignatureType: " + aSignatureType + " " + 
    		"aCanonicalizationMethodName: " + aCanonicalizationMethodName + " " + 
    		"aSignatureMethod: " + aSignatureMethod + " " + 
		"\n");

    var xmlDocSaveInFileElem = document.getElementById('xmldsigffext.signenc.xmldoc.workflow.save');
    handleSaveWizardPageOutputChange(xmlDocSaveInFileElem);

    if (inXmlFilePath) {
	gXmlDocWizardElem.inXmlFilePath = inXmlFilePath;
    }

    if (aWizardCommandSteps) {
    	activateCustomWizardPages(aWizardCommandSteps);
    }

    if (aOutXmlFilePath && (aOutXmlFilePath != "")) {
	gXmlDocWizardElem.outXmlFilePath = aOutXmlFilePath;
    	var finalOutXmlFilePickerRowElem = document.getElementById("xmldsigffext.signenc.xmldoc.workflow.out.file.row");
	// finalOutXmlFilePickerRowElem.hidden = true;
    	var finalOutXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.workflow.out.file");
	finalOutXmlFilePickerElem.filepath = aOutXmlFilePath;
	if (finalOutXmlFilePickerElem.file) {
	    finalOutXmlFilePickerElem.disabled = true;
	}
    }

    xmldsigffext_SignEnc_doOnloadInitSignCertParam(
		aSelectedSignerCert,
		aSignatureType,
		aCanonicalizationMethodName,
		aSignatureMethod
    		);
    
    dump("xmldsigffext_doOnloadInitSignParam():................End.\n");
}

function xmldsigffext_initParamsOnLoad()
{
    dump("xmldsigffext_initParamsOnLoad():................Start.\n");

    if ((window.arguments == null) || (window.arguments.length == 0)) {
    	// xmldsigffext_testParamsOnLoad();
    	return false;
    }

    try {
    	gParams = window.arguments[0].QueryInterface(Components.interfaces.nsIDialogParamBlock);
    	gPkiParams = window.arguments[0].QueryInterface(Components.interfaces.nsIPKIParamBlock);
    } catch (ex) {}

    if (!gParams) {
    	return false;
    }

    var paramCnt = gParams.GetInt(0);
    if (paramCnt <= 0) {
    	return false;
    }

    //
    // Parameters are position based (like command line) 
    // in the following order: command-steps, inXMLFile, outXMLFile, signatureType,
    //                         canonicalizationMethodName, signatureMethod.
    // You cannot omit intermediate paramters - "" (zero-length string) in those cases.
    //
    
    var argc = 0;
    var wizardWorkFlowSeq	= gParams.GetString(argc); argc++;
    var unsignedXMLFilePath	= gParams.GetString(argc); argc++;
    var signedXMLFilePath	= gParams.GetString(argc); argc++;


    var signatureType		= gParams.GetString(argc); argc++;
    if (signatureType == "") {
    	signatureType = null;
    }

    var canonicalizationMethodName = gParams.GetString(argc); argc++;
    if (canonicalizationMethodName == "") {
    	canonicalizationMethodName = null;
    }

    var signatureMethod = gParams.GetString(argc); argc++;
    if (signatureMethod == "") {
    	signatureMethod = null;
    }

    var signerX509Cert = null;
    if (gPkiParams) {
    	signerX509Cert = gPkiParams.getISupportAtIndex(0); argc++;
        if (signerX509Cert) {
    	    signerX509Cert = signerX509Cert.QueryInterface(Components.interfaces.nsIX509Cert);
        }
    }

    xmldsigffext_doOnloadInitSignParam(
    		unsignedXMLFilePath,
		signedXMLFilePath,
		wizardWorkFlowSeq,
		signerX509Cert,
		signatureType,
		canonicalizationMethodName
		);

    dump("xmldsigffext_initParamsOnLoad():................End.\n");
    return true;
}

function xmldsigffext_testParamsOnLoad()
{
    dump("xmldsigffext_testParamsOnLoad():................Start.\n");

    var xmlDocInitPrefUtilElem = document.getElementById('xmldsigffext.signenc.xmldoc.init.prefutil');
    var wizardWorkFlowSeq	= xmlDocInitPrefUtilElem.getPrefStringValue("xmldsigffext.sign.wizardWorkFlowSeq");
    var inputXMLFilePath	= xmlDocInitPrefUtilElem.getPrefStringValue("xmldsigffext.sign.inputXMLFilePath");
    var outputXMLFilePath	= xmlDocInitPrefUtilElem.getPrefStringValue("xmldsigffext.sign.outputXMLFilePath");

    var credentialType		= xmlDocInitPrefUtilElem.getPrefStringValue("xmldsigffext.sign.credentialType");
    var signatureType		= xmlDocInitPrefUtilElem.getPrefStringValue("xmldsigffext.sign.signatureType");
    var canonicalizationMethodName = xmlDocInitPrefUtilElem.getPrefStringValue("xmldsigffext.sign.canonicalizationMethodName");
    var signatureMethod		= xmlDocInitPrefUtilElem.getPrefStringValue("xmldsigffext.sign.signatureMethod");
    var signerX509CertNickName	= xmlDocInitPrefUtilElem.getPrefStringValue("xmldsigffext.sign.signerX509CertNickName");
    var signerX509Cert		= null;

    if (signerX509CertNickName && (signerX509CertNickName != "")) {
    	var x509CertDB = Components.classes["@mozilla.org/security/x509certdb;1"].
				getService(Components.interfaces.nsIX509CertDB);
    	try {
    	    signerX509Cert = x509CertDB.findCertByNickname(null, signerX509CertNickName);
    	} catch (ex) { signerX509Cert = null; }
    }


    xmldsigffext_doOnloadInitSignParam(
    		inputXMLFilePath,
		outputXMLFilePath,
		wizardWorkFlowSeq,
		signerX509Cert,
		signatureType,
		canonicalizationMethodName,
		signatureMethod
		);

    dump("xmldsigffext_testParamsOnLoad():................End.\n");
    return true;
}

function xmldsigffext_onFinish(aWizardElem) 
{
}

function xmldsigffext_onCancel(aWizardElem) 
{
}

function handleExtra1CmdEvent(ev) 
{
    dump("handleExtra1CmdEvent():................Start.\n");

    var buttonElem = ev.originalTarget;
    dump("handleExtra1CmdEvent(): buttonElem: " + buttonElem + "\n");
    dump("handleExtra1CmdEvent(): buttonElem: " + buttonElem + " label: " + buttonElem.label + "\n");
    var dlgtype = buttonElem.getAttribute("dlgtype");
    dump("handleExtra1CmdEvent(): dlgtype: " + dlgtype + "\n");
    if (dlgtype != "extra1") {
    	return;
    }

    gXmlDocWizardElem.canAdvance = true;
    gXmlDocWizardElem.goTo("xmldsigffext.signenc.xmldoc.finish");
}


function xmlDocFinishPageShow(aWizardPageElem) 
{
    // dump("xmlDocFinishPageShow():................Start.\n");
    // dump("xmlDocFinishPageShow(): aWizardPageElem.filepath: " + aWizardPageElem.filepath + "\n");
    // dump("xmlDocFinishPageShow(): aWizardPageElem.xmldoc: " + aWizardPageElem.xmldoc + "\n");

    gWizardButtonNextElem.label = gWizardButtonNextOrigLabel;
    gWizardButtonExtra1Elem.hidden = true;

    gXmlDocWizardElem.canAdvance = false;

    var finalXmlFilePathItemElem = document.getElementById("xmldsigffext.signenc.xmldoc.finish.file.path");
    var finalXmlFilePathDataElem = document.getElementById("xmldsigffext.signenc.xmldoc.finish.file.data");
    var finalXmlFilePathDataGBoxElem = document.getElementById("xmldsigffext.signenc.xmldoc.finish.file.data.gbox");
    finalXmlFilePathDataGBoxElem.hidden = true;

    if (!gXmlDocWizardElem.generateOutFile) {
	finalXmlFilePathItemElem.hidden = true;
	// finalXmlFilePathDataGBoxElem.hidden = true;
    	gXmlDocWizardElem.canAdvance = true;
    	// dump("xmlDocFinishPageShow():................End(00).\n");
    	return true;
    }
    finalXmlFilePathItemElem.hidden = false;
    // finalXmlFilePathDataGBoxElem.hidden = false;

    if (aWizardPageElem.xmldoc) {
    	finalXmlFilePathItemElem.xmldoc = aWizardPageElem.xmldoc;
    }
    if (aWizardPageElem.filepath) {
    	finalXmlFilePathItemElem.filepath = aWizardPageElem.filepath;
    }

    if (finalXmlFilePathItemElem.filepath) {
    	// finalXmlFilePathDataElem.value = finalXmlFilePathItemElem.readFile();
    	gXmlDocWizardElem.canAdvance = true;
    	// dump("xmlDocFinishPageShow():................End(01).\n");
    	return true;
    }


    var finalOutXmlFilePickerElem = gXmlDocWizardElem.finalOutXmlFilePickerElem;
    if (!finalOutXmlFilePickerElem.file) {
	var outXmlFile = null;
	// outXmlFile = finalOutXmlFilePickerElem.selectFile();
	if (!outXmlFile) {
	    outXmlFile = finalOutXmlFilePickerElem.autoSelectTempFile("XMLDSigTool", "OutXmlFile.xml");
	}
	finalXmlFilePathItemElem.file = outXmlFile;
    }
    if (!finalXmlFilePathItemElem.file || !aWizardPageElem.xmldoc) {
    	gXmlDocWizardElem.canAdvance = false;
    	return false;
    }
    // dump("xmlDocFinishPageShow():finalXmlFilePathItemElem.filepath: " + finalXmlFilePathItemElem.filepath + "\n");
    try {
    	var /*nsIFile*/ outXmlDocFile  = finalXmlFilePathItemElem.file;
    	dump("xmlDocFinishPageShow(): outXmlDocFile: " + outXmlDocFile + "\n");
    	var sigEncXmlDSigTool = Components.classes["@avaya.com/pkm/xmldsigtool;1"].
    			getService(Components.interfaces.alrIXPXmlDSigTool);
    	sigEncXmlDSigTool.saveXMLDocToFile(
			aWizardPageElem.xmldoc,
			outXmlDocFile
			);
    	// finalXmlFilePathDataElem.value = finalXmlFilePathItemElem.readFile();
    } catch (ex) { 
    	gXmlDocWizardElem.canAdvance = false;
    	return false;
    }

    gXmlDocWizardElem.canAdvance = true;

    // dump("xmlDocFinishPageShow():................End.\n");
    return true;
}

function xmlDocFinishPageAdvanced(aWizardPageElem) 
{
    return true;
}

function xmlDocErrorPageShow(aWizardPageElem) 
{
    return true;
}

