/* @(#) $Id: XmlDSigEncWizardOverlay.js,v 1.8 2008/04/16 00:19:46 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */



var /* nsIX509CertDB	  */ gSigEncCertDB = null;
var /* nsIX509CertDB	  */ gSigEncX509CertDBUtil = null;
var /* alrIXPSignTool	  */ gSigEncXmlDSigTool = null;
var /* alrIXPXmlEncSvc	  */ gSigEncXmlEncSvc = null;

var gXmlDocSignEncWizardElem;

var gSigEncWizardPrefUtilElem;
var gSigEncWizardInitDone = false;
var gSigEncWizardButtonNextElem;
var gSigEncWizardButtonNextOrigLabel;

function xmldsigffext_SigEncOverlay_initOnLoad(aWizardElem)
{
    dump("xmldsigffext_SigEncOverlay_initOnLoad():................Start.\n");
    if (gSigEncWizardInitDone) {
    	return;
    }
    gSigEncWizardInitDone = true;

    gXmlDocSignEncWizardElem = aWizardElem;
    gSigEncWizardButtonNextElem = gXmlDocSignEncWizardElem.getButton("next");
    gSigEncWizardButtonNextOrigLabel = gSigEncWizardButtonNextElem.label;

    /*
    gSigEncWizardPrefUtilElem = document.createElementNS(
    		"http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "prefutil");
    dump("xmldsigffext_SigEncOverlay_initOnLoad(): gSigEncWizardPrefUtilElem: " + gSigEncWizardPrefUtilElem + "\n");
    */
    gSigEncWizardPrefUtilElem = document.getElementById('xmldsigffext.signenc.xmldoc.sign.prefutil');

    initXmlDocSignEncHandler();
    initDefaultXmlDocSigParam();
    initDefaultXmlDocEncryptParam();

    dump("xmldsigffext_SigEncOverlay_initOnLoad():................End.\n");
}

function initXmlDocSignEncHandler()
{
    const  XPILoadErrorMessage = "Make sure that DLLs (shared libraries) from Apache Xerces-C++ and Xalan-C++ are in your PATH (LD_LIBRARY_PATH) environment variable.";

    try {
    	gSigEncCertDB = Components.classes["@mozilla.org/security/x509certdb;1"].
			getService(Components.interfaces.nsIX509CertDB);
    	gSigEncX509CertDBUtil = Components.classes["@avaya.com/pkm/x509certdbutil;1"].
    			getService(Components.interfaces.alrIX509CertDBUtil);
    	gSigEncXmlDSigTool = Components.classes["@avaya.com/pkm/xmldsigtool;1"].
    			getService(Components.interfaces.alrIXPXmlDSigTool);
    	gSigEncXmlEncSvc = Components.classes["@avaya.com/pkm/xmlencsvc;1"].
    			getService(Components.interfaces.alrIXPXmlEncSvc);

    } catch (ex) {
    	alert("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool - ex: " + ex + "\n");
    	dump("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool - ex: " + ex + "\n");
	dump(XPILoadErrorMessage + "\n");
	throw ex;
    }
    if (gSigEncXmlDSigTool == null) {
    	alert("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool.\n");
    	dump("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool.\n");
	dump(XPILoadErrorMessage + "\n");
    	return;
    }
}


function xmldsigffext_SignEnc_doOnloadInitSignParam(
	/* nsIX509 */ aSelectedSignerCert,
	/* String */ aSignerUserName,
	/* String */ aSignerSharedKey,
	/* String */ aCredentialType,
	/* String */ aSignatureType,
	/* String */ aCanonicalizationMethodName,
	/* String */ aSignatureMethod,
	/* String */ aSigKeyInfoParam
	)
{
    dump("xmldsigffext_SignEnc_doOnloadInitSignParam():................Start.\n");
    // xmldsigffext_initVerifyFormXULElems();

    /*
    dump("xmldsigffext_SignEnc_doOnloadInitSignParam():\n" + 
    		"aSignatureType: " + aSignatureType + "\n\t" + 
    		"aCanonicalizationMethodName: " + aCanonicalizationMethodName + "\n\t" + 
    		"aCredentialType: " + aCredentialType + "\n\t" + 
    		" cert: " + (aSelectedSignerCert?aSelectedSignerCert.nickname:"") + "\n\t" + 
    		"aSignerUserName: " + aSignerUserName + "\n\t" + 
    		"aSignerSharedKey: " + aSignerSharedKey + "\n\t" + 
    		"aSignatureMethod: " + aSignatureMethod + "\n\t" + 
    		"aSigKeyInfoParam: " + aSigKeyInfoParam + "\n\t" + 
		"\n"
		);
    */

    var xmlDocSignDSigBoxElem = document.getElementById("xmldsigffext.signenc.xmldoc.sign.xmldsig");

    // Signature type initialization must be the first one.
    // Otherwise, already set parameters will be reinitialized to default value.
    if (aSignatureType) {
    	xmlDocSignDSigBoxElem.signatureType = aSignatureType;
    }

    if (aCanonicalizationMethodName) {
    	xmlDocSignDSigBoxElem.canonicalizationMethodName = aCanonicalizationMethodName;
    }

    if (aSigKeyInfoParam) {
	var keyInfoParamOptions = parseInt(aSigKeyInfoParam);
    	xmlDocSignDSigBoxElem.keyInfoParamOptions = keyInfoParamOptions;
    }

    var credentialType = aCredentialType;
    if (!aCredentialType) {
        if (aSelectedSignerCert) {
    	    credentialType = "certificate";
        }
	else {
    	    credentialType = "password";
	}
    }

    var signatureMethod = aSignatureMethod;
    if (signatureMethod) {
	if (credentialType == "password") {
            if (signatureMethod.indexOf("#hmac-sha") <= 0) {
    	        signatureMethod = "http://www.w3.org/2000/09/xmldsig#hmac-sha1";
            }
	}
	else {
            if (signatureMethod.indexOf("#hmac-sha") > 0) {
    	        signatureMethod = "http://www.w3.org/2000/09/xmldsig#rsa-sha1";
	    }
	}
    }
    else {
	if (credentialType == "password") {
    	    signatureMethod = "http://www.w3.org/2000/09/xmldsig#hmac-sha1";
	}
    }

    if (signatureMethod) {
    	xmlDocSignDSigBoxElem.signatureMethod = signatureMethod;
    }
    xmlDocSignDSigBoxElem.credentialType = credentialType;

    if (xmlDocSignDSigBoxElem.credentialType == "password") {
	if (aSignerUserName) {
    	    xmlDocSignDSigBoxElem.signerUserName = aSignerUserName;
	}
	if (aSignerSharedKey) {
    	    xmlDocSignDSigBoxElem.signerSharedKey = aSignerSharedKey;
	}
    }
    else {
	if (aSelectedSignerCert) {
	    xmlDocSignDSigBoxElem.signerCert = aSelectedSignerCert;
	}
    }

    /*
    dump("xmldsigffext_SignEnc_doOnloadInitSignParam(): xmlDocSignDSigBoxElem: \n" + 
    		"signatureType: " + xmlDocSignDSigBoxElem.signatureType + "\n\t" + 
    		"canonicalizationMethodName: " + xmlDocSignDSigBoxElem.canonicalizationMethodName + "\n\t" + 
    		"credentialType: " + xmlDocSignDSigBoxElem.credentialType + "\n\t" + 
    		"cert: " + (xmlDocSignDSigBoxElem.signerCert?xmlDocSignDSigBoxElem.signerCert.nickname:"") + "\n\t" + 
    		"signerUserName: " + xmlDocSignDSigBoxElem.signerUserName + "\n\t" + 
    		"signerSharedKey: " + xmlDocSignDSigBoxElem.signerSharedKey + "\n\t" + 
    		"signatureMethod: " + xmlDocSignDSigBoxElem.signatureMethod + "\n\t" + 
    		"keyInfoParamOptions: " + xmlDocSignDSigBoxElem.keyInfoParamOptions + " " + 
		"\n"
		);
    */

    dump("xmldsigffext_SignEnc_doOnloadInitSignParam():................End.\n");
}

function xmldsigffext_SignEnc_doOnloadInitSignSymKeyParam(
	/* String */ aSignerUserName,
	/* String */ aSignerSharedKey,
	/* String */ aSignatureType,
	/* String */ aCanonicalizationMethodName,
	/* String */ aSignatureMethod,
	/* String */ aSigKeyInfoParam
	)
{
    var credentialType = "password";
    var signatureMethod = aSignatureMethod;
    if (!signatureMethod || signatureMethod.indexOf("#hmac-sha") <= 0) {
    	signatureMethod = "http://www.w3.org/2000/09/xmldsig#hmac-sha1";
    }
    xmldsigffext_SignEnc_doOnloadInitSignParam(
		null,
		aSignerUserName,
		aSignerSharedKey,
		credentialType,
		aSignatureType,
    		aCanonicalizationMethodName,
		signatureMethod,
		aSigKeyInfoParam
		);
}

function xmldsigffext_SignEnc_doOnloadInitSignCertParam(
	/* nsIX509 */ aSelectedSignerCert,
	/* String */ aSignatureType,
	/* String */ aCanonicalizationMethodName,
	/* String */ aSignatureMethod,
	/* String */ aSigKeyInfoParam
	)
{
    dump("xmldsigffext_SignEnc_doOnloadInitSignCertParam():................Start.\n");

    var credentialType = "certificate";

    var signatureMethod = aSignatureMethod;
    if (!signatureMethod || signatureMethod.indexOf("#hmac-sha") > 0) {
    	signatureMethod = "http://www.w3.org/2000/09/xmldsig#rsa-sha1";
    }
    xmldsigffext_SignEnc_doOnloadInitSignParam(
		aSelectedSignerCert,
		null,
		null,
		credentialType,
		aSignatureType,
    		aCanonicalizationMethodName,
		signatureMethod,
		aSigKeyInfoParam
		);

    dump("xmldsigffext_SignEnc_doOnloadInitSignCertParam():................End.\n");
}


function initDefaultXmlDocSigParam()
{
    dump("initDefaultXmlDocSigParam():................Start.\n");

    // TODO: Obtain these parameters from preferences

    /*
    var xmlDocSignDSigBoxElem = document.getElementById("xmldsigffext.signenc.xmldoc.sign.xmldsig");
    xmlDocSignDSigBoxElem.signatureType = "ENVELOPED_SIGNATURE";
    xmlDocSignDSigBoxElem.credentialType = "certificate";
    xmlDocSignDSigBoxElem.canonicalizationMethodName = "C14NE_NOC";
    xmlDocSignDSigBoxElem.signatureMethod = "http://www.w3.org/2000/09/xmldsig#rsa-sha1";
    */
    // dump("initDefaultXmlDocSigParam(): gSigEncWizardPrefUtilElem: " + gSigEncWizardPrefUtilElem + "\n");

    var signatureType		= gSigEncWizardPrefUtilElem.getPrefStringValue("xmldsigffext.sign.signatureType");
    var credentialType		= gSigEncWizardPrefUtilElem.getPrefStringValue("xmldsigffext.sign.credentialType");
    var canonicalizationMethodName = gSigEncWizardPrefUtilElem.getPrefStringValue("xmldsigffext.sign.canonicalizationMethodName");
    var certSignatureMethod	= gSigEncWizardPrefUtilElem.getPrefStringValue("xmldsigffext.sign.signatureMethod");
    var symKeySignatureMethod	= gSigEncWizardPrefUtilElem.getPrefStringValue("xmldsigffext.sign.signatureMethod.symkey");
    var signatureMethod = null; 
    if (credentialType == "certificate") {
    	signatureMethod = certSignatureMethod;
    }
    else {
    	signatureMethod = symKeySignatureMethod;
    }

    /*
    if (!signatureType) {
    	signatureType = "ENVELOPED_SIGNATURE";
    }

    if (!canonicalizationMethodName) {
    	canonicalizationMethodName = "C14NE_NOC";
    }

    if (!credentialType) {
    	credentialType = "certificate";
    }
    if (!signatureMethod) {
    	signatureMethod = "http://www.w3.org/2000/09/xmldsig#rsa-sha1";
    }
    */

    var signerX509CertNickName	= gSigEncWizardPrefUtilElem.getPrefStringValue("xmldsigffext.sign.signerX509CertNickName");

    var signerX509Cert = null;
    if (signerX509CertNickName && (signerX509CertNickName != "") 
    				&& (credentialType == "certificate")) {
    	var x509CertDB = Components.classes["@mozilla.org/security/x509certdb;1"].
				getService(Components.interfaces.nsIX509CertDB);
    	try {
    	    signerX509Cert = x509CertDB.findCertByNickname(null, signerX509CertNickName);
    	} catch (ex) { signerX509Cert = null; }
	/*
        if (signerX509Cert) {
	    xmlDocSignDSigBoxElem.signerCert = signerX509Cert;
        }
	*/
    }

    if (credentialType == "certificate") {
    	xmldsigffext_SignEnc_doOnloadInitSignCertParam(
		signerX509Cert,
		signatureType,
		canonicalizationMethodName,
		signatureMethod
		);
    }
    else {
    	xmldsigffext_SignEnc_doOnloadInitSignSymKeyParam(
		null, null,
		signatureType,
		canonicalizationMethodName,
		signatureMethod
		);
    }

    dump("initDefaultXmlDocSigParam():................End.\n");
}


function xmldsigffext_SignEnc_testParamsOnLoad()
{
    dump("xmldsigffext_SignEnc_testParamsOnLoad():................Start.\n");

    var credentialType		= gSigEncWizardPrefUtilElem.getPrefStringValue("xmldsigffext.sign.credentialType");
    var signatureType		= gSigEncWizardPrefUtilElem.getPrefStringValue("xmldsigffext.sign.signatureType");
    var canonicalizationMethodName = gSigEncWizardPrefUtilElem.getPrefStringValue("xmldsigffext.sign.canonicalizationMethodName");
    var signatureMethod		= gSigEncWizardPrefUtilElem.getPrefStringValue("xmldsigffext.sign.signatureMethod");
    var signerX509CertNickName	= gSigEncWizardPrefUtilElem.getPrefStringValue("xmldsigffext.sign.signerX509CertNickName");
    var signerX509Cert		= null;

    if (signerX509CertNickName && (signerX509CertNickName != "")) {
    	var x509CertDB = Components.classes["@mozilla.org/security/x509certdb;1"].
				getService(Components.interfaces.nsIX509CertDB);
    	try {
    	    signerX509Cert = x509CertDB.findCertByNickname(null, signerX509CertNickName);
    	} catch (ex) { signerX509Cert = null; }
    }


    xmldsigffext_SignEnc_doOnloadInitSignCertParam(
		signerX509Cert,
		signatureType,
		canonicalizationMethodName,
		signatureMethod
		);

    dump("xmldsigffext_SignEnc_testParamsOnLoad():................End.\n");
    return true;
}



function xmldsigffext_SignEnc_xmlDocParseXmlFile(aXmlDocInFilePicker)
{
    dump("xmldsigffext_SignEnc_xmlDocParseXmlFile():................Start.\n");

    var unsignedXmlFile = aXmlDocInFilePicker.file;
    if (unsignedXmlFile == null) {
    	// alert("xmldsigffext_SignEnc_xmlDocParseXmlFile(): signed XML file name is missing.\n");
    	dump("xmldsigffext_SignEnc_xmlDocParseXmlFile(): signed XML file name is missing.\n");
    	return null;
    }
    if (unsignedXmlFile.fileSize == 0) {
    	alert("xmldsigffext_SignEnc_xmlDocParseXmlFile(): Zero-length XML file - pick another one.\n");
    	dump("xmldsigffext_SignEnc_xmlDocParseXmlFile(): Zero-length XML file - pick another one.\n");
    	return null;
    }

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
    var /* nsIDOMDocument */ unsignedXmlDoc = gSigEncXmlDSigTool.readXMLDocFromFile(unsignedXmlFile);
    if (!unsignedXmlDoc) {
    	alert("xmldsigffext_SignEnc_xmlDocParseXmlFile(): Not a valid XML file.\n");
    	dump("xmldsigffext_SignEnc_xmlDocParseXmlFile(): Not a valid XML file.\n");
    	return null;
    }
    if (unsignedXmlDoc.documentElement.tagName == "parsererror") {
    	alert("xmldsigffext_SignEnc_xmlDocParseXmlFile(): Parsing of  XML file failed.\n");
    	dump("xmldsigffext_SignEnc_xmlDocParseXmlFile(): Parsing of  XML file failed.\n");
    	return null;
    }
    aXmlDocInFilePicker.xmldoc = unsignedXmlDoc;

    return unsignedXmlDoc;
}


function xmlDocSignPageShow(aWizardPageElem) 
{
    dump("xmlDocSignPageShow():................Start.\n");

    // gXmlDocSignEncWizardElem.canAdvance = false;


    var pageUserNextElem = document.getElementById("xmldsigffext.signenc.xmldoc.sign.next");
    gSigEncWizardButtonNextElem.label = pageUserNextElem.value;

    var inXmlFilePickerElem = document.getElementById('xmldsigffext.signenc.xmldoc.unsigned.file.path');
    inXmlFilePickerElem.xmldoc = null;

    var inXmlFilePickerRowElem = document.getElementById('xmldsigffext.signenc.xmldoc.unsigned.file.row');
    if (!gXmlDocSignEncWizardElem.firstStep && !gXmlDocSignEncWizardElem.saveInFile) {
	inXmlFilePickerRowElem.hidden = true;
    }
    else {
        if (aWizardPageElem.filepath) {
            inXmlFilePickerElem.filepath = aWizardPageElem.filepath;
        }
	inXmlFilePickerRowElem.hidden = false;
    }

    if (aWizardPageElem.xmldoc) {
    	inXmlFilePickerElem.xmldoc = aWizardPageElem.xmldoc;
    }

    var outXmlFilePickerRowElem = document.getElementById("xmldsigffext.signenc.xmldoc.signed.file.row");
    // if (gXmlDocSignEncWizardElem.saveInFile || aWizardPageElem.lastStep) {
    if (gXmlDocSignEncWizardElem.saveInFile) {
    	outXmlFilePickerRowElem.hidden = false;
    }
    else {
	outXmlFilePickerRowElem.hidden = true;
    }

    handleSignInXMLFilePathChange(inXmlFilePickerElem);

    gXmlDocSignEncWizardElem.firstStep = false;
    dump("xmlDocSignPageShow():................End.\n");
    return true;
}


function handleSignInXMLFilePathChange(aFilePickerElem, ev) 
{
    dump("handleSignInXMLFilePathChange():................Start.\n");

    // dump("handleSignInXMLFilePathChange(): ev: " + ev + "\n");
    if (ev) {
	aFilePickerElem.xmldoc = null; // Force the parsing of newly choosen XML file 
        if ((aFilePickerElem.value == "") || !aFilePickerElem.file) {
    	    // dump("handleSignInXMLFilePathChange():................10.\n");
    	    gXmlDocSignEncWizardElem.canAdvance = false;
    	    return false;
        }
    }

    var unsignedXmlDoc = aFilePickerElem.xmldoc;
    // dump("handleSignInXMLFilePathChange(): unsignedXmlDoc: " + unsignedXmlDoc + "\n");
    if (!unsignedXmlDoc) {
	if (!aFilePickerElem.file) {
    	    gXmlDocSignEncWizardElem.canAdvance = false;
	    return false;
	}
    	unsignedXmlDoc = xmldsigffext_SignEnc_xmlDocParseXmlFile(aFilePickerElem);
    	if (!unsignedXmlDoc) {
    	    dump("handleSignInXMLFilePathChange(): xmldsigffext_SignEnc_xmlDocParseXmlFile() failed.\n");
    	    gXmlDocSignEncWizardElem.canAdvance = false;
	    return false;
    	}
    }

    if (ev) {
    	gXmlDocSignEncWizardElem.currentPage.xmldoc = unsignedXmlDoc;
    	gXmlDocSignEncWizardElem.currentPage.filepath = aFilePickerElem.filepath;
    }

    var xmlDocSignDSigBoxElem = document.getElementById("xmldsigffext.signenc.xmldoc.sign.xmldsig");
    try {
    	xmlDocSignDSigBoxElem.displayXmlDoc(unsignedXmlDoc);
    } catch (ex) {
    	dump("xmldsigffext_displayXmlDoc(): xmlDocSignDSigBoxElem.displayXmlDoc() failed - ex: " + ex + "\n");
    	gXmlDocSignEncWizardElem.canAdvance = false;
	return false;
    }

    var outXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.signed.file.path");
    // if (!gXmlDocSignEncWizardElem.saveInFile && !gXmlDocSignEncWizardElem.currentPage.lastStep) {
    if (!gXmlDocSignEncWizardElem.saveInFile) {
    	gXmlDocSignEncWizardElem.canAdvance = true;
	outXmlFilePickerElem.hidden = true;
    	return true;
    }
    outXmlFilePickerElem.hidden = false;

    if ((outXmlFilePickerElem.value != "") && outXmlFilePickerElem.file) {
    	gXmlDocSignEncWizardElem.canAdvance = true;
    	// dump("handleSignInXMLFilePathChange():................20.\n");
    	return true;
    }

    var inXmlFile = aFilePickerElem.file;
    var outXmlFileName = "Signed_" + inXmlFile.leafName;
    // dump("handleSignInXMLFilePathChange(): outXmlFileName: " + outXmlFileName + "\n");

    var outXmlFileDir = inXmlFile.parent; 
    outXmlFilePickerElem.autoSelectFile(outXmlFileDir, outXmlFileName);

    handleSignOutXMLFilePathChange(outXmlFilePickerElem);

    // dump("xmlDocEncryptPageShow(): outXmlFilePath: " + outXmlFilePickerElem.value + "\n");


    dump("handleSignInXMLFilePathChange():................End.\n");
    return true;
}

function handleUnsignedXMLFileChange(ev) 
{
    var signedFilePickerElem = ev.target;
    dump("handleSignInXMLFileChange(): signedFilePickerElem: " + signedFilePickerElem + "\n");
    handleSignInXMLFilePathChange(signedFilePickerElem, ev);
}

function handleSignOutXMLFilePathChange(aFilePickerElem, ev) 
{
    if ((aFilePickerElem.value != "") && aFilePickerElem.file) {
    	gXmlDocSignEncWizardElem.canAdvance = true;
    }
    else {
    	gXmlDocSignEncWizardElem.canAdvance = false;
    }
}

function handleSignedXMLFileChange(ev) 
{
    var encyptedFilePickerElem = ev.target;
    handleSignOutXMLFilePathChange(encyptedFilePickerElem, ev);
}

function xmlDocSignPageAdvanced(aWizardPageElem) 
{
    dump("xmlDocSignPageAdvanced():................Start.\n");

    var xmlDocSignDSigBoxElem = document.getElementById("xmldsigffext.signenc.xmldoc.sign.xmldsig");
    // var signedXmlDoc = xmlDocSignDSigBoxElem.signXMLDocToFile(outXmlFilePickerElem);
    var signedXmlDoc = xmlDocSignDSigBoxElem.signXMLDoc();
    if (!signedXmlDoc) {
	alert("Failed to sign XML Doc.");
	dump("Failed to sign XML Doc.\n");
    	return false;
    }

    var nextPageElem = gXmlDocSignEncWizardElem.getPageById(aWizardPageElem.next);
    nextPageElem.xmldoc = signedXmlDoc;

    try {
    	// if (gXmlDocSignEncWizardElem.saveInFile || aWizardPageElem.lastStep) {
    	if (gXmlDocSignEncWizardElem.saveInFile) {
    	    var outXmlFilePickerElem = document.getElementById('xmldsigffext.signenc.xmldoc.signed.file.path');
    	    var /*nsIFile*/ signOutXmlDocFile  = outXmlFilePickerElem.file;
    	    gSigEncXmlDSigTool.saveXMLDocToFile(
			signedXmlDoc,
			signOutXmlDocFile
			);
    	    outXmlFilePickerElem.xmldoc = signedXmlDoc;
    	    nextPageElem.filepath = outXmlFilePickerElem.filepath;
	}
    } catch (ex) {
    	dump("xmlDocEncryptPageAdvanced(): gSigEncXmlDSigTool.saveXMLDocToFile() failed - ex: " + ex + "\n");
    	return false;
    }

    gSigEncWizardButtonNextElem.label = gSigEncWizardButtonNextOrigLabel;

    dump("xmlDocSignPageAdvanced():................End.\n");
    return true;
}

function xmlDocVerifyPageShow(aWizardPageElem) 
{
    dump("xmlDocVerifyPageShow():................Start.\n");
    gXmlDocSignEncWizardElem.canAdvance = false;

    var pageUserNextElem = document.getElementById("xmldsigffext.signenc.xmldoc.verify.next");
    gSigEncWizardButtonNextElem.label = pageUserNextElem.value;

    var inXmlFileGridElem = document.getElementById('xmldsigffext.signenc.xmldoc.verify.file.grid');
    var inXmlFilePickerElem = document.getElementById('xmldsigffext.signenc.xmldoc.verify.file.path');
    inXmlFilePickerElem.xmldoc = null;

    // var inXmlFilePickerRowElem = document.getElementById('xmldsigffext.signenc.xmldoc.verify.file.row');
    if (!gXmlDocSignEncWizardElem.firstStep && !gXmlDocSignEncWizardElem.saveInFile) {
	inXmlFileGridElem.hidden = true;
	// inXmlFilePickerElem.hidden = true;
    }
    else {
        if (aWizardPageElem.filepath) {
            inXmlFilePickerElem.filepath = aWizardPageElem.filepath;
        }
	// inXmlFilePickerElem.hidden = false;
	inXmlFileGridElem.hidden = false;
    }


    if (aWizardPageElem.xmldoc) {
    	inXmlFilePickerElem.xmldoc = aWizardPageElem.xmldoc;
    }
    handleVerifyInXMLFilePathChange(inXmlFilePickerElem);

    // var xmlDocVerifyDSigBoxElem = document.getElementById("xmldsigffext.signenc.xmldoc.verify.xmldsig");
    
    gXmlDocSignEncWizardElem.firstStep = false;

    dump("xmlDocVerifyPageShow():................End.\n");
    return true;
}

function handleVerifyInXMLFilePathChange(aFilePickerElem, ev) 
{
    dump("handleVerifyInXMLFilePathChange():................Start.\n");

    if (ev) {
	aFilePickerElem.xmldoc = null;
        if ((aFilePickerElem.value == "") || !aFilePickerElem.file) {
    	    dump("handleSignInXMLFilePathChange(): NULL signed XML file is selected.\n");
    	    gXmlDocSignEncWizardElem.canAdvance = false;
    	    return false;
        }
    }

    var signedXmlDoc = aFilePickerElem.xmldoc;
    if (!signedXmlDoc) {
    	signedXmlDoc = xmldsigffext_SignEnc_xmlDocParseXmlFile(aFilePickerElem);
    	if (!signedXmlDoc) {
    	    dump("handleVerifyInXMLFilePathChange(): xmldsigffext_SignEnc_xmlDocParseXmlFile() failed.\n");
    	    gXmlDocSignEncWizardElem.canAdvance = false;
    	    return false;
        }
    }
    var xmlDocVerifyDSigBoxElem	= document.getElementById("xmldsigffext.signenc.xmldoc.verify.xmldsig");
    try {
    	xmlDocVerifyDSigBoxElem.displayXmlDoc(signedXmlDoc);
    } catch (ex) {
    	dump("handleVerifyInXMLFilePathChange(): xmlDocVerifyDSigBoxElem.displayXmlDoc() failed - ex: " + ex + "\n");
    	gXmlDocSignEncWizardElem.canAdvance = false;
	return false;
    }

    if (ev) {
    	gXmlDocSignEncWizardElem.currentPage.xmldoc = signedXmlDoc;
    	gXmlDocSignEncWizardElem.currentPage.filepath = aFilePickerElem.filepath;
    }

    gXmlDocSignEncWizardElem.canAdvance = true;

    dump("handleVerifyInXMLFilePathChange():................End.\n");
    return true;
}

function handleVerifyXMLFileChange(ev) 
{
    var signedFilePickerElem = ev.target;
    handleVerifyInXMLFilePathChange(signedFilePickerElem, ev);
}

function xmlDocVerifyPageAdvanced(aWizardPageElem) 
{
    dump("xmlDocVerifyPageAdvanced():................Start.\n");
    gSigEncWizardButtonNextElem.label = gSigEncWizardButtonNextOrigLabel;

    // var xmlDocVerifyDSignatureElem = document.getElementById("xmldsigffext.signenc.xmldoc.verify.xmldsig");
    var xmlDocVerifyDSigBoxElem	= document.getElementById("xmldsigffext.signenc.xmldoc.verify.xmldsig");
    var isVerified = xmlDocVerifyDSigBoxElem.verifyXMLDoc();
    if (!isVerified) {
    	alert("Failed to verify the signature in the signed XML document.");
	return false;
    }
    alert("Successfully verified signtaure in the signed XML document.");

    /*
    var inXmlFilePickerElem = document.getElementById('xmldsigffext.signenc.xmldoc.verify.file.path');
    if (!inXmlFilePickerElem.file) {
	return false;
    }
    */

    var nextPageElem = gXmlDocSignEncWizardElem.getPageById(aWizardPageElem.next);
    nextPageElem.xmldoc = aWizardPageElem.xmldoc;

    var inXmlFilePickerElem = document.getElementById('xmldsigffext.signenc.xmldoc.verify.file.path');
    // if (gXmlDocSignEncWizardElem.saveInFile || aWizardPageElem.lastStep) {
    if (gXmlDocSignEncWizardElem.saveInFile) {
    	nextPageElem.filepath = inXmlFilePickerElem.filepath;
    }

    dump("xmlDocVerifyPageAdvanced():................End.\n");
    return isVerified;
}


function xmldsigffext_SignEnc_doOnloadInitEncParam(
	/* nsIX509 */ aKekEncryptX509Cert,
	/* String */ aKekEncryptMethodAlg,
	/* String */ aSymEncryptMethodAlg
	)
{
    dump("xmldsigffext_SignEnc_doOnloadInitEncParam():................Start.\n");

    dump("\taKekEncryptX509Cert: " + (aKekEncryptX509Cert?aKekEncryptX509Cert.nickname:"") + "\n\t" + 
    		"aKekEncryptMethodAlg: " + aKekEncryptMethodAlg + "\n\t" + 
    		"aSymEncryptMethodAlg: " + aSymEncryptMethodAlg + "\n\t" + 
		"\n"
		);
    if (aSymEncryptMethodAlg && (aSymEncryptMethodAlg != "")) {
    	var symEncryptMethodElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.symkey.enc.method");
    	symEncryptMethodElem.Algorithm = aSymEncryptMethodAlg;
    }

    if (aKekEncryptMethodAlg && (aSymEncryptMethodAlg != "")) {
    	var kekEncryptMethodElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.kek.enc.method");
    	kekEncryptMethodElem.Algorithm = aKekEncryptMethodAlg;
    }
    
    if (aKekEncryptX509Cert) {
    	var kekX509CertPickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.kek.certpicker");
    	kekX509CertPickerElem.initWithCert(aKekEncryptX509Cert);
    }

    dump("xmldsigffext_SignEnc_doOnloadInitEncParam():................End.\n");
}

function initDefaultXmlDocEncryptParam()
{
    // TODO: Obtain these parameters from preferences

    var symEncryptMethodAlg	= gSigEncWizardPrefUtilElem.getPrefStringValue("xmldsigffext.encrypt.symkey.enc.algorithm");
    var kekEncryptMethodAlg	= gSigEncWizardPrefUtilElem.getPrefStringValue("xmldsigffext.encrypt.kek.enc.algorithm");
    var kekX509Cert = null;

    xmldsigffext_SignEnc_doOnloadInitEncParam(
		kekX509Cert,
		kekEncryptMethodAlg,
		symEncryptMethodAlg
    		);
}


function xmlDocEncryptPageShow(aWizardPageElem) 
{
    dump("xmlDocEncryptPageShow():................Start.\n");
    // gXmlDocSignEncWizardElem.canAdvance = false;

    var pageUserNextElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.next");
    gSigEncWizardButtonNextElem.label = pageUserNextElem.value;

    var inXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.in.file.path");
    inXmlFilePickerElem.xmldoc = null;

    var inXmlFilePickerRowElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.in.file.row");
    if (!gXmlDocSignEncWizardElem.firstStep && !gXmlDocSignEncWizardElem.saveInFile) {
	inXmlFilePickerRowElem.hidden = true;
    }
    else {
        if (aWizardPageElem.filepath) {
            inXmlFilePickerElem.filepath = aWizardPageElem.filepath;
        }
	inXmlFilePickerRowElem.hidden = false;
    }

    if (aWizardPageElem.xmldoc) {
    	inXmlFilePickerElem.xmldoc = aWizardPageElem.xmldoc;
    }
    handleEncryptInXMLFilePathChange(inXmlFilePickerElem);

    var outXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.out.file.path");

    var outXmlFilePickerRowElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.out.file.row");
    // if (gXmlDocSignEncWizardElem.saveInFile || aWizardPageElem.lastStep) {
    if (gXmlDocSignEncWizardElem.saveInFile) {
    	outXmlFilePickerRowElem.hidden = false;
    }
    else {
	outXmlFilePickerRowElem.hidden = true;
    }


    gXmlDocSignEncWizardElem.firstStep = false;

    dump("xmlDocEncryptPageShow():................End.\n");
    return true;
}


function handleEncryptInXMLFilePathChange(aFilePickerElem, ev) 
{
    dump("handleEncryptInXMLFilePathChange():................Start.\n");

    if (ev) {
	aFilePickerElem.xmldoc = null;
        if ((aFilePickerElem.value == "") || !aFilePickerElem.file) {
    	    // dump("handleEncryptInXMLFilePathChange():................10.\n");
    	    gXmlDocSignEncWizardElem.canAdvance = false;
    	    return false;
    	}
    }

    var plainXmlDoc = aFilePickerElem.xmldoc;
    if (!plainXmlDoc) {
    	plainXmlDoc = xmldsigffext_SignEnc_xmlDocParseXmlFile(aFilePickerElem);
    	if (!plainXmlDoc) {
    	    gXmlDocSignEncWizardElem.canAdvance = false;
    	    return false;
    	}
    }

    if (ev) {
    	gXmlDocSignEncWizardElem.currentPage.xmldoc = plainXmlDoc;
    	gXmlDocSignEncWizardElem.currentPage.filepath = aFilePickerElem.filepath;
    }

    var outXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.out.file.path");
    // if (!gXmlDocSignEncWizardElem.saveInFile && !gXmlDocSignEncWizardElem.currentPage.lastStep) {
    if (!gXmlDocSignEncWizardElem.saveInFile) {
    	gXmlDocSignEncWizardElem.canAdvance = true;
	outXmlFilePickerElem.hidden = true;
    	return true;
    }

    outXmlFilePickerElem.hidden = false;

    if ((outXmlFilePickerElem.value != "") && outXmlFilePickerElem.file) {
    	gXmlDocSignEncWizardElem.canAdvance = true;
    	// dump("handleEncryptInXMLFilePathChange():................20.\n");
    	return true;
    }
    // dump("handleEncryptInXMLFilePathChange():................30.\n");

    var inXmlFile = aFilePickerElem.file;
    var outXmlFileName = "Encrypted_" + inXmlFile.leafName;

    // dump("xmlDocEncryptPageShow(): outXmlFileName: " + outXmlFileName + "\n");
    var outXmlFileDir = inXmlFile.parent; 
    outXmlFilePickerElem.autoSelectFile(outXmlFileDir, outXmlFileName);

    handleEncryptOutXMLFilePathChange(outXmlFilePickerElem);
    // dump("xmlDocEncryptPageShow(): outXmlFilePath: " + outXmlFilePickerElem.value + "\n");

    dump("handleEncryptInXMLFilePathChange():................End.\n");
    return false;
}

function handlePlainXMLFileChange(ev) 
{
    var signedFilePickerElem = ev.target;
    handleEncryptInXMLFilePathChange(signedFilePickerElem, ev);
}


function handleEncryptOutXMLFilePathChange(aFilePickerElem, ev) 
{
    dump("handleEncryptOutXMLFilePathChange():................Start.\n");
    if ((aFilePickerElem.value != "") && aFilePickerElem.file) {
    	gXmlDocSignEncWizardElem.canAdvance = true;
    }
    else {
    	gXmlDocSignEncWizardElem.canAdvance = false;
    }
}

function handleEncryptedXMLFileChange(ev) 
{
    // dump("handleEncryptedXMLFileChange():................Start.\n");

    var encyptedFilePickerElem = ev.target;
    handleEncryptOutXMLFilePathChange(encyptedFilePickerElem, ev);
}

function handleXmlDocEncryptCertChange(aKekCertPickerElem, ev) 
{
    dump("handleXmlDocEncryptCertChange():................Start.\n");
    dump("handleXmlDocEncryptCertChange():................End.\n");
}


function xmlDocEncryptPageAdvanced(aWizardPageElem) 
{
    dump("xmlDocEncryptPageAdvanced():................Start.\n");

    var kekX509CertPickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.kek.certpicker");

    var kekX509Cert = kekX509CertPickerElem.selectedCert;
    if (!kekX509Cert) {
    	dump("xmlDocEncryptPageAdvanced(): no encryption certificate is present.\n");
    	return false;
    }

    /*
    void alrIXPXmlDocSvc.encryptXMLFile (
    		in nsILocalFile aInPlainXMLFile,
		in string aEncryptionKeyType,
		in nsIX509Cert aEncryptCert,
		in string aKeyEncryptionAlgorithmURI,
		in nsILocalFile aOutEncryptedXMLFile
		);
    void encryptXMLFileWithParams (
    		in nsILocalFile aInPlainXMLFile,
		in nsIX509Cert aKekX509Cert,
		in nsIPersistentProperties aEncryptionProps,
		in nsILocalFile aOutEncryptedXMLFile
		);
    */

    var docEncryptMethodElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.symkey.enc.method");
    var kekKeyInfoParamElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.kek.keyinfo");
    var kekEncryptMethodElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.kek.enc.method");

    var /* nsIPersistentProperties */ xmlDocEncProps = null;
    xmlDocEncProps = Components.classes["@mozilla.org/persistent-properties;1"].
			createInstance(Components.interfaces.nsIPersistentProperties);
    kekKeyInfoParamElem.getKeyInfoParameters(xmlDocEncProps);

    docEncryptMethodElem.getParameters(xmlDocEncProps);
    kekEncryptMethodElem.getParameters(xmlDocEncProps);
    // dumpProperties(xmlDocEncProps, "xmlDocEncProps:");

    var encryptionKeyType = docEncryptMethodElem.getAttribute("Algorithm");
    var keyEncryptionAlgorithmURI = kekEncryptMethodElem.getAttribute("Algorithm");
    var encryptedXmlDoc = null;

    var encryptInXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.in.file.path");
    try {
	/*
    	gSigEncXmlEncSvc.encryptXMLFileWithParams(
		encryptInXmlFile,
		kekX509Cert,
		xmlDocEncProps,
		encryptOutXmlDocFile
		);
	*/
    	encryptedXmlDoc = gSigEncXmlEncSvc.encryptXMLDocWithParams(
		aWizardPageElem.xmldoc,
		kekX509Cert,
		xmlDocEncProps
		);
    } catch (ex) {
    	dump("xmlDocEncryptPageAdvanced(): gSigEncXmlEncSvc.encryptXMLDocWithParams() failed - ex: " + ex + "\n");
    	return false;
    }
    var nextPageElem = gXmlDocSignEncWizardElem.getPageById(aWizardPageElem.next);
    nextPageElem.xmldoc = encryptedXmlDoc;

    try {
        // if (gXmlDocSignEncWizardElem.saveInFile || aWizardPageElem.lastStep) {
    	if (gXmlDocSignEncWizardElem.saveInFile) {
            var outXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.out.file.path");
    	    var /*nsIFile*/ encryptOutXmlDocFile  = outXmlFilePickerElem.file;
    	    gSigEncXmlDSigTool.saveXMLDocToFile(
			encryptedXmlDoc,
			encryptOutXmlDocFile
			);
    	    outXmlFilePickerElem.xmldoc = encryptedXmlDoc;
    	    nextPageElem.filepath = outXmlFilePickerElem.filepath;
	}
    } catch (ex) {
    	dump("xmlDocEncryptPageAdvanced(): gSigEncXmlDSigTool.saveXMLDocToFile() failed - ex: " + ex + "\n");
    	return false;
    }

    gSigEncWizardButtonNextElem.label = gSigEncWizardButtonNextOrigLabel;

    dump("xmlDocEncryptPageAdvanced():................End.\n");
    return true;
}

function xmlDocDecryptPageShow(aWizardPageElem) 
{
    dump("xmlDocDecryptPageShow():................Start.\n");

    var pageUserNextElem = document.getElementById("xmldsigffext.signenc.xmldoc.decrypt.next");
    gSigEncWizardButtonNextElem.label = pageUserNextElem.value;
    // gXmlDocSignEncWizardElem.canAdvance = false;

    var decryptInXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.decrypt.in.file.path");
    decryptInXmlFilePickerElem.xmldoc = null;

    var inXmlFilePickerRowElem = document.getElementById("xmldsigffext.signenc.xmldoc.decrypt.in.file.row");
    if (!gXmlDocSignEncWizardElem.firstStep && !gXmlDocSignEncWizardElem.saveInFile) {
	inXmlFilePickerRowElem.hidden = true;
    }
    else {
        if (aWizardPageElem.filepath) {
            decryptInXmlFilePickerElem.filepath = aWizardPageElem.filepath;
        }
	inXmlFilePickerRowElem.hidden = false;
    }

    if (aWizardPageElem.xmldoc) {
    	decryptInXmlFilePickerElem.xmldoc = aWizardPageElem.xmldoc;
    }
    dump("xmlDocDecryptPageShow(): decryptInXmlFilePickerElem.xmldoc: " + decryptInXmlFilePickerElem.xmldoc + "\n");
    var outXmlFilePickerRowElem = document.getElementById("xmldsigffext.signenc.xmldoc.decrypt.out.file.row");
    // if (gXmlDocSignEncWizardElem.saveInFile || aWizardPageElem.lastStep) {
    if (gXmlDocSignEncWizardElem.saveInFile) {
    	outXmlFilePickerRowElem.hidden = false;
    }
    else {
	outXmlFilePickerRowElem.hidden = true;
    }


    gXmlDocSignEncWizardElem.canAdvance = false;
    handleDecryptInXMLFilePathChange(decryptInXmlFilePickerElem);

    gXmlDocSignEncWizardElem.firstStep = false;

    dump("xmlDocDecryptPageShow():................End.\n");
}


function handleDecryptInXMLFilePathChange(aFilePickerElem, ev) 
{
    dump("handleDecryptInXMLFilePathChange():................Start.\n");

    if (ev) {
	aFilePickerElem.xmldoc = null;
    	if ((aFilePickerElem.value == "") || !aFilePickerElem.file) {
    	    gXmlDocSignEncWizardElem.canAdvance = false;
    	    dump("handleDecryptInXMLFilePathChange(): no input XML file.\n");
    	    return false;
        }
    }

    var encryptedXmlDoc = aFilePickerElem.xmldoc;
    if (!encryptedXmlDoc) {
    	encryptedXmlDoc = xmldsigffext_SignEnc_xmlDocParseXmlFile(aFilePickerElem);
    	if (!encryptedXmlDoc) {
    	    gXmlDocSignEncWizardElem.canAdvance = false;
    	    return false;
    	}
    }

    if (ev) {
    	gXmlDocSignEncWizardElem.currentPage.xmldoc = encryptedXmlDoc;
    	gXmlDocSignEncWizardElem.currentPage.filepath = aFilePickerElem.filepath;
    }

    /*
    var xulEncXmlElemList = encryptedXmlDoc.getElementsByTagName("EncryptedData");
    var xulEncXmlElem = null;
    if (xulEncXmlElemList && (xulEncXmlElemList.length > 0)) {
    	xulEncXmlElem = xulEncXmlElemList.item(0);
    }
    */

    var encryptedDataBoxElem = document.getElementById("xmldsigffext.signenc.xmldoc.decrypt.encryptedDataBox");
    encryptedDataBoxElem.displayXmlDoc(encryptedXmlDoc);

    var kekX509Cert = encryptedDataBoxElem.kekX509Cert;
    // dump("handleDecryptInXMLFilePathChange(): kekX509Cert: " + kekX509Cert + "\n");
    if (!kekX509Cert) {
	var msg = "Will not be able to decrypt the XML doc - couldn't decode the KEK from keyinfo.";
	dump(msg + "\n");
	alert(msg);
    	gXmlDocSignEncWizardElem.canAdvance = false;
    	return false;
    }

    // dump("handleDecryptInXMLFilePathChange(): kekX509Cert: " + kekX509Cert.nickname + "\n");
    if (!gSigEncX509CertDBUtil.isUserCert(kekX509Cert)) {
	var msg = "Will not be able to decrypt the XML doc - No private key associate with the KEK cert for " + kekX509Cert.nickname + " in the Certificate DB."
	dump(msg + "\n");
	alert(msg);
    	gXmlDocSignEncWizardElem.canAdvance = false;
    	return false;
    }
    gXmlDocSignEncWizardElem.canAdvance = true;

    var outXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.decrypt.out.file.path");
    // if (!gXmlDocSignEncWizardElem.saveInFile && !gXmlDocSignEncWizardElem.currentPage.lastStep) {
    if (!gXmlDocSignEncWizardElem.saveInFile) {
    	gXmlDocSignEncWizardElem.canAdvance = true;
    	return true;
    }

    if ((outXmlFilePickerElem.value != "") && outXmlFilePickerElem.file) {
    	gXmlDocSignEncWizardElem.canAdvance = true;
    	return true;
    }
    // dump("handleDecryptInXMLFilePathChange(): no output XML file.\n");

    var inXmlFile = aFilePickerElem.file;
    var outXmlFileName = "Plain_" + inXmlFile.leafName;
    // dump("handleDecryptInXMLFilePathChange(): outXmlFileName: " + outXmlFileName + "\n");

    var outXmlFileDir = inXmlFile.parent; 
    outXmlFilePickerElem.autoSelectFile(outXmlFileDir, outXmlFileName);
    handleDecryptedOutXMLFilePathChange(outXmlFilePickerElem);
    // dump("handleDecryptInXMLFilePathChange(): outXmlFilePath: " + outXmlFilePickerElem.value + "\n");

    dump("handleDecryptInXMLFilePathChange():................End.\n");
    return true;
}

function handleDecryptInXMLFileChange(ev) 
{
    var decyptInFilePickerElem = ev.target;
    // handleDecryptInXMLFilePathChange(decyptInFilePickerElem, ev);
    handleDecryptInXMLFilePathChange(decyptInFilePickerElem);
}

function handleDecryptedOutXMLFilePathChange(aTargetElem, ev) 
{
    // dump("handleDecryptedOutXMLFilePathChange():................Start.\n");
    if ((aTargetElem.value != "") && aTargetElem.file) {
    	gXmlDocSignEncWizardElem.canAdvance = true;
    }
    // dump("handleDecryptedOutXMLFilePathChange():................End.\n");
}

function handleDecryptedXMLFileChange(ev) 
{
    var decyptedFilePickerElem = ev.target;
    handleDecryptedXMLFilePathChange(decyptedFilePickerElem, ev);
}

function xmlDocDecryptPageAdvanced(aWizardPageElem) 
{
    dump("xmlDocDecryptPageAdvanced():................Start.\n");

    var inXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.decrypt.in.file.path");
    var /*nsIFile*/ encryptedXmlDocFile  = inXmlFilePickerElem.file;
    // dump("xmlDocDecryptPageShow(): inXmlFilePickerElem.xmldoc: " + inXmlFilePickerElem.xmldoc + "\n");

    var encryptedDataBoxElem = document.getElementById("xmldsigffext.signenc.xmldoc.decrypt.encryptedDataBox");
    var kekX509Cert = encryptedDataBoxElem.kekX509Cert;
    if (kekX509Cert) {
    	if (!gSigEncX509CertDBUtil.isUserCert(kekX509Cert)) {
	    var msg = "Unable to decrypt the XML doc - No private key associate with this KEK cert in the DB."
	    dump(msg + "\n");
	    alert(msg);
	    return false;
	}
    }

    /*
    void alrIXPXmlDocSvc.decryptXMLDoc (
    		in nsILocalFile aInPlainXMLDoc,
		inout nsIX509Cert aEncryptCert,
		);
    */

    var kekX509CertObj = new Object();
    if (kekX509Cert) {
    	kekX509CertObj.value = kekX509Cert;
    }
    var plainXmlDoc = null;
    try {
    	plainXmlDoc = gSigEncXmlEncSvc.decryptXMLDoc(
		inXmlFilePickerElem.xmldoc,
		kekX509CertObj
		);
    	if (!kekX509Cert && kekX509CertObj.value) {
	    kekX509Cert = kekX509CertObj.value;
	}
    } catch (ex) {
    	dump("xmlDocDecryptPageAdvanced(): gSigEncXmlEncSvc.decryptXMLDoc() failed - ex: " + ex + "\n");
    	alert("Failed to decrypt the document.");
    	return false;
    }
    alert("Successfully decrypted the document.");

    // dump("xmlDocDecryptPageAdvanced(): aWizardPageElem.next: " + aWizardPageElem.next + "\n");
    var nextPageElem = gXmlDocSignEncWizardElem.getPageById(aWizardPageElem.next);
    nextPageElem.xmldoc = plainXmlDoc;

    try {
        // if (gXmlDocSignEncWizardElem.saveInFile || aWizardPageElem.lastStep) {
    	if (gXmlDocSignEncWizardElem.saveInFile) {
    	    var outXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.decrypt.out.file.path");
    	    var /*nsIFile*/ plainXmlDocFile  = outXmlFilePickerElem.file;
    	    gSigEncXmlDSigTool.saveXMLDocToFile(
			plainXmlDoc,
			plainXmlDocFile
			);
    	    outXmlFilePickerElem.xmldoc = plainXmlDoc;
    	    nextPageElem.filepath = outXmlFilePickerElem.filepath;
	}
    } catch (ex) {
    	dump("xmlDocDecryptPageAdvanced(): gSigEncXmlEncSvc.saveXMLDocToFile() failed - ex: " + ex + "\n");
    	return false;
    }

    gSigEncWizardButtonNextElem.label = gSigEncWizardButtonNextOrigLabel;

    dump("xmlDocDecryptPageAdvanced():................End.\n");
    return true;
}

function xmlDocVerify2PageShow(aWizardPageElem) 
{
    dump("xmlDocVerify2PageShow():................Start.\n");
    // gXmlDocSignEncWizardElem.canAdvance = false;

    var pageUserNextElem = document.getElementById("xmldsigffext.signenc.xmldoc.verify2.next");
    gSigEncWizardButtonNextElem.label = pageUserNextElem.value;

    var inXmlFileGridElem = document.getElementById('xmldsigffext.signenc.xmldoc.verify2.file.grid');
    var inXmlFilePickerElem = document.getElementById('xmldsigffext.signenc.xmldoc.verify2.file.path');

    // var inXmlFilePickerRowElem = document.getElementById("xmldsigffext.signenc.xmldoc.verify2.file.row");
    if (!gXmlDocSignEncWizardElem.firstStep && !gXmlDocSignEncWizardElem.saveInFile) {
	// inXmlFilePickerElem.hidden = true;
	inXmlFileGridElem.hidden = true;
    }
    else {
        if (aWizardPageElem.filepath) {
            inXmlFilePickerElem.filepath = aWizardPageElem.filepath;
        }
	// inXmlFilePickerElem.hidden = false;
	inXmlFileGridElem.hidden = false;
    }

    if (aWizardPageElem.xmldoc) {
    	inXmlFilePickerElem.xmldoc = aWizardPageElem.xmldoc;
    }
    
    var plainXmlDoc = inXmlFilePickerElem.xmldoc;
    if (!plainXmlDoc) {
    	plainXmlDoc = xmldsigffext_SignEnc_xmlDocParseXmlFile(inXmlFilePickerElem);
    }
    
    var xmlDocVerifyTokenDSignatureElem = document.getElementById("xmldsigffext.signenc.xmldoc.verify2.xmldsig");
    xmlDocVerifyTokenDSignatureElem.displayXmlDoc(plainXmlDoc);

    gXmlDocSignEncWizardElem.firstStep = false;

    dump("xmlDocVerify2PageShow():................End.\n");
    return true;
}

function xmlDocVerify2PageAdvanced(aWizardPageElem) 
{
    // dump("xmlDocVerify2PageAdvanced():................Start.\n");
    gSigEncWizardButtonNextElem.label = gSigEncWizardButtonNextOrigLabel;

    var xmlDocVerifyTokenDSignatureElem = document.getElementById("xmldsigffext.signenc.xmldoc.verify2.xmldsig");
    var isVerified = xmlDocVerifyTokenDSignatureElem.verifyXMLDoc();
    if (!isVerified) {
    	alert("Failed to verify the signature in the signed XML document.");
	return false;
    }
    alert("Successfully verified signtaure in the signed XML document.");


    // dump("xmlDocVerify2PageAdvanced(): aWizardPageElem.next: " + aWizardPageElem.next + "\n");
    var nextPageElem = gXmlDocSignEncWizardElem.getPageById(aWizardPageElem.next);
    nextPageElem.xmldoc = aWizardPageElem.xmldoc;

    var inXmlFilePickerElem = document.getElementById('xmldsigffext.signenc.xmldoc.verify2.file.path');
    // if (gXmlDocSignEncWizardElem.saveInFile || aWizardPageElem.lastStep) {
    if (gXmlDocSignEncWizardElem.saveInFile) {
    	nextPageElem.filepath = inXmlFilePickerElem.filepath;
    }

    // dump("xmlDocVerify2PageAdvanced():................End.\n");
    return isVerified;
}

