/* @(#) $Id: XmlDSigEncWorkFlowInit.js,v 1.2 2008/05/07 00:09:33 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */



var gXmlDocWizardWorkFlowInitDone = false;
var gXmlDocWorkFlowWizardElem;
var gXmlDocSaveInFileElem;
var gButtonNextOrigLabel;

function xmldsigffext_SigEncWorkFlow_initOnLoad(aWizardElem)
{
    if (gXmlDocWizardWorkFlowInitDone) {
    	return;
    }

    // dump("SamlSelfTokenCreateWorkFlowInit_initOnLoad():................Start.\n");
    gXmlDocWizardWorkFlowInitDone = true;


    gXmlDocWorkFlowWizardElem = aWizardElem;
    var wizardButtonNextElem = gXmlDocWorkFlowWizardElem.getButton("next");
    gButtonNextOrigLabel = wizardButtonNextElem.label;


    // gFinalXmlFilePathItemElem = document.getElementById("xmldsigffext.signenc.xmldoc.finish.file.path");
    gXmlDocSaveInFileElem = document.getElementById('xmldsigffext.signenc.xmldoc.workflow.save');

    // dump("SamlSelfTokenCreateWorkFlowInit_initOnLoad():................End.\n");
}

function xmlDocWorkFlowInitPageShow(aWizardPageElem) 
{
    // dump("\n");
    // dump("xmlDocWorkFlowInitPageShow():................Start.\n");


    xmldsigffext_SigEncWorkFlow_initOnLoad(aWizardPageElem.parentNode);

    gXmlDocWorkFlowWizardElem.canAdvance = false;

    var wizardButtonNextElem = gXmlDocWorkFlowWizardElem.getButton("next");
    wizardButtonNextElem.label = gButtonNextOrigLabel;

    var xmlDocWorkFlowGroupElem = document.getElementById("xmldsigffext.signenc.xmldoc.workflow.group");
    handleXmlDocWorkFlowSeqChange(xmlDocWorkFlowGroupElem);

    // xmldsigffext_initParamsOnLoad();

    gXmlDocWorkFlowWizardElem.canAdvance = true;
    // dump("xmlDocWorkFlowInitPageShow():................End.\n");
    // dump("\n");
}

function updateWizardPageWorkFlowSequence() 
{
    // dump("updateWizardPageWorkFlowSequence():................Start.\n");

    var startingPageId = null;
    var prevPageId = null;
    var lastPageElem = null;

    var xmlDocWorkFlowStepsRowElem = document.getElementById("xmldsigffext.signenc.xmldoc.workflow.steps.row");
    var xmlDocWorkFlowStepsElems = xmlDocWorkFlowStepsRowElem.getElementsByTagName("checkbox");

    var totStepCnt = 0;
    var generateOutFile = false;
    for (var i = 0; i < xmlDocWorkFlowStepsElems.length; i++) {
    	var xmlDocWorkFlowStepElem = xmlDocWorkFlowStepsElems.item(i);
	if (!xmlDocWorkFlowStepElem.checked) {
	    continue;
	}
	var cmdPageId = xmlDocWorkFlowStepElem.getAttribute("cmdPageId");
	if (!cmdPageId) {
	    continue;
	}
	if (prevPageId) {
    	    var prevPageElem = gXmlDocWorkFlowWizardElem.getPageById(prevPageId);
	    if (prevPageElem) {
	    	prevPageElem.next = cmdPageId;
    	    	// dump("updateWizardPageWorkFlowSequence(): " + prevPageId + " ==> " + cmdPageId + "\n");
	    }
	}

	prevPageId = cmdPageId;
	if (!startingPageId) {
	    startingPageId = cmdPageId;
	}
	if (xmlDocWorkFlowStepElem.getAttribute("genoutfile") == "true") {
	    generateOutFile = true;
	}
	totStepCnt++;
    }
    if (prevPageId) {
    	var lastPageElem = gXmlDocWorkFlowWizardElem.getPageById(prevPageId);
	if (lastPageElem) {
    	    lastPageElem.next = "xmldsigffext.signenc.xmldoc.finish";
	    lastPageElem.lastStep = true;
    	    // dump("updateWizardPageWorkFlowSequence(): " + prevPageId + " ==> " + lastPageElem.next + "\n");
	}
    }
    if (startingPageId) {
    	setStartingWizardPage(startingPageId);
    }

    var xmlDocSaveInFileRowElem = document.getElementById('xmldsigffext.signenc.xmldoc.workflow.save.row');
    var xmlDocSaveInFileElem = document.getElementById('xmldsigffext.signenc.xmldoc.workflow.save');
    var finalOutXmlFilePickerRowElem = document.getElementById("xmldsigffext.signenc.xmldoc.workflow.out.file.row");
    var finalOutXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.workflow.out.file");


    // dump("updateWizardPageWorkFlowSequence(): generateOutFile: " + generateOutFile + " totStepCnt: " + totStepCnt + "\n");
    gXmlDocWorkFlowWizardElem.finalOutXmlFilePickerElem = finalOutXmlFilePickerElem;
    gXmlDocWorkFlowWizardElem.generateOutFile = generateOutFile;

    if (generateOutFile) {
	if (totStepCnt > 1) {
    	    xmlDocSaveInFileRowElem.hidden = false;
	}
	else {
    	    xmlDocSaveInFileRowElem.hidden = true;
	}
	handleSaveWizardPageOutputChange(xmlDocSaveInFileElem);
    	// finalOutXmlFilePickerRowElem.hidden = false;
    }
    else {
    	xmlDocSaveInFileRowElem.hidden = true;
    	finalOutXmlFilePickerRowElem.hidden = true;
	if (!finalOutXmlFilePickerElem.disabled) {
	    finalOutXmlFilePickerElem.filepath = "";
	}
    }
    if (!finalOutXmlFilePickerElem.disabled) {
    	handleFinalOutXMLFileChange(finalOutXmlFilePickerElem);
    }

    // dump("updateWizardPageWorkFlowSequence():................End.\n");
    return startingPageId;
}

function activateWizardPages(aWorkFlowPageNameList) 
{
    // dump("activateWizardPages():................Start.\n");

    var workFlowPageNames = aWorkFlowPageNameList.split(",");
    for (var i = 0; i < workFlowPageNames.length; i++) {
    	var workFlowPageName = workFlowPageNames[i];
	var workFlowPageActiveElemId = "xmldsigffext.signenc.xmldoc.workflow.steps." + workFlowPageName;
    	// dump("activateWizardPages(): workFlowPageActiveElemId: " + workFlowPageActiveElemId + "\n");
        var workFlowPageActiveElem = document.getElementById(workFlowPageActiveElemId);
	if (!workFlowPageActiveElem) {
	    continue;
	}
	workFlowPageActiveElem.checked = true;
    }

    updateWizardPageWorkFlowSequence();

    // dump("activateWizardPages():................End.\n");
    return true;
}

function handleXmlDocWorkFlowSeqChange(aXmlDocWorkFlowGroupElem, ev) 
{
    // dump("handleXmlDocWorkFlowSeqChange():................Start.\n");

    var xmlDocWorkFlowItemElem = aXmlDocWorkFlowGroupElem.selectedItem;
    var workFlowItemValue = xmlDocWorkFlowItemElem.value;

    var xmlDocWorkFlowStepsRowElem = document.getElementById("xmldsigffext.signenc.xmldoc.workflow.steps.row");
    var xmlDocWorkFlowStepsElems = xmlDocWorkFlowStepsRowElem.getElementsByTagName("checkbox");
    for (var i = 0; i < xmlDocWorkFlowStepsElems.length; i++) {
    	var xmlDocWorkFlowStepElem = xmlDocWorkFlowStepsElems.item(i);
	xmlDocWorkFlowStepElem.checked = false;
	if (workFlowItemValue == "custom") {
	    xmlDocWorkFlowStepElem.disabled = false;
	}
	else {
	    xmlDocWorkFlowStepElem.disabled = true;
	}
    }
    if (workFlowItemValue != "custom") {
    	activateWizardPages(workFlowItemValue);
    }

    // dump("handleXmlDocWorkFlowSeqChange():................End.\n");
}

function activateCustomWizardPages(aCustomWorkFlowSeq) 
{
    // dump("activateCustomWizardPages(" + aCustomWorkFlowSeq + "):................Start.\n");

    var workFlowSeqItemElem = null;
    var workFlowSeqGroupElem = document.getElementById("xmldsigffext.signenc.xmldoc.workflow.group");

    if (!aCustomWorkFlowSeq || (aCustomWorkFlowSeq == "")) {
    	// dump("activateCustomWizardPages(" + aCustomWorkFlowSeq + "):................10.\n");
	// TODO: Get the default actions from the preference.
    	workFlowSeqItemElem = document.getElementById("xmldsigffext.signenc.xmldoc.workflow.item01");
    	workFlowSeqGroupElem.selectedItem = workFlowSeqItemElem;
	handleXmlDocWorkFlowSeqChange(workFlowSeqGroupElem);
	return workFlowSeqItemElem;
    }

    var workFlowSeqItemElemList = workFlowSeqGroupElem.getElementsByAttribute("value", aCustomWorkFlowSeq);
    if (workFlowSeqItemElemList && (workFlowSeqItemElemList.length > 0)) {
    	// dump("activateCustomWizardPages(" + aCustomWorkFlowSeq + "):................20.\n");
	// Found an existing workflow seq item - so select that one and then update the workflow page sequence
    	workFlowSeqItemElem = workFlowSeqItemElemList.item(0);
	workFlowSeqGroupElem.selectedItem = workFlowSeqItemElem;
	handleXmlDocWorkFlowSeqChange(workFlowSeqGroupElem);
	return workFlowSeqItemElem;
    }
    // dump("activateCustomWizardPages(" + aCustomWorkFlowSeq + "):................30.\n");

    workFlowSeqItemElem = document.getElementById("xmldsigffext.signenc.xmldoc.workflow.custom");
    workFlowSeqGroupElem.selectedItem = workFlowSeqItemElem;
    handleXmlDocWorkFlowSeqChange(workFlowSeqGroupElem);
    // dump("activateCustomWizardPages(" + aCustomWorkFlowSeq + "):................40.\n");

    activateWizardPages(aCustomWorkFlowSeq);

    // dump("activateCustomWizardPages():................End.\n");
    return workFlowSeqItemElem;
}

function setStartingWizardPage(aStartingPageId) 
{
    // dump("setStartingWizardPage(): aStartingPageId: " + aStartingPageId + "\n");

    gXmlDocWorkFlowWizardElem.currentPage.next = aStartingPageId;

    // Make the input file picker for the first step browsable/modifiable element.
    var nextPageElem = gXmlDocWorkFlowWizardElem.getPageById(aStartingPageId);
    var nexPageInputFilePickerElemList = nextPageElem.getElementsByAttribute("fileMode", "open");
    if (nexPageInputFilePickerElemList.length > 0) {
	var nexPageInputFilePickerElem = nexPageInputFilePickerElemList.item(0);
	nexPageInputFilePickerElem.removeAttribute("readonly");
	nexPageInputFilePickerElem.removeAttribute("browsehidden");
    }
}

function handleXmlDocWorkFlowStepsChange(ev) 
{
    // dump("handleXmlDocWorkFlowStepsChange():................Start.\n");

    var targetElem = ev.targetElem;

    if (ev) {
    	ev.stopPropagation();
    }

    var startingPageId = updateWizardPageWorkFlowSequence();
    if (!startingPageId) {
    	gXmlDocWorkFlowWizardElem.canAdvance = false;
    	return;
    }

    gXmlDocWorkFlowWizardElem.canAdvance = true;

    // dump("handleXmlDocWorkFlowStepsChange():................End.\n");
}

function handleSaveWizardPageOutputChange(aSaveInFileElem, ev) 
{
    gXmlDocWorkFlowWizardElem.saveInFile = aSaveInFileElem.checked;

    var finalOutXmlFilePickerRowElem = document.getElementById("xmldsigffext.signenc.xmldoc.workflow.out.file.row");
    if (aSaveInFileElem.checked) {
    	finalOutXmlFilePickerRowElem.hidden = true;
    }
    else {
    	finalOutXmlFilePickerRowElem.hidden = false;
    }
}

function handleFinalOutXMLFileChange(aFinalOutXmlFilePickerElem, ev) 
{
    var finalOutXmlFilePath = aFinalOutXmlFilePickerElem.filepath;
    if (aFinalOutXmlFilePickerElem.file) {
    	gXmlDocWorkFlowWizardElem.outXmlFilePath = aFinalOutXmlFilePickerElem.filepath;
    }
    else {
    	gXmlDocWorkFlowWizardElem.outXmlFilePath = null;
    }
}

function xmlDocWorkFlowInitPageAdvanced(aWizardPageElem) 
{
    // dump("xmlDocWorkFlowInitPageAdvanced():................Start.\n");

    gXmlDocWorkFlowWizardElem.saveInFile = gXmlDocSaveInFileElem.checked;

    var nextPageElem = gXmlDocWorkFlowWizardElem.getPageById(aWizardPageElem.next);
    if (gXmlDocWorkFlowWizardElem.xmldoc) {
    	nextPageElem.xmldoc = gXmlDocWorkFlowWizardElem.xmldoc;
    }

    if (gXmlDocWorkFlowWizardElem.inXmlFilePath) {
    	nextPageElem.filepath = gXmlDocWorkFlowWizardElem.inXmlFilePath;
    	// dump("xmlDocWorkFlowInitPageAdvanced(): nextPageElem.filepath: " + nextPageElem.filepath + "\n");
    }

    gXmlDocWorkFlowWizardElem.firstStep = true;

    // dump("xmlDocWorkFlowInitPageAdvanced():................End.\n");
}

