/* @(#) $Id: XmlDigitalSigViewer.js,v 1.4 2008/05/01 02:18:11 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


var /* nsIDialogParamBlock */	gParams = null;
var /* DOMParser */		gXmlParser = null;
var /* XMLSerializer */		gXmlSerializer = null;

var /* nsIX509Cert	  */ gCertDB = null;
var /* alrIXPSignTool	  */ gXmlDSigTool = null;

var gXmlDSigInputFilePickerElem;

var alreadyInit = false;

var XPILoadErrorMessage = "Make sure that DLLs (shared libraries) from Apache Xerces-C++ and Xalan-C++ are in your PATH (LD_LIBRARY_PATH) environment variable.";

function xmldsigffext_initOnLoad()
{
    dump("xmldsigffext_initOnLoad():................Start.\n");

    if (alreadyInit) {
    	return;
    }
    alreadyInit = true;

    xmldsigffext_isSupportedOS();

    try {
    	gCertDB = Components.classes["@mozilla.org/security/x509certdb;1"].
			getService(Components.interfaces.nsIX509CertDB);
    	gXmlDSigTool = Components.classes["@avaya.com/pkm/xmldsigtool;1"].
    			getService(Components.interfaces.alrIXPXmlDSigTool);
    } catch (ex) {
    	alert("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool - ex: " + ex + "\n");
    	dump("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool - ex: " + ex + "\n");
	dump(XPILoadErrorMessage + "\n");
	throw ex;
    }
    if (gXmlDSigTool == null) {
    	alert("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool.\n");
    	dump("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool.\n");
	dump(XPILoadErrorMessage + "\n");
    	return;
    }

    gXmlParser = new DOMParser();
    gXmlSerializer = new XMLSerializer();

    try {
    	xmldsigffext_initSigViewerXULElems();

    } catch (ex) {
    	dump("xmldsigffext_initOnLoad(): ex - " + ex + "\n");
    }

    xmldsigffext_initParamsOnLoad();

    dump("xmldsigffext_initOnLoad():................End.\n");
}


function xmldsigffext_initParamsOnLoad()
{
    dump("xmldsigffext_initParamsOnLoad():................Start.\n");

    if ((window.arguments == null) || (window.arguments.length == 0)) {

    	// gXmlDSigInputFilePickerElem.filepath = "/tmp/XMLDSigTool/XXXXXXX.xml";
    	// xmldsigffext_xmlDocFileChangeHandler();

    	return false;
    }

    var xmlDSigInputFileGridElem = document.getElementById("xmldsigffext.sig.viewer.in.file.grid");

    gParams = window.arguments[0].QueryInterface(Components.interfaces.nsIDialogParamBlock);

    if (gParams.objects && (gParams.objects.length > 0)) {
	xmlDSigInputFileGridElem.hidden = true;

	var /* nsIDOMElement */ xmlDocSigElem = null;
	try {
	    xmlDocSigElem = gParams.objects.queryElementAt(0, Components.interfaces.nsIDOMElement);
	} catch (ex) {
    	    return false;
	}
	if (!xmlDocSigElem) {
    	    return false;
	}

	displayXmlSignature(xmlDocSigElem);

    	dump("xmldsigffext_initParamsOnLoad():................End(1).\n");
    	return true;
    }

    var paramCnt = gParams.GetInt(0);
    if (paramCnt <= 0) {
    	return false;
    }
    var signedXMLFilePath = gParams.GetString(0);

    dump("xmldsigffext_initParamsOnLoad(): signedXMLFilePath: " + signedXMLFilePath + " " + "\n");

    if ((signedXMLFilePath.indexOf("http://") == 0) 
	    || (signedXMLFilePath.indexOf("https://") == 0) 
	    || (signedXMLFilePath.indexOf("file://") == 0) 
	    ) {
        var /* nsIDOMDocument */ xmlDoc = gXmlDSigTool.readXMLDocFromURIPath(signedXMLFilePath);
        if (!xmlDoc) {
    	    alert("xmldsigffext_inputXmlDocURIChangeHandler(): Failed to load XML Doc usin the URI: " + signedXMLFilePath + ".\n");
    	    dump("xmldsigffext_inputXmlDocURIChangeHandler(): Failed to load XML Doc usin the URI: " + signedXMLFilePath + ".\n");
    	    return false;
        }

	xmlDSigInputFileGridElem.hidden = true;
	displaySignedXmlDoc(xmlDoc);
    	dump("xmldsigffext_initParamsOnLoad():................End(2).\n");
    	return true;
    }

    xmldsigffext_doOnloadInitViewParam(signedXMLFilePath);

    dump("xmldsigffext_initParamsOnLoad():................End.\n");
    return true;
}

function xmldsigffext_initSigViewerXULElems()
{
    dump("xmldsigffext_initVerifyFormXULElems():................Start.\n");

    gXmlDSigInputFilePickerElem		= document.getElementById("xmldsigffext.sig.viewer.in.filepicker");
    /*
    gXmlDSigSignatureOverlayElem	= document.getElementById("xmldsigffext.sig.viewer.overlay");
    gXmlDSigViewerElem			= document.getElementById("xmldsigffext.form.signature.viewer");
    */

    handleInXMLFilePathChange(gXmlDSigInputFilePickerElem);

    dump("xmldsigffext_initVerifyFormXULElems():................End.\n");
}

function xmldsigffext_doOnloadInitViewParam(aXmlFilePath) 
{
    gXmlDSigInputFilePickerElem.filepath = aXmlFilePath;
    handleInXMLFilePathChange(gXmlDSigInputFilePickerElem);
}

function handleInXMLFilePathChange(aFilePickerElem, ev) 
{
    dump("handleInXMLFilePathChange():................Start.\n");

    if ((aFilePickerElem.value == "") || !aFilePickerElem.file) {
        return;
    }

    var xmlDSigViewerElem = document.getElementById("xmldsigffext.form.signature.viewer");

    var signatureDoc = xmlDSigViewerElem.readXMLDocFromFile(aFilePickerElem.file);
    var xmlDocSignatureElem = signatureDoc.documentElement;
    if (xmlDocSignatureElem.localName != "Signature") {
    	xmlDocSignatureElem = xmlDSigViewerElem.getFirstChildElementByTagName(xmlDocSignatureElem, "Signature");
    }

    try {
    	displayXmlSignature(xmlDocSignatureElem);
    } catch (ex) {
    	dump("handleInXMLFilePathChange(): displayXmlSignature() failed - ex: " + ex + "\n");
	return;
    }

    dump("handleInXMLFilePathChange():................End.\n");
    return;
}

function displaySignedXmlURI(aSignedXmlDocURI) 
{
    var /* nsIDOMDocument */ xmlDoc = gXmlDSigTool.readXMLDocFromURIPath(signedXMLFilePath);
    if (!xmlDoc) {
    }
    displaySignedXmlDoc(xmlDoc);
}

function displaySignedXmlDoc(aSignedXmlDoc) 
{
    displayXmlSignature(aSignedXmlDoc.documentElement);

    /*
    if ((aSignedXmlDoc.documentElement.localName == "Signature") 
    	&& (aSignedXmlDoc.documentElement.namespaceURI == xxxx)) {
    	displayXmlSignature(aSignedXmlDoc.documentElement);
	return;
    }
    var xmlDocSignatureElemList = aSignedXmlDoc.documentElement.getElementsByTagNameNS(xxxx, "Signature"); 
    if (xmlDocSignatureElemList.length <= 0) {
    	return;
    }
    var xmlDocSignatureElem = xmlDocSignatureElemList.item(0);
    if (xmlDocSignatureElem.parentNode != aSignedXmlDoc.documentElement) {
    	return;
    }
    displayXmlSignature(xmlDocSignatureElem);
    */
}

function displayXmlSignature(aXmlDocSignatureElem) 
{
    dump("displayXmlSignature():................Start.\n");

    var xmlDSigViewerElem = document.getElementById("xmldsigffext.form.signature.viewer");

    xmlDSigViewerElem.displayXmlSignature(aXmlDocSignatureElem);

    dump("displayXmlSignature():................End.\n");
}

