/* @(#) $Id: XmlDigitalSignatureForm.js,v 1.11 2008/05/01 02:18:11 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */



var gXmlDSigInputFileIsSignedElem;
var gXmlDSigInputFilePickerElem;
var gXmlDSigResignRowElem;
var gXmlDSigResignElem;

var gXmlDSigSignatureOverlayElem;
var gXmlDSigEditorElem;

var gXmlDSigSignedOutDocGridElem;

var gXmlDSigSignedOutFilePickerRowElem;
var gXmlDSigSignedOutFilePickerElem;
var gXmlDSigSignedOutDocVerifyElem;
var gXmlDSigEnableEncryptRowElem;

// var gXmlParser;
// var gXmlSerializer;

function xmldsigffext_initVerifyFormXULElems()
{
    // dump("xmldsigffext_initVerifyFormXULElems():................Start.\n");

    var xmlDSigSignedOutDocGridElem = document.getElementById("xmldsigffext.form.xmlsig.in.doc.grid"); 
    gXmlDSigInputFilePickerElem		= document.getElementById("xmldsigffext.form.sign.file.in.xmldoc.path");
    gXmlDSigInputFileIsSignedElem	= document.getElementById("xmldsigffext.form.sign.file.in.xmldoc.issigned");
    gXmlDSigResignRowElem		= document.getElementById("xmldsigffext.form.sign.resign.row");
    gXmlDSigResignElem			= document.getElementById("xmldsigffext.form.sign.resign");
    // xmlDSigSignedOutDocGridElem.hidden = false;


    gXmlDSigSignatureOverlayElem	= document.getElementById("xmldsigffext.form.xmlsig.overlay");
    gXmlDSigEditorElem		= document.getElementById("xmldsigffext.form.signature.box");

    gXmlDSigSignedOutDocGridElem 	= document.getElementById("xmldsigffext.form.xmlsig.out.doc.grid"); 

    gXmlDSigSignedOutFilePickerRowElem = document.getElementById("xmldsigffext.form.sign.file.out.xmldoc.row"); 
    gXmlDSigSignedOutFilePickerElem	= document.getElementById("xmldsigffext.form.sign.file.out.xmldoc.path"); 
    gXmlDSigSignedOutDocVerifyElem	= document.getElementById("xmldsigffext.form.sign.file.out.xmldoc.verify"); 

    // gXmlDSigEnableEncryptRowElem 	= document.getElementById("xmldsigffext.form.encrypt.enable.row"); 

    gXmlDSigInputFilePickerElem.addEventListener('command', xmldsigffext_xmlDocFileChangeHandler, false);
    gXmlDSigInputFilePickerElem.addEventListener('change', xmldsigffext_xmlDocFileChangeHandler, false);

    // xmldsigffext_xmlDocFileChangeHandler();
    xmldsigffext_initSignVerifySig();

    // gXmlParser = new DOMParser();
    // gXmlSerializer = new XMLSerializer();


    // dump("xmldsigffext_initVerifyFormXULElems():................End.\n");
}

function xmldsigffext_initSignVerifySig()
{
    gXmlDSigSignatureOverlayElem.hidden = true;
}

function xmldsigffext_doOnloadInitSignParam(/* String */ inXmlFilePath, /* String */ outXmlFilePath, /* nsIX509 */ aSelectedSignerCert)
{
    dump("xmldsigffext_doOnloadInitSignParam():................Start.\n");
    // xmldsigffext_initVerifyFormXULElems();

    dump("inXmlFilePath: " + inXmlFilePath + " " + 
    		"outXmlFilePath: " + outXmlFilePath + " " + 
    		"cert: " + (aSelectedSignerCert?aSelectedSignerCert.nickname:"") + " " + 
		"\n");
    if (inXmlFilePath) {
	if ((inXmlFilePath.indexOf("http://") == 0) 
	    || (inXmlFilePath.indexOf("https://") == 0) 
	    || (inXmlFilePath.indexOf("file://") == 0) 
	    ) {
	    xmldsigffext_inputXmlDocURIChangeHandler(inXmlFilePath);
	    return;
    	}
    }


    if (inXmlFilePath) {
    	gXmlDSigInputFilePickerElem.value = inXmlFilePath;
	gXmlDSigInputFilePickerElem.disabled = true;
    }


    xmldsigffext_xmlDocFileChangeHandler(null);
    if (aSelectedSignerCert) {
    	// xmldsigffext_setUserCredential(aSelectedSignerCert);
    }

    if (outXmlFilePath) {
    	gXmlDSigSignedOutFilePickerElem.value = outXmlFilePath;
	gXmlDSigSignedOutFilePickerElem.disabled = true;
    }
    dump("xmldsigffext_doOnloadInitSignParam():................End.\n");
}

function xmldsigffext_setInputXMLFilePath(xmlFilePath)
{
    gXmlDSigInputFilePickerElem.value = xmlFilePath;
}


function xmldsigffext_enableForUnsignedXmlDoc()
{
    // dump("xmldsigffext_enableForUnsignedXmlDoc():................Start.\n");

    // xmldsigffext_enabledSignedInfo(true);

    gXmlDSigInputFileIsSignedElem.hidden = true;

    // gXmlDSigResignRowElem.hidden = true;
    // gXmlDSigResignElem.checked = false;

    xmldsigffext_enableForSign();

    gXmlDSigSignedOutFilePickerRowElem.hidden = false;
    // gXmlDSigEnableEncryptRowElem.hidden = false;
    gXmlDSigSignedOutDocGridElem.hidden = false;

    // dump("xmldsigffext_enableForUnsignedXmlDoc():................End.\n");
}


function xmldsigffext_enableForSignedXmlDoc()
{
    // dump("xmldsigffext_enableForSignedXmlDoc():................Start.\n");

    gXmlDSigInputFileIsSignedElem.hidden = false;

    gXmlDSigResignRowElem.hidden = false;
    gXmlDSigResignElem.checked = false;

    xmldsigffext_enableForVerify();

    gXmlDSigSignedOutDocGridElem.hidden = true;
    gXmlDSigSignedOutFilePickerRowElem.hidden = true;
    // gXmlDSigEnableEncryptRowElem.hidden = true;

    // dump("xmldsigffext_enableForSignedXmlDoc():................End.\n");
}

function xmldsigffext_displayXmlDoc(aXmlDoc)
{
    // dump("xmldsigffext_displayXmlDoc():................Start.\n");

    gXmlDSigSignatureOverlayElem.hidden = false;
    try {
    	gXmlDSigEditorElem.displayXmlDoc(aXmlDoc);
    } catch (ex) {
    	dump("xmldsigffext_displayXmlDoc(): gXmlDSigEditorElem.displayXmlDoc() failed - ex: " + ex + "\n");
    	alert("xmldsigffext_displayXmlDoc(): failed to create and display XML signature - ex: " + ex + "\n");
    	gXmlDSigSignatureOverlayElem.hidden = true;
	return;
    }


    var isSignedXMLDoc = gXmlDSigEditorElem.isSignedXmlDoc;
    dump("xmldsigffext_displayXmlDoc(): isSignedXMLDoc: " + isSignedXMLDoc + "\n");

    gXmlDSigResignRowElem.hidden = !isSignedXMLDoc;
    if (isSignedXMLDoc) {
    	xmldsigffext_enableForSignedXmlDoc();

    	gXmlDSigResignElem.disabled = false;
	var credentialType = gXmlDSigEditorElem.credentialType;
    	// dump("xmldsigffext_displayXmlDoc(): credentialType: " + credentialType + "\n");
	if ("certificate" == credentialType) {
	    var isUserCert = false;
	    var signerCert = gXmlDSigEditorElem.docSignerCert;
	    if (signerCert) {
	    	isUserCert = gX509CertDBUtil.isUserCert(signerCert);
    	    	// dump("xmldsigffext_displayXmlDoc(): signerCert: " + signerCert.nickname + " isUserCert: " + isUserCert + "\n");
	    }
	    if (!isUserCert) {
    	    	dump("xmldsigffext_displayXmlDoc(): signer cert is does not have private key in CertDB - disabling editing of signature.\n");
    	    	gXmlDSigResignElem.disabled = true;
	    }
	}
	else {
	    gXmlDSigEditorElem.signerSharedKey = "";
	}
    }
    else {
    	xmldsigffext_enableForUnsignedXmlDoc();
    	// gXmlDSigResignRowElem.hidden = true;
	gXmlDSigSignedOutFilePickerElem.value = "";
    }

    // dump("xmldsigffext_displayXmlDoc():................End.\n");
}

function xmldsigffext_xmlDocFileChangeHandler(ev)
{
    // dump("xmldsigffext_xmlDocFileChangeHandler():................Start.\n");


    var xmlDSigInputFilePickerElem = gXmlDSigInputFilePickerElem;
    if (ev) {
    	xmlDSigInputFilePickerElem = ev.currentTarget;
    }
    xmldsigffext_inputXmlDocFileChangeHandler(xmlDSigInputFilePickerElem, ev);
    
    // dump("xmldsigffext_xmlDocFileChangeHandler():................End.\n");
}

function xmldsigffext_inputXmlDocFileChangeHandler(aXmlDSigInputFilePickerElem, ev)
{

    // dump("xmldsigffext_inputXmlDocFileChangeHandler():................Start.\n");
    

    gXmlDSigSignatureOverlayElem.hidden = true;
    gXmlDSigSignedOutDocVerifyElem.hidden = true;

    var signedXmlFile = gXmlDSigInputFilePickerElem.file;
    if (signedXmlFile == null) {
    	alert("xmldsigffext_inputXmlDocFileChangeHandler(): signed XML file name is missing.\n");
    	dump("xmldsigffext_inputXmlDocFileChangeHandler(): signed XML file name is missing.\n");
    	return;
    }
    if (signedXmlFile.fileSize == 0) {
    	alert("xmldsigffext_inputXmlDocFileChangeHandler(): Zero-length XML file - pick another one.\n");
    	dump("xmldsigffext_inputXmlDocFileChangeHandler(): Zero-length XML file - pick another one.\n");
    	return;
    }
    dump("xmldsigffext_inputXmlDocFileChangeHandler(): inXmlFilePath: " + gXmlDSigInputFilePickerElem.filepath + "\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var /* nsIDOMDocument */ xmlDoc = gXmlDSigTool.readXMLDocFromFile(signedXmlFile);
    if (!xmlDoc) {
    	alert("xmldsigffext_inputXmlDocFileChangeHandler(): Not a valid XML file.\n");
    	dump("xmldsigffext_inputXmlDocFileChangeHandler(): Not a valid XML file.\n");
    	return;
    }
    if (xmlDoc.documentElement.tagName == "parsererror") {
    	alert("xmldsigffext_inputXmlDocFileChangeHandler(): Parsing of  XML file failed.\n");
    	dump("xmldsigffext_inputXmlDocFileChangeHandler(): Parsing of  XML file failed.\n");
    	return;
    }
    gXmlDSigInputFilePickerElem.xmlDoc = xmlDoc;

    xmldsigffext_displayXmlDoc(gXmlDSigInputFilePickerElem.xmlDoc);

    // dump("xmldsigffext_inputXmlDocFileChangeHandler():................End.\n");
}

function xmldsigffext_inputXmlDocURIChangeHandler(aXmlDSigInputURISpec, ev)
{
    var /* nsIDOMDocument */ xmlDoc = gXmlDSigTool.readXMLDocFromURIPath(aXmlDSigInputURISpec);
    if (!xmlDoc) {
    	alert("xmldsigffext_inputXmlDocURIChangeHandler(): Failed to load XML Doc usin the URI: " + aXmlDSigInputURISpec + ".\n");
    	dump("xmldsigffext_inputXmlDocURIChangeHandler(): Failed to load XML Doc usin the URI: " + aXmlDSigInputURISpec + ".\n");
    	return;
    }
    var xmlDSigSignedOutDocGridElem = document.getElementById("xmldsigffext.form.xmlsig.in.doc.grid"); 
    xmlDSigSignedOutDocGridElem.hidden = true;

    xmldsigffext_displayXmlDoc(xmlDoc);
}

function xmldsigffext_handleModifySignature(modifySigCheckBoxElem)
{
    // dump("xmldsigffext_handleModifySignature():................End.\n");

    if (modifySigCheckBoxElem.checked) {
	gXmlDSigEditorElem.enableModifySignature(modifySigCheckBoxElem.checked);
	gXmlDSigSignedOutFilePickerElem.value = "";
    	xmldsigffext_enableForUnsignedXmlDoc();
    }
    else {
    	xmldsigffext_displayXmlDoc(gXmlDSigInputFilePickerElem.xmlDoc);
    	xmldsigffext_enableForSignedXmlDoc();
    }
    // dump("xmldsigffext_handleModifySignature():................End.\n");
}


function xmldsigffext_autoSelectOutSignedFile(/* nsILocalFile */ inputXMLFile)
{
    var outSignedFileName = null;

    outSignedFileName = "TmpXMLFile.xml";
    if (inputXMLFile) {
    	outSignedFileName = inputXMLFile.leafName;
    }
    if (outSignedFileName.indexOf("_SIGNATURE") < 0) {
    	outSignedFileName =
			(gXmlDSigEditorElem.signerAlias?gXmlDSigEditorElem.signerAlias:"UserX") + 
			/*
			"_" + gXmlDSigEditorElem.credentialType + 
			*/
			"_" + gXmlDSigEditorElem.signerKeyType + 
			"_" + gXmlDSigEditorElem.signatureType + 
			"_" + gXmlDSigEditorElem.canonicalizationMethodName + 
			"_" + inputXMLFile.leafName + 
			"";
    	// dump("xmldsigffext_autoSelectOutSignedFile(): outSignedFileName: " + outSignedFileName + "\n");
    }
    
    return xmldsigffext_autoSelectOutFile(gXmlDSigSignedOutFilePickerElem, outSignedFileName);
}


/* nsIDOMDocument  */
function xmldsigffext_signXMLDocWithSharedKey(/* nsIDOMDocument  */ xmlDoc, /* nsIPersistentProperties */ xmlSignatureProps)
{
    // dump("xmldsigffext_signXMLDocWithSharedKey():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var outSignedXmlDoc = null;
    try {
    	outSignedXmlDoc = gXmlDSigTool.signXMLDocBySharedKey(xmlDoc, xmlSignatureProps);
    } catch (ex) {
    	// alert("xmldsigffext_signXMLFileWithSharedKey(): failed to create signed XML file - ex : " + ex + "\n");
    	dump("xmldsigffext_signXMLDocWithSharedKey(): failed to create signed XML file - ex : " + ex + "\n");
	throw ex;
    }

    // dump("xmldsigffext_signXMLDocWithSharedKey():................End.\n");

    return outSignedXmlDoc;

}


/* nsIDOMDocument  */
function xmldsigffext_signXMLDocWithCert(/* nsIDOMDocument  */ xmlDoc, /* nsIX509Cert */ signerCert, /* nsIPersistentProperties */ xmlSignatureProps)
{
    // dump("xmldsigffext_signXMLDocWithCert():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var outSignedXmlDoc = null;
    try {
    	// Force token login - on windows the popup window for password is not coming up
    	xmldsigffext_loginToCertToken(signerCert);
    	outSignedXmlDoc = gXmlDSigTool.signXMLDocByX509Cert(xmlDoc, signerCert, xmlSignatureProps);
    } catch (ex) {
    	alert("xmldsigffext_signXMLDocWithCert(): failed to sign XML file - ex : " + ex + "\n");
    	dump("xmldsigffext_signXMLDocWithCert(): failed to sign XML file - ex : " + ex + "\n");
	throw ex;
    }

    // dump("xmldsigffext_signXMLDocWithCert():................End.\n");

    return outSignedXmlDoc;
}


/* nsIDOMDocument */
function xmldsigffext_signXMLDoc()
{
    dump("xmldsigffext_signXMLDoc():................Start.\n");

    var signedXmlDoc = null;

    var xmlDoc = gXmlDSigInputFilePickerElem.xmlDoc;
    var xmlDocWithSigTransforms = gXmlDSigEditorElem.getXmlDocWithSigTransforms();
    if (!xmlDocWithSigTransforms) {
	dump("xmldsigffext_signXMLDoc(): getXmlDocWithSigTransforms() failed - NULL XML doc.\n");
    	return null;
    }
    var /* nsIPersistentProperties */ xmlSignatureProps = gXmlDSigEditorElem.getSignatureProperties();

    /*
    var signedXmlDocStr = gXmlSerializer.serializeToString(xmlDocWithSigTransforms);
    dump("xmldsigffext_signXMLDoc(): signedXmlDocStr: \n" + signedXmlDocStr + "\n");

    gXmlDSigEditorElem.dumpProperties(xmlSignatureProps, "Signing Props:");
    */

    // var credentialType = xmldsigffext_getUserCredentialType();
    var credentialType = gXmlDSigEditorElem.credentialType;
    if (credentialType == "certificate") {
        var /* nsIX509Cert */ signerCert;
        signerCert = gXmlDSigEditorElem.signerCert;
        if (signerCert == null) {
    	    dump("xmldsigffext_signXMLDoc(): null signerCert - you must choose a signer certificate.\n");
    	    alert("xmldsigffext_signXMLDoc(): null signerCert - you must choose a signer certificate.\n");
    	    return null;
        }
    	signedXmlDoc = xmldsigffext_signXMLDocWithCert(xmlDocWithSigTransforms, signerCert, xmlSignatureProps);
    }
    else if (credentialType == "password") {
    	var sharedKey = gXmlDSigEditorElem.signerSharedKey;
        if (sharedKey.length == 0) {
    	    alert("xmldsigffext_signXMLDoc(): shared key is missing.\n");
    	    dump("xmldsigffext_signXMLDoc(): shared key is missing.\n");
    	    return null;
        }
    	signedXmlDoc = xmldsigffext_signXMLDocWithSharedKey(xmlDocWithSigTransforms, xmlSignatureProps);
    }
    else {
    	signedXmlDoc = null;
    }
    if (!signedXmlDoc) {
    	return null;
    }

    dump("xmldsigffext_signXMLDoc():................End.\n");
    return signedXmlDoc;
}

/* nsIDOMDocument */
function xmldsigffext_signXMLDocToFile()
{
    // dump("xmldsigffext_signXMLDocToFile():................Start.\n");

    // Select path to the signed XML File 
    var /* nsILocalFile */ outSignedXmlDocFile = null;
    if (gXmlDSigSignedOutFilePickerElem.value == "") {
	xmldsigffext_autoSelectOutSignedFile(gXmlDSigInputFilePickerElem.file);
    }
    outSignedXmlDocFile = gXmlDSigSignedOutFilePickerElem.file;
    if (outSignedXmlDocFile == null) {
    	dump("xmldsigffext_signXMLDocToFile(): failed to get outSignedXmlDocFile.\n");
        return signedXmlDoc;
    }
    // dump("xmldsigffext_signXMLDocToFile(): outSignedXmlDocFile: " + outSignedXmlDocFile.path + "\n");


    // Create signed XML doc 
    var /* nsIDOMDocument */ signedXmlDoc = null;
    signedXmlDoc = xmldsigffext_signXMLDoc();
    if (!signedXmlDoc) {
    	return null;
    }

    // Save signed XML doc 

    var signedXmlDocStr = gXmlSerializer.serializeToString(signedXmlDoc);
    gXmlDSigSignedOutFilePickerElem.saveFile(signedXmlDocStr);
    gXmlDSigSignedOutFilePickerElem.refresh();

    gXmlDSigSignedOutDocVerifyElem.hidden = false;

    // dump("xmldsigffext_signXMLDocToFile():................End.\n");
    return signedXmlDoc;
}

function xmldsigffext_verifySignedXMLDocWithSharedKey(signedXmlDoc, xmlSignatureProps)
{
    dump("xmldsigffext_verifySignedXMLDocWithSharedKey():................Start.\n");

    var sharedKey = gXmlDSigEditorElem.signerSharedKey;
    if (!sharedKey || (sharedKey == "")) {
	sharedKey = propmptAndGetPassword(
		"Enter the Signing Key",
		"This document is signed with symmetric key - enter the key used to sign the document"
		)
	if (!sharedKey || (sharedKey == "")) { 
	    // alert("Password is missing - enter a password.");
    	    return false;
	}
	gXmlDSigEditorElem.signerSharedKey = sharedKey;
    }
    /*
    if (sharedKey == "") {
	alert("Password is missing - enter a password.");
    	return false;
    }
    */

    var isPassed = false;
    try {
    	isPassed = gXmlDSigTool.verifySignedXMLDocBySharedKey(
                        signedXmlDoc,
			sharedKey,
			xmlSignatureProps
                        );
    } catch (ex) {
    	dump("xmldsigffext_verifySignedXMLDocWithSharedKey(): failed to verify signed archive file - ex : " + ex + "\n");
	throw ex;
    }

    dump("xmldsigffext_verifySignedXMLDocWithSharedKey():................End.\n");
    return isPassed;
}


function xmldsigffext_verifySignedXMLDocByX509Cert(signedXmlDoc, xmlSignatureProps)
{
    // dump("xmldsigffext_verifySignedXMLDocByX509Cert():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var /* nsIX509Cert */ docSignerCert = null;
    var signerCertObj = new Object();
    var isPassed = false;
    try {
    	docSignerCert = gXmlDSigEditorElem.docSignerCert;
    	// dump("xmldsigffext_verifySignedXMLDocByX509Cert(): docSignerCert: " + docSignerCert + "\n");
	if (docSignerCert) {
    	dump("xmldsigffext_verifySignedXMLDocByX509Cert(): docSignerCert: " + docSignerCert.nickname + "\n");
	}
	signerCertObj.value = gXmlDSigEditorElem.docSignerCert;
    	isPassed = gXmlDSigTool.verifySignedXMLDocByX509Cert(
                        signedXmlDoc,
			signerCertObj,
			xmlSignatureProps
                        );
    } catch (ex) {
    	dump("xmldsigffext_verifySignedXMLDocByX509Cert(): failed to verify signed archive file - ex : " + ex + "\n");
	isPassed = false;
	// throw ex;
    }
    /*
    if (!docSignerCert) {
	docSignerCert = signerCertObj.value;
    	dump("xmldsigffext_verifySignedXMLDocByX509Cert(): signerCertObj.value: " + signerCertObj.value + "\n");
	if (docSignerCert) {
    	    gXmlDSigEditorElem.docSignerCert = docSignerCert;
    	    xmldsigffext_showXmlDocSignerCert(signerCertObj.value);
    	    dump("xmldsigffext_verifySignedXMLDocByX509Cert():x509Cert.dbKey: " + signerCertObj.value.dbKey + "\n");
	}
    }
    */

    // dump("xmldsigffext_verifySignedXMLDocByX509Cert():................End.\n");
    return isPassed;
}

function xmldsigffext_verifySignedXMLDoc()
{
    // dump("xmldsigffext_verifySignedXMLDoc():................Start.\n");

    var /* nsIPersistentProperties */ xmlSignatureProps = gXmlDSigEditorElem.getSignatureProperties();
    var /* nsIDOMDocument */ signedXmlDoc = gXmlDSigInputFilePickerElem.xmlDoc;

    var isPassed = false;
    var credentialType = gXmlDSigEditorElem.credentialType;
    if (credentialType == "certificate") {
    	isPassed = xmldsigffext_verifySignedXMLDocByX509Cert(signedXmlDoc, xmlSignatureProps);
    }
    else {
    	isPassed = xmldsigffext_verifySignedXMLDocWithSharedKey(signedXmlDoc, xmlSignatureProps);
    }

    var errorMessage = null;
    if (!isPassed) {
	try {
	    var propKey = "errorMessage";
	    errorMessage = xmlSignatureProps.getStringProperty(propKey);
	} catch(ex) { }
	if (errorMessage) {
	    alert("XML Signature verification failed - " + errorMessage + "\n");
	}
    }
    // dump("xmldsigffext_verifySignedXMLDoc():................End.\n");
    return isPassed;
}



function xmldsigffext_signXMLFileWithSharedKey(/* nsIPersistentProperties */ xmlSignatureProps)
{
    // dump("xmldsigffext_signXMLFileWithSharedKey():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var /* nsILocalFile */ inputXMLFile = gXmlDSigInputFilePickerElem.file;
    if (inputXMLFile == null) {
    	dump("xmldsigffext_signXMLFileWithSharedKey(): No input XML file is selected.\n");
    	return null;
    }

    var /* nsILocalFile */ outSignedXMLFile = gXmlDSigSignedOutFilePickerElem.file;
    if (outSignedXMLFile == null) {
    	dump("xmldsigffext_signXMLFileWithSharedKey(): failed to get outSignedXMLFile.\n");
        return null;
    }

    try {
    	gXmlDSigTool.signXMLFileBySharedKey(inputXMLFile, xmlSignatureProps, outSignedXMLFile);
    } catch (ex) {
    	// alert("xmldsigffext_signXMLFileWithSharedKey(): failed to create signed XML file - ex : " + ex + "\n");
    	dump("xmldsigffext_signXMLFileWithSharedKey(): failed to create signed XML file - ex : " + ex + "\n");
	throw ex;
    }

    // dump("xmldsigffext_signXMLFileWithSharedKey():................End.\n");

    return outSignedXMLFile;
}

function xmldsigffext_signXMLFileWithCert(/* nsIPersistentProperties */ xmlSignatureProps)
{
    // dump("xmldsigffext_signXMLFileWithCert():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
    netscape.security.PrivilegeManager.enablePrivilege("UniversalFileRead");

    var /* nsIX509Cert */ signerCert;
    signerCert = gXmlDSigEditorElem.signerCert;
    if (signerCert == null) {
    	alert("xmldsigffext_signXMLFileWithCert(): null signer certificate - you must choose a signer certificate.");
    	dump("xmldsigffext_signXMLFileWithCert(): null signer certificate - you must choose a signer certificate.\n");
    	return null;
    }

    var /* nsILocalFile */ inputXMLFile = gXmlDSigInputFilePickerElem.file;
    if (inputXMLFile == null) {
    	dump("xmldsigffext_signXMLFileWithCert(): No input XML file is selected.\n");
    	return null;
    }

    var /* nsILocalFile */ outSignedXMLFile = gXmlDSigSignedOutFilePickerElem.file;
    if (outSignedXMLFile == null) {
    	dump("xmldsigffext_signXMLFileWithCert(): failed to get outSignedXMLFile.\n");
        return null;
    }

    try {
    	// Force token login - on windows the popup window for password is not coming up
    	xmldsigffext_loginToCertToken(signerCert);

    	// dumpProperties(xmlSignatureProps, "xmldsigffext_signXMLFileWithCert(): xmlSignatureParams:");
    	gXmlDSigTool.signXMLFileByX509Cert(inputXMLFile, signerCert, xmlSignatureProps, outSignedXMLFile);
    } catch (ex) {
    	// alert("xmldsigffext_signXMLFileWithCert(): failed to create signed XML file - ex : " + ex + "\n");
    	dump("xmldsigffext_signXMLFileWithCert(): failed to create signed XML file - ex : " + ex + "\n");
	throw ex;
    }

    // dump("xmldsigffext_signXMLFileWithCert():................End.\n");

    return outSignedXMLFile;
}

function xmldsigffext_signXMLFile()
{
    dump("xmldsigffext_signXMLFile():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
    netscape.security.PrivilegeManager.enablePrivilege("UniversalFileRead");

    var /* nsIPersistentProperties */ xmlSignatureProps = gXmlDSigEditorElem.getSignatureProperties();
    var /* nsIPersistentProperties */ xmlSigProps = Components.classes["@mozilla.org/persistent-properties;1"].
                    createInstance(Components.interfaces.nsIPersistentProperties);

    var /* nsILocalFile */ inputXMLFile = gXmlDSigInputFilePickerElem.file;
    if (inputXMLFile == null) {
    	dump("xmldsigffext_signXMLFile(): No input XML file is selected.\n");
    	alert("xmldsigffext_signXMLFile(): No input XML file is selected.\n");
    	return null;
    }

    var /* nsILocalFile */ outSignedXMLFile = null;
    if (gXmlDSigSignedOutFilePickerElem.value == "") {
	xmldsigffext_autoSelectOutSignedFile(inputXMLFile);
    }
    outSignedXMLFile = gXmlDSigSignedOutFilePickerElem.file;
    if (outSignedXMLFile == null) {
    	dump("xmldsigffext_signXMLFile(): failed to get outSignedXMLFile.\n");
    	alert("xmldsigffext_signXMLFile(): failed to get outSignedXMLFile.\n");
        return null;
    }
    dump("xmldsigffext_signXMLFile(): outSignedXMLFile: " + outSignedXMLFile.path + "\n");


    // var credentialType = xmldsigffext_getUserCredentialType();
    var credentialType = gXmlDSigEditorElem.credentialType;
    if (credentialType == "certificate") {
    	outSignedXMLFile = xmldsigffext_signXMLFileWithCert(xmlSignatureProps);
    }
    else if (credentialType == "password") {
    	var sharedKey = gXmlDSigEditorElem.signerSharedKey;
        if (sharedKey.length == 0) {
    	    alert("xmldsigffext_signXMLFileWithSharedKey(): shared key is missing.\n");
    	    dump("xmldsigffext_signXMLFileWithSharedKey(): shared key is missing.\n");
    	    return null;
        }
    	outSignedXMLFile = xmldsigffext_signXMLFileWithSharedKey(xmlSignatureProps);
    }
    else {
    	outSignedXMLFile = null;
    }

    if (!outSignedXMLFile) {
    	dump("xmldsigffext_signXMLFile(): failed to sign input XML file.\n");
	return null;
    }

    gXmlDSigSignedOutFilePickerElem.refresh();
    outSignedXMLFile = gXmlDSigSignedOutFilePickerElem.file;
    if (!outSignedXMLFile || !outSignedXMLFile.exists() || (outSignedXMLFile.fileSize <= 0)) {
    	dump("xmldsigffext_signXMLFile(): failed to create Signed XML file.\n");
    	// alert("xmldsigffext_signXMLFile(): failed to create Signed XML file.\n");
	return null;
    }

    dump("xmldsigffext_signXMLFile():................End.\n");

    return gXmlDSigSignedOutFilePickerElem.file;
}

function propmptAndGetPassword(aPromptWinTitle, aPromptMsg)
{
    var checkStateMsg = null;
    var checkStateObj = new Object();
    checkStateObj.value = null;
    var passwordObj = new Object();
    passwordObj.value = null;

    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService();
    promptService = promptService.QueryInterface(Components.interfaces.nsIPromptService);
    var dialogOk = promptService.promptPassword(
			window,
			aPromptWinTitle,
			aPromptMsg,
			passwordObj,
			checkStateMsg,
			checkStateObj
		     	);
    if (!dialogOk) {
	return null;
    }
    return passwordObj.value;
}

function xmldsigffext_verifySignedXMLFileWithSharedKey(xmlSignatureProps)
{
    dump("xmldsigffext_verifySignedXMLFileWithSharedKey():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var signedXmlFile = gXmlDSigInputFilePickerElem.file;

    var sharedKey = gXmlDSigEditorElem.signerSharedKey;
    if (sharedKey == "") {
	var promptWinTitle = "Enter the Signing Key";
	var promptMsg = "This document is signed with symmetric key - enter the key used to sign the document"
	sharedKey = propmptAndGetPassword( promptWinTitle, promptMsg)
	if (!sharedKey || (sharedKey == "")) { 
	    // alert("Password is missing - enter a password.");
    	    return false;
	}
	gXmlDSigEditorElem.signerSharedKey = sharedKey;
    }

    var isPassed = false;
    try {
    	/*
        boolean verifySignedXMLFileByX509Cert(
	    	in nsILocalFile aSignedXmlFile,
		in AString sharedKey,
		in nsIPersistentProperties aSignatureProps
		);
	*/
    	isPassed = gXmlDSigTool.verifySignedXMLFileBySharedKey(
                        signedXmlFile,
			sharedKey,
			xmlSignatureProps
                        );
    } catch (ex) {
    	dump("xmldsigffext_verifySignedXMLFileWithSharedKey to verify signed XML file - ex : " + ex + "\n");
	throw ex;
    }

    dump("xmldsigffext_verifySignedXMLFileWithSharedKey():................Start.\n");
    return isPassed;
}

function xmldsigffext_verifySignedXMLFileWithX509Cert(xmlSignatureProps)
{
    dump("xmldsigffext_verifySignedXMLFileWithX509Cert():................Start.\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');

    var signedXmlFile = gXmlDSigInputFilePickerElem.file;

    var /* nsIX509Cert */ docSignerCert = null;
    var signerCertObj = new Object();
    var isPassed = false;
    try {
    	docSignerCert = gXmlDSigEditorElem.docSignerCert;
	if (docSignerCert) {
    	dump("xmldsigffext_verifySignedXMLFileWithX509Cert(): docSignerCert: " + docSignerCert.nickname + "\n");
	}
	signerCertObj.value = gXmlDSigEditorElem.docSignerCert;
    	isPassed = gXmlDSigTool.verifySignedXMLFileByX509Cert(
                        signedXmlFile,
			signerCertObj,
			xmlSignatureProps
                        );
    } catch (ex) {
    	dump("xmldsigffext_verifySignedXMLFileWithX509Cert(): failed to verify signed XML file - ex : " + ex + "\n");
	throw ex;
    }
    /*
    if (!signerCert) {
    	// gXmlDSigDocSignerCertElem.cert = signerCertObj.value;
    	if (signerCertObj.value) {
    	    xmldsigffext_showXmlDocSignerCert(signerCertObj.value);
    	    dump("xmldsigffext_verifySignedXMLFileWithX509Cert():x509Cert.dbKey: " + signerCertObj.value.dbKey + "\n");
    	}
    }
    */

    dump("xmldsigffext_verifySignedXMLFileWithX509Cert():................End.\n");
    return isPassed;
}

function xmldsigffext_verifySignedXMLFile()
{
    dump("xmldsigffext_verifySignedXMLFile():................Start.\n");

    var /* nsIPersistentProperties */ xmlSigProps = gXmlDSigEditorElem.getSignatureProperties();

    var isPassed = false;
    var credentialType = gXmlDSigEditorElem.credentialType;
    if (credentialType.value == "certificate") {
    	isPassed = xmldsigffext_verifySignedXMLFileWithX509Cert(xmlSignatureProps);
    }
    else {
    	isPassed = xmldsigffext_verifySignedXMLFileWithSharedKey(xmlSignatureProps);
    }

    dump("xmldsigffext_verifySignedXMLFile():................End.\n");
    return isPassed;
}


function xmldsigffext_loadAndVerifySignedDoc()
{
    xmldsigffext_setInputXMLFilePath(gXmlDSigSignedOutFilePickerElem.value);
    gXmlDSigSignedOutFilePickerElem.value = "";
    xmldsigffext_xmlDocFileChangeHandler();
}

